{-# LANGUAGE EmptyDataDecls, RankNTypes, ScopedTypeVariables #-}

module
  FOR(Nat, Ceq, Set_impl, Ccompare, Set, nat_of_integer, Fset, Term(..),
       Terma(..), Ftrs(..), Pos_step(..), Ext_step(..), Gtt_rel(..),
       Rr1_rel(..), Rr2_rel(..), Formula(..), Info(..), Claim(..),
       Equivalence(..), Inference(..), Certificate(..), fset_of_list, r2Eq,
       fTrue, r1Fin, fFalse, gSteps, r2Join, r2Meet, r2Step, r2Reflc, r2Steps,
       r2StepEq, fRestrict, r2ParStep, r2StepsEq, r2StepsNF, r2RootStep,
       r2RootSteps, r2RootStepEq, r2NonRootStep, r2RootStepsEq, r2NonRootSteps,
       r2NonRootStepEq, r2NonRootStepsEq, check_certificate_string)
  where {

import Prelude ((==), (/=), (<), (<=), (>=), (>), (+), (-), (*), (/), (**),
  (>>=), (>>), (=<<), (&&), (||), (^), (^^), (.), ($), ($!), (++), (!!), Eq,
  error, id, return, not, fst, snd, map, filter, concat, concatMap, reverse,
  zip, null, takeWhile, dropWhile, all, any, Integer, negate, abs, divMod,
  String, Bool(True, False), Maybe(Nothing, Just));
import qualified Prelude;
import qualified Uint;
import qualified Array;
import qualified Uint32;
import qualified Data_Bits;

newtype Nat = Nat Integer;

integer_of_nat :: Nat -> Integer;
integer_of_nat (Nat x) = x;

equal_nat :: Nat -> Nat -> Bool;
equal_nat m n = integer_of_nat m == integer_of_nat n;

instance Eq Nat where {
  a == b = equal_nat a b;
};

zero_nat :: Nat;
zero_nat = Nat (0 :: Integer);

class Zero a where {
  zero :: a;
};

instance Zero Nat where {
  zero = zero_nat;
};

less_eq_nat :: Nat -> Nat -> Bool;
less_eq_nat m n = integer_of_nat m <= integer_of_nat n;

class Ord a where {
  less_eq :: a -> a -> Bool;
  less :: a -> a -> Bool;
};

less_nat :: Nat -> Nat -> Bool;
less_nat m n = integer_of_nat m < integer_of_nat n;

instance Ord Nat where {
  less_eq = less_eq_nat;
  less = less_nat;
};

data Ordera = Eqa | Lt | Gt;

class (Ord a) => Preorder a where {
};

class (Preorder a) => Order a where {
};

class (Order a) => Linorder a where {
};

comparator_of :: forall a. (Eq a, Linorder a) => a -> a -> Ordera;
comparator_of x y = (if less x y then Lt else (if x == y then Eqa else Gt));

instance Preorder Nat where {
};

instance Order Nat where {
};

instance Linorder Nat where {
};

compare_nat :: Nat -> Nat -> Ordera;
compare_nat = comparator_of;

class Compare a where {
  compare :: a -> a -> Ordera;
};

instance Compare Nat where {
  compare = compare_nat;
};

ceq_nat :: Maybe (Nat -> Nat -> Bool);
ceq_nat = Just equal_nat;

class Ceq a where {
  ceq :: Maybe (a -> a -> Bool);
};

instance Ceq Nat where {
  ceq = ceq_nat;
};

newtype Phantom a b = Phantom b;

data Set_impla = Set_Choose | Set_Collect | Set_DList | Set_RBT | Set_Monada;

set_impl_nat :: Phantom Nat Set_impla;
set_impl_nat = Phantom Set_RBT;

class Set_impl a where {
  set_impl :: Phantom a Set_impla;
};

instance Set_impl Nat where {
  set_impl = set_impl_nat;
};

finite_UNIV_nat :: Phantom Nat Bool;
finite_UNIV_nat = Phantom False;

card_UNIV_nat :: Phantom Nat Nat;
card_UNIV_nat = Phantom zero_nat;

class Finite_UNIV a where {
  finite_UNIV :: Phantom a Bool;
};

class (Finite_UNIV a) => Card_UNIV a where {
  card_UNIV :: Phantom a Nat;
};

instance Finite_UNIV Nat where {
  finite_UNIV = finite_UNIV_nat;
};

instance Card_UNIV Nat where {
  card_UNIV = card_UNIV_nat;
};

cEnum_nat :: Maybe ([Nat], ((Nat -> Bool) -> Bool, (Nat -> Bool) -> Bool));
cEnum_nat = Nothing;

class Cenum a where {
  cEnum :: Maybe ([a], ((a -> Bool) -> Bool, (a -> Bool) -> Bool));
};

instance Cenum Nat where {
  cEnum = cEnum_nat;
};

ccompare_nat :: Maybe (Nat -> Nat -> Ordera);
ccompare_nat = Just compare_nat;

class Ccompare a where {
  ccompare :: Maybe (a -> a -> Ordera);
};

instance Ccompare Nat where {
  ccompare = ccompare_nat;
};

max :: forall a. (Ord a) => a -> a -> a;
max a b = (if less_eq a b then b else a);

instance Ord Integer where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

minus_nat :: Nat -> Nat -> Nat;
minus_nat m n = Nat (max (0 :: Integer) (integer_of_nat m - integer_of_nat n));

data Num = One | Bit0 Num | Bit1 Num;

one_nat :: Nat;
one_nat = Nat (1 :: Integer);

proper_interval_nat :: Maybe Nat -> Maybe Nat -> Bool;
proper_interval_nat no Nothing = True;
proper_interval_nat Nothing (Just x) = less_nat zero_nat x;
proper_interval_nat (Just x) (Just y) = less_nat one_nat (minus_nat y x);

cproper_interval_nat :: Maybe Nat -> Maybe Nat -> Bool;
cproper_interval_nat = proper_interval_nat;

class (Ccompare a) => Cproper_interval a where {
  cproper_interval :: Maybe a -> Maybe a -> Bool;
};

instance Cproper_interval Nat where {
  cproper_interval = cproper_interval_nat;
};

newtype Set_dlist a = Abs_dlist [a];

list_of_dlist :: forall a. (Ceq a) => Set_dlist a -> [a];
list_of_dlist (Abs_dlist x) = x;

list_member :: forall a. (a -> a -> Bool) -> [a] -> a -> Bool;
list_member equal (x : xs) y = equal x y || list_member equal xs y;
list_member equal [] y = False;

data Color = R | B;

data Rbt a b = Empty | Branch Color (Rbt a b) a b (Rbt a b);

newtype Mapping_rbt b a = Mapping_RBT (Rbt b a);

data Set a = Collect_set (a -> Bool) | DList_set (Set_dlist a)
  | RBT_set (Mapping_rbt a ()) | Set_Monad [a] | Complement (Set a);

uminus_set :: forall a. Set a -> Set a;
uminus_set (Complement b) = b;
uminus_set (Collect_set p) = Collect_set (\ x -> not (p x));
uminus_set a = Complement a;

balance :: forall a b. Rbt a b -> a -> b -> Rbt a b -> Rbt a b;
balance (Branch R a w x b) s t (Branch R c y z d) =
  Branch R (Branch B a w x b) s t (Branch B c y z d);
balance (Branch R (Branch R a w x b) s t c) y z Empty =
  Branch R (Branch B a w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch R a w x b) s t c) y z (Branch B va vb vc vd) =
  Branch R (Branch B a w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R Empty w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch B va vb vc vd) w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch R Empty w x (Branch R b s t c)) y z (Branch B va vb vc vd) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R (Branch B ve vf vg vh) w x (Branch R b s t c)) y z
  (Branch B va vb vc vd) =
  Branch R (Branch B (Branch B ve vf vg vh) w x b) s t
    (Branch B c y z (Branch B va vb vc vd));
balance Empty w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z d);
balance (Branch B va vb vc vd) w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z d);
balance Empty w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance Empty w x (Branch R (Branch R b s t c) y z (Branch B va vb vc vd)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch B va vb vc vd) w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch B va vb vc vd) w x
  (Branch R (Branch R b s t c) y z (Branch B ve vf vg vh)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t
    (Branch B c y z (Branch B ve vf vg vh));
balance Empty s t Empty = Branch B Empty s t Empty;
balance Empty s t (Branch B va vb vc vd) =
  Branch B Empty s t (Branch B va vb vc vd);
balance Empty s t (Branch v Empty vb vc Empty) =
  Branch B Empty s t (Branch v Empty vb vc Empty);
balance Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty) =
  Branch B Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty);
balance Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi)) =
  Branch B Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi));
balance Empty s t (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi))
  = Branch B Empty s t
      (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi));
balance (Branch B va vb vc vd) s t Empty =
  Branch B (Branch B va vb vc vd) s t Empty;
balance (Branch B va vb vc vd) s t (Branch B ve vf vg vh) =
  Branch B (Branch B va vb vc vd) s t (Branch B ve vf vg vh);
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty) =
  Branch B (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v (Branch B vi vj vk vl) vf vg Empty)
  = Branch B (Branch B va vb vc vd) s t
      (Branch v (Branch B vi vj vk vl) vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg (Branch B vj vk vl vm))
  = Branch B (Branch B va vb vc vd) s t
      (Branch v Empty vf vg (Branch B vj vk vl vm));
balance (Branch B va vb vc vd) s t
  (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm)) =
  Branch B (Branch B va vb vc vd) s t
    (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm));
balance (Branch v Empty vb vc Empty) s t Empty =
  Branch B (Branch v Empty vb vc Empty) s t Empty;
balance (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty =
  Branch B (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty =
  Branch B (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t Empty
  = Branch B (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t
      Empty;
balance (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd) =
  Branch B (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd);
balance (Branch v Empty vf vg (Branch B vi vj vk vl)) s t (Branch B va vb vc vd)
  = Branch B (Branch v Empty vf vg (Branch B vi vj vk vl)) s t
      (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg Empty) s t (Branch B va vb vc vd)
  = Branch B (Branch v (Branch B vj vk vl vm) vf vg Empty) s t
      (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
  (Branch B va vb vc vd) =
  Branch B (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
    (Branch B va vb vc vd);

rbt_comp_ins ::
  forall a b.
    (a -> a -> Ordera) -> (a -> b -> b -> b) -> a -> b -> Rbt a b -> Rbt a b;
rbt_comp_ins c f k v Empty = Branch R Empty k v Empty;
rbt_comp_ins c f k v (Branch B l x y r) =
  (case c k x of {
    Eqa -> Branch B l x (f k y v) r;
    Lt -> balance (rbt_comp_ins c f k v l) x y r;
    Gt -> balance l x y (rbt_comp_ins c f k v r);
  });
rbt_comp_ins c f k v (Branch R l x y r) =
  (case c k x of {
    Eqa -> Branch R l x (f k y v) r;
    Lt -> Branch R (rbt_comp_ins c f k v l) x y r;
    Gt -> Branch R l x y (rbt_comp_ins c f k v r);
  });

paint :: forall a b. Color -> Rbt a b -> Rbt a b;
paint c Empty = Empty;
paint c (Branch uu l k v r) = Branch c l k v r;

rbt_comp_insert_with_key ::
  forall a b.
    (a -> a -> Ordera) -> (a -> b -> b -> b) -> a -> b -> Rbt a b -> Rbt a b;
rbt_comp_insert_with_key c f k v t = paint B (rbt_comp_ins c f k v t);

rbt_comp_insert ::
  forall a b. (a -> a -> Ordera) -> a -> b -> Rbt a b -> Rbt a b;
rbt_comp_insert c = rbt_comp_insert_with_key c (\ _ _ nv -> nv);

impl_of :: forall b a. (Ccompare b) => Mapping_rbt b a -> Rbt b a;
impl_of (Mapping_RBT x) = x;

the :: forall a. Maybe a -> a;
the (Just x2) = x2;

insertc ::
  forall a b. (Ccompare a) => a -> b -> Mapping_rbt a b -> Mapping_rbt a b;
insertc xc xd xe =
  Mapping_RBT (rbt_comp_insert (the ccompare) xc xd (impl_of xe));

comp_sunion_with ::
  forall a b.
    (a -> a -> Ordera) ->
      (a -> b -> b -> b) -> [(a, b)] -> [(a, b)] -> [(a, b)];
comp_sunion_with c f ((ka, va) : asa) ((k, v) : bs) =
  (case c k ka of {
    Eqa -> (ka, f ka va v) : comp_sunion_with c f asa bs;
    Lt -> (k, v) : comp_sunion_with c f ((ka, va) : asa) bs;
    Gt -> (ka, va) : comp_sunion_with c f asa ((k, v) : bs);
  });
comp_sunion_with c f [] bs = bs;
comp_sunion_with c f asa [] = asa;

data Comparea = LT | GT | EQ;

skip_red :: forall a b. Rbt a b -> Rbt a b;
skip_red (Branch R l k v r) = l;
skip_red Empty = Empty;
skip_red (Branch B va vb vc vd) = Branch B va vb vc vd;

skip_black :: forall a b. Rbt a b -> Rbt a b;
skip_black t = let {
                 ta = skip_red t;
               } in (case ta of {
                      Empty -> ta;
                      Branch R _ _ _ _ -> ta;
                      Branch B l _ _ _ -> l;
                    });

compare_height ::
  forall a b. Rbt a b -> Rbt a b -> Rbt a b -> Rbt a b -> Comparea;
compare_height sx s t tx =
  (case (skip_red sx, (skip_red s, (skip_red t, skip_red tx))) of {
    (Empty, (Empty, (_, Empty))) -> EQ;
    (Empty, (Empty, (_, Branch _ _ _ _ _))) -> LT;
    (Empty, (Branch _ _ _ _ _, (Empty, _))) -> EQ;
    (Empty, (Branch _ _ _ _ _, (Branch _ _ _ _ _, Empty))) -> EQ;
    (Empty, (Branch _ sa _ _ _, (Branch _ ta _ _ _, Branch _ txa _ _ _))) ->
      compare_height Empty sa ta (skip_black txa);
    (Branch _ _ _ _ _, (Empty, (Empty, Empty))) -> GT;
    (Branch _ _ _ _ _, (Empty, (Empty, Branch _ _ _ _ _))) -> LT;
    (Branch _ _ _ _ _, (Empty, (Branch _ _ _ _ _, Empty))) -> EQ;
    (Branch _ _ _ _ _, (Empty, (Branch _ _ _ _ _, Branch _ _ _ _ _))) -> LT;
    (Branch _ _ _ _ _, (Branch _ _ _ _ _, (Empty, _))) -> GT;
    (Branch _ sxa _ _ _, (Branch _ sa _ _ _, (Branch _ ta _ _ _, Empty))) ->
      compare_height (skip_black sxa) sa ta Empty;
    (Branch _ sxa _ _ _,
      (Branch _ sa _ _ _, (Branch _ ta _ _ _, Branch _ txa _ _ _)))
      -> compare_height (skip_black sxa) sa ta (skip_black txa);
  });

plus_nat :: Nat -> Nat -> Nat;
plus_nat m n = Nat (integer_of_nat m + integer_of_nat n);

suc :: Nat -> Nat;
suc n = plus_nat n one_nat;

gen_length :: forall a. Nat -> [a] -> Nat;
gen_length n (x : xs) = gen_length (suc n) xs;
gen_length n [] = n;

size_list :: forall a. [a] -> Nat;
size_list = gen_length zero_nat;

nat_of_integer :: Integer -> Nat;
nat_of_integer k = Nat (max (0 :: Integer) k);

apfst :: forall a b c. (a -> b) -> (a, c) -> (b, c);
apfst f (x, y) = (f x, y);

map_prod :: forall a b c d. (a -> b) -> (c -> d) -> (a, c) -> (b, d);
map_prod f g (a, b) = (f a, g b);

divmod_nat :: Nat -> Nat -> (Nat, Nat);
divmod_nat m n =
  let {
    k = integer_of_nat m;
    l = integer_of_nat n;
  } in map_prod nat_of_integer nat_of_integer
         (if k == (0 :: Integer) then ((0 :: Integer), (0 :: Integer))
           else (if l == (0 :: Integer) then ((0 :: Integer), k)
                  else divMod (abs k) (abs l)));

rbtreeify_g :: forall a b. Nat -> [(a, b)] -> (Rbt a b, [(a, b)]);
rbtreeify_g n kvs =
  (if equal_nat n zero_nat || equal_nat n one_nat then (Empty, kvs)
    else (case divmod_nat n (nat_of_integer (2 :: Integer)) of {
           (na, r) ->
             (if equal_nat r zero_nat
               then (case rbtreeify_g na kvs of {
                      (t1, (k, v) : kvsa) ->
                        apfst (Branch B t1 k v) (rbtreeify_g na kvsa);
                    })
               else (case rbtreeify_f na kvs of {
                      (t1, (k, v) : kvsa) ->
                        apfst (Branch B t1 k v) (rbtreeify_g na kvsa);
                    }));
         }));

rbtreeify_f :: forall a b. Nat -> [(a, b)] -> (Rbt a b, [(a, b)]);
rbtreeify_f n kvs =
  (if equal_nat n zero_nat then (Empty, kvs)
    else (if equal_nat n one_nat
           then (case kvs of {
                  (k, v) : kvsa -> (Branch R Empty k v Empty, kvsa);
                })
           else (case divmod_nat n (nat_of_integer (2 :: Integer)) of {
                  (na, r) ->
                    (if equal_nat r zero_nat
                      then (case rbtreeify_f na kvs of {
                             (t1, (k, v) : kvsa) ->
                               apfst (Branch B t1 k v) (rbtreeify_g na kvsa);
                           })
                      else (case rbtreeify_f na kvs of {
                             (t1, (k, v) : kvsa) ->
                               apfst (Branch B t1 k v) (rbtreeify_f na kvsa);
                           }));
                })));

rbtreeify :: forall a b. [(a, b)] -> Rbt a b;
rbtreeify kvs = fst (rbtreeify_g (suc (size_list kvs)) kvs);

gen_entries :: forall a b. [((a, b), Rbt a b)] -> Rbt a b -> [(a, b)];
gen_entries kvts (Branch c l k v r) = gen_entries (((k, v), r) : kvts) l;
gen_entries ((kv, t) : kvts) Empty = kv : gen_entries kvts t;
gen_entries [] Empty = [];

entries :: forall a b. Rbt a b -> [(a, b)];
entries = gen_entries [];

folda :: forall a b c. (a -> b -> c -> c) -> Rbt a b -> c -> c;
folda f (Branch c lt k v rt) x = folda f rt (f k v (folda f lt x));
folda f Empty x = x;

rbt_comp_union_with_key ::
  forall a b.
    (a -> a -> Ordera) -> (a -> b -> b -> b) -> Rbt a b -> Rbt a b -> Rbt a b;
rbt_comp_union_with_key c f t1 t2 =
  (case compare_height t1 t1 t2 t2 of {
    LT -> folda (rbt_comp_insert_with_key c (\ k v w -> f k w v)) t1 t2;
    GT -> folda (rbt_comp_insert_with_key c f) t2 t1;
    EQ -> rbtreeify (comp_sunion_with c f (entries t1) (entries t2));
  });

join ::
  forall a b.
    (Ccompare a) => (a -> b -> b -> b) ->
                      Mapping_rbt a b -> Mapping_rbt a b -> Mapping_rbt a b;
join xc xd xe =
  Mapping_RBT
    (rbt_comp_union_with_key (the ccompare) xc (impl_of xd) (impl_of xe));

list_insert :: forall a. (a -> a -> Bool) -> a -> [a] -> [a];
list_insert equal x xs = (if list_member equal xs x then xs else x : xs);

insertb :: forall a. (Ceq a) => a -> Set_dlist a -> Set_dlist a;
insertb xb xc = Abs_dlist (list_insert (the ceq) xb (list_of_dlist xc));

fold :: forall a b. (a -> b -> b) -> [a] -> b -> b;
fold f (x : xs) s = fold f xs (f x s);
fold f [] s = s;

foldc :: forall a b. (Ceq a) => (a -> b -> b) -> Set_dlist a -> b -> b;
foldc x xc = fold x (list_of_dlist xc);

union :: forall a. (Ceq a) => Set_dlist a -> Set_dlist a -> Set_dlist a;
union = foldc insertb;

memberc :: forall a. (Ceq a) => Set_dlist a -> a -> Bool;
memberc xa = list_member (the ceq) (list_of_dlist xa);

rbt_comp_lookup :: forall a b. (a -> a -> Ordera) -> Rbt a b -> a -> Maybe b;
rbt_comp_lookup c Empty k = Nothing;
rbt_comp_lookup c (Branch uu l x y r) k = (case c k x of {
    Eqa -> Just y;
    Lt -> rbt_comp_lookup c l k;
    Gt -> rbt_comp_lookup c r k;
  });

lookup :: forall a b. (Ccompare a) => Mapping_rbt a b -> a -> Maybe b;
lookup xa = rbt_comp_lookup (the ccompare) (impl_of xa);

memberb :: forall a. (Ccompare a) => Mapping_rbt a () -> a -> Bool;
memberb t x = lookup t x == Just ();

member :: forall a. (Ceq a, Ccompare a) => a -> Set a -> Bool;
member x (Set_Monad xs) =
  (case ceq of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "member Set_Monad: ceq = None" (\ _ -> member x (Set_Monad xs));
    Just eq -> list_member eq xs x;
  });
member xa (Complement x) = not (member xa x);
member x (RBT_set rbt) = memberb rbt x;
member x (DList_set dxs) = memberc dxs x;
member x (Collect_set a) = a x;

is_none :: forall a. Maybe a -> Bool;
is_none (Just x) = False;
is_none Nothing = True;

inter_list ::
  forall a. (Ccompare a) => Mapping_rbt a () -> [a] -> Mapping_rbt a ();
inter_list xb xc =
  Mapping_RBT
    (fold (\ k -> rbt_comp_insert (the ccompare) k ())
      (filter
        (\ x -> not (is_none (rbt_comp_lookup (the ccompare) (impl_of xb) x)))
        xc)
      Empty);

filterc ::
  forall a b.
    (Ccompare a) => ((a, b) -> Bool) -> Mapping_rbt a b -> Mapping_rbt a b;
filterc xb xc = Mapping_RBT (rbtreeify (filter xb (entries (impl_of xc))));

comp_sinter_with ::
  forall a b.
    (a -> a -> Ordera) ->
      (a -> b -> b -> b) -> [(a, b)] -> [(a, b)] -> [(a, b)];
comp_sinter_with c f ((ka, va) : asa) ((k, v) : bs) =
  (case c k ka of {
    Eqa -> (ka, f ka va v) : comp_sinter_with c f asa bs;
    Lt -> comp_sinter_with c f ((ka, va) : asa) bs;
    Gt -> comp_sinter_with c f asa ((k, v) : bs);
  });
comp_sinter_with c f [] uu = [];
comp_sinter_with c f uv [] = [];

map_option :: forall a b. (a -> b) -> Maybe a -> Maybe b;
map_option f Nothing = Nothing;
map_option f (Just x2) = Just (f x2);

map_filter :: forall a b. (a -> Maybe b) -> [a] -> [b];
map_filter f [] = [];
map_filter f (x : xs) = (case f x of {
                          Nothing -> map_filter f xs;
                          Just y -> y : map_filter f xs;
                        });

rbt_comp_inter_with_key ::
  forall a b.
    (a -> a -> Ordera) -> (a -> b -> b -> b) -> Rbt a b -> Rbt a b -> Rbt a b;
rbt_comp_inter_with_key c f t1 t2 =
  (case compare_height t1 t1 t2 t2 of {
    LT -> rbtreeify
            (map_filter
              (\ (k, v) ->
                map_option (\ w -> (k, f k v w)) (rbt_comp_lookup c t2 k))
              (entries t1));
    GT -> rbtreeify
            (map_filter
              (\ (k, v) ->
                map_option (\ w -> (k, f k w v)) (rbt_comp_lookup c t1 k))
              (entries t2));
    EQ -> rbtreeify (comp_sinter_with c f (entries t1) (entries t2));
  });

meet ::
  forall a b.
    (Ccompare a) => (a -> b -> b -> b) ->
                      Mapping_rbt a b -> Mapping_rbt a b -> Mapping_rbt a b;
meet xc xd xe =
  Mapping_RBT
    (rbt_comp_inter_with_key (the ccompare) xc (impl_of xd) (impl_of xe));

filterb :: forall a. (Ceq a) => (a -> Bool) -> Set_dlist a -> Set_dlist a;
filterb xb xc = Abs_dlist (filter xb (list_of_dlist xc));

inf_set :: forall a. (Ceq a, Ccompare a) => Set a -> Set a -> Set a;
inf_set (RBT_set rbt1) (Set_Monad xs) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "inter RBT_set Set_Monad: ccompare = None"
        (\ _ -> inf_set (RBT_set rbt1) (Set_Monad xs));
    Just _ -> RBT_set (inter_list rbt1 xs);
  });
inf_set (RBT_set rbt) (DList_set dxs) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "inter RBT_set DList_set: ccompare = None"
        (\ _ -> inf_set (RBT_set rbt) (DList_set dxs));
    Just _ ->
      (case (ceq :: Maybe (a -> a -> Bool)) of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "inter RBT_set DList_set: ceq = None"
            (\ _ -> inf_set (RBT_set rbt) (DList_set dxs));
        Just _ -> RBT_set (inter_list rbt (list_of_dlist dxs));
      });
  });
inf_set (RBT_set rbt1) (RBT_set rbt2) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "inter RBT_set RBT_set: ccompare = None"
        (\ _ -> inf_set (RBT_set rbt1) (RBT_set rbt2));
    Just _ -> RBT_set (meet (\ _ _ -> id) rbt1 rbt2);
  });
inf_set (DList_set dxs1) (Set_Monad xs) =
  (case ceq of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "inter DList_set Set_Monad: ceq = None"
        (\ _ -> inf_set (DList_set dxs1) (Set_Monad xs));
    Just eq -> DList_set (filterb (list_member eq xs) dxs1);
  });
inf_set (DList_set dxs1) (DList_set dxs2) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "inter DList_set DList_set: ceq = None"
        (\ _ -> inf_set (DList_set dxs1) (DList_set dxs2));
    Just _ -> DList_set (filterb (memberc dxs2) dxs1);
  });
inf_set (DList_set dxs) (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "inter DList_set RBT_set: ccompare = None"
        (\ _ -> inf_set (DList_set dxs) (RBT_set rbt));
    Just _ ->
      (case (ceq :: Maybe (a -> a -> Bool)) of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "inter DList_set RBT_set: ceq = None"
            (\ _ -> inf_set (DList_set dxs) (RBT_set rbt));
        Just _ -> RBT_set (inter_list rbt (list_of_dlist dxs));
      });
  });
inf_set (Set_Monad xs1) (Set_Monad xs2) =
  (case ceq of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "inter Set_Monad Set_Monad: ceq = None"
        (\ _ -> inf_set (Set_Monad xs1) (Set_Monad xs2));
    Just eq -> Set_Monad (filter (list_member eq xs2) xs1);
  });
inf_set (Set_Monad xs) (DList_set dxs2) =
  (case ceq of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "inter Set_Monad DList_set: ceq = None"
        (\ _ -> inf_set (Set_Monad xs) (DList_set dxs2));
    Just eq -> DList_set (filterb (list_member eq xs) dxs2);
  });
inf_set (Set_Monad xs) (RBT_set rbt1) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "inter Set_Monad RBT_set: ccompare = None"
        (\ _ -> inf_set (RBT_set rbt1) (Set_Monad xs));
    Just _ -> RBT_set (inter_list rbt1 xs);
  });
inf_set (Complement ba) (Complement b) = Complement (sup_set ba b);
inf_set g (RBT_set rbt2) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "inter RBT_set2: ccompare = None" (\ _ -> inf_set g (RBT_set rbt2));
    Just _ -> RBT_set (filterc ((\ x -> member x g) . fst) rbt2);
  });
inf_set (RBT_set rbt1) g =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "inter RBT_set1: ccompare = None" (\ _ -> inf_set (RBT_set rbt1) g);
    Just _ -> RBT_set (filterc ((\ x -> member x g) . fst) rbt1);
  });
inf_set h (DList_set dxs2) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "inter DList_set2: ceq = None" (\ _ -> inf_set h (DList_set dxs2));
    Just _ -> DList_set (filterb (\ x -> member x h) dxs2);
  });
inf_set (DList_set dxs1) h =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "inter DList_set1: ceq = None" (\ _ -> inf_set (DList_set dxs1) h);
    Just _ -> DList_set (filterb (\ x -> member x h) dxs1);
  });
inf_set i (Set_Monad xs) = Set_Monad (filter (\ x -> member x i) xs);
inf_set (Set_Monad xs) i = Set_Monad (filter (\ x -> member x i) xs);
inf_set j (Collect_set a) = Collect_set (\ x -> a x && member x j);
inf_set (Collect_set a) j = Collect_set (\ x -> a x && member x j);

sup_set :: forall a. (Ceq a, Ccompare a) => Set a -> Set a -> Set a;
sup_set ba (Complement b) = Complement (inf_set (uminus_set ba) b);
sup_set (Complement ba) b = Complement (inf_set ba (uminus_set b));
sup_set b (Collect_set a) = Collect_set (\ x -> a x || member x b);
sup_set (Collect_set a) b = Collect_set (\ x -> a x || member x b);
sup_set (Set_Monad xs) (Set_Monad ys) = Set_Monad (xs ++ ys);
sup_set (DList_set dxs1) (Set_Monad ws) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "union DList_set Set_Monad: ceq = None"
        (\ _ -> sup_set (DList_set dxs1) (Set_Monad ws));
    Just _ -> DList_set (fold insertb ws dxs1);
  });
sup_set (Set_Monad ws) (DList_set dxs2) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "union Set_Monad DList_set: ceq = None"
        (\ _ -> sup_set (Set_Monad ws) (DList_set dxs2));
    Just _ -> DList_set (fold insertb ws dxs2);
  });
sup_set (RBT_set rbt1) (Set_Monad zs) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "union RBT_set Set_Monad: ccompare = None"
        (\ _ -> sup_set (RBT_set rbt1) (Set_Monad zs));
    Just _ -> RBT_set (fold (\ k -> insertc k ()) zs rbt1);
  });
sup_set (Set_Monad zs) (RBT_set rbt2) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "union Set_Monad RBT_set: ccompare = None"
        (\ _ -> sup_set (Set_Monad zs) (RBT_set rbt2));
    Just _ -> RBT_set (fold (\ k -> insertc k ()) zs rbt2);
  });
sup_set (DList_set dxs1) (DList_set dxs2) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "union DList_set DList_set: ceq = None"
        (\ _ -> sup_set (DList_set dxs1) (DList_set dxs2));
    Just _ -> DList_set (union dxs1 dxs2);
  });
sup_set (DList_set dxs) (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "union DList_set RBT_set: ccompare = None"
        (\ _ -> sup_set (RBT_set rbt) (DList_set dxs));
    Just _ ->
      (case (ceq :: Maybe (a -> a -> Bool)) of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "union DList_set RBT_set: ceq = None"
            (\ _ -> sup_set (RBT_set rbt) (DList_set dxs));
        Just _ -> RBT_set (foldc (\ k -> insertc k ()) dxs rbt);
      });
  });
sup_set (RBT_set rbt) (DList_set dxs) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "union RBT_set DList_set: ccompare = None"
        (\ _ -> sup_set (RBT_set rbt) (DList_set dxs));
    Just _ ->
      (case (ceq :: Maybe (a -> a -> Bool)) of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "union RBT_set DList_set: ceq = None"
            (\ _ -> sup_set (RBT_set rbt) (DList_set dxs));
        Just _ -> RBT_set (foldc (\ k -> insertc k ()) dxs rbt);
      });
  });
sup_set (RBT_set rbt1) (RBT_set rbt2) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "union RBT_set RBT_set: ccompare = None"
        (\ _ -> sup_set (RBT_set rbt1) (RBT_set rbt2));
    Just _ -> RBT_set (join (\ _ _ -> id) rbt1 rbt2);
  });

class Inf a where {
  inf :: a -> a -> a;
};

instance (Ceq a, Ccompare a) => Inf (Set a) where {
  inf = inf_set;
};

class Sup a where {
  sup :: a -> a -> a;
};

instance (Ceq a, Ccompare a) => Sup (Set a) where {
  sup = sup_set;
};

equal_order :: Ordera -> Ordera -> Bool;
equal_order Lt Gt = False;
equal_order Gt Lt = False;
equal_order Eqa Gt = False;
equal_order Gt Eqa = False;
equal_order Eqa Lt = False;
equal_order Lt Eqa = False;
equal_order Gt Gt = True;
equal_order Lt Lt = True;
equal_order Eqa Eqa = True;

newtype Generator a b = Generator (b -> Bool, b -> (a, b));

generator :: forall a b. Generator a b -> (b -> Bool, b -> (a, b));
generator (Generator x) = x;

has_next :: forall a b. Generator a b -> b -> Bool;
has_next g = fst (generator g);

next :: forall a b. Generator a b -> b -> (a, b);
next g = snd (generator g);

sorted_list_subset_fusion ::
  forall a b c.
    (a -> a -> Bool) ->
      (a -> a -> Bool) -> Generator a b -> Generator a c -> b -> c -> Bool;
sorted_list_subset_fusion less eq g1 g2 s1 s2 =
  (if has_next g1 s1
    then (case next g1 s1 of {
           (x, s1a) ->
             has_next g2 s2 &&
               (case next g2 s2 of {
                 (y, s2a) ->
                   (if eq x y
                     then sorted_list_subset_fusion less eq g1 g2 s1a s2a
                     else less y x &&
                            sorted_list_subset_fusion less eq g1 g2 s1 s2a);
               });
         })
    else True);

list_all_fusion :: forall a b. Generator a b -> (a -> Bool) -> b -> Bool;
list_all_fusion g p s =
  (if has_next g s then (case next g s of {
                          (x, sa) -> p x && list_all_fusion g p sa;
                        })
    else True);

rbt_keys_next ::
  forall a b. ([(a, Rbt a b)], Rbt a b) -> (a, ([(a, Rbt a b)], Rbt a b));
rbt_keys_next ((k, t) : kts, Empty) = (k, (kts, t));
rbt_keys_next (kts, Branch c l k v r) = rbt_keys_next ((k, r) : kts, l);

rbt_has_next :: forall a b c. ([(a, Rbt b c)], Rbt b c) -> Bool;
rbt_has_next ([], Empty) = False;
rbt_has_next (vb : vc, va) = True;
rbt_has_next (v, Branch vb vc vd ve vf) = True;

rbt_keys_generator :: forall a b. Generator a ([(a, Rbt a b)], Rbt a b);
rbt_keys_generator = Generator (rbt_has_next, rbt_keys_next);

lt_of_comp :: forall a. (a -> a -> Ordera) -> a -> a -> Bool;
lt_of_comp acomp x y = (case acomp x y of {
                         Eqa -> False;
                         Lt -> True;
                         Gt -> False;
                       });

dlist_all :: forall a. (Ceq a) => (a -> Bool) -> Set_dlist a -> Bool;
dlist_all x xc = all x (list_of_dlist xc);

rbt_init :: forall a b c. Rbt a b -> ([(c, Rbt a b)], Rbt a b);
rbt_init = (\ a -> ([], a));

init ::
  forall a b c. (Ccompare a) => Mapping_rbt a b -> ([(c, Rbt a b)], Rbt a b);
init xa = rbt_init (impl_of xa);

collect :: forall a. (Cenum a) => (a -> Bool) -> Set a;
collect p = (case cEnum of {
              Nothing -> Collect_set p;
              Just (enum, _) -> Set_Monad (filter p enum);
            });

subset_eq :: forall a. (Cenum a, Ceq a, Ccompare a) => Set a -> Set a -> Bool;
subset_eq (RBT_set rbt1) (RBT_set rbt2) =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "subset RBT_set RBT_set: ccompare = None"
        (\ _ -> subset_eq (RBT_set rbt1) (RBT_set rbt2));
    Just c ->
      (case ceq of {
        Nothing ->
          sorted_list_subset_fusion (lt_of_comp c)
            (\ x y -> equal_order (c x y) Eqa) rbt_keys_generator
            rbt_keys_generator (init rbt1) (init rbt2);
        Just eq ->
          sorted_list_subset_fusion (lt_of_comp c) eq rbt_keys_generator
            rbt_keys_generator (init rbt1) (init rbt2);
      });
  });
subset_eq (Complement a1) (Complement a2) = subset_eq a2 a1;
subset_eq (Collect_set p) (Complement a) =
  subset_eq a (collect (\ x -> not (p x)));
subset_eq (Set_Monad xs) c = all (\ x -> member x c) xs;
subset_eq (DList_set dxs) c =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "subset DList_set1: ceq = None" (\ _ -> subset_eq (DList_set dxs) c);
    Just _ -> dlist_all (\ x -> member x c) dxs;
  });
subset_eq (RBT_set rbt) b =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "subset RBT_set1: ccompare = None" (\ _ -> subset_eq (RBT_set rbt) b);
    Just _ -> list_all_fusion rbt_keys_generator (\ x -> member x b) (init rbt);
  });

less_eq_set :: forall a. (Cenum a, Ceq a, Ccompare a) => Set a -> Set a -> Bool;
less_eq_set = subset_eq;

less_set :: forall a. (Cenum a, Ceq a, Ccompare a) => Set a -> Set a -> Bool;
less_set a b = less_eq_set a b && not (less_eq_set b a);

instance (Cenum a, Ceq a, Ccompare a) => Ord (Set a) where {
  less_eq = less_eq_set;
  less = less_set;
};

instance (Cenum a, Ceq a, Ccompare a) => Preorder (Set a) where {
};

instance (Cenum a, Ceq a, Ccompare a) => Order (Set a) where {
};

class (Sup a, Order a) => Semilattice_sup a where {
};

class (Inf a, Order a) => Semilattice_inf a where {
};

class (Semilattice_inf a, Semilattice_sup a) => Lattice a where {
};

instance (Cenum a, Ceq a, Ccompare a) => Semilattice_sup (Set a) where {
};

instance (Cenum a, Ceq a, Ccompare a) => Semilattice_inf (Set a) where {
};

instance (Cenum a, Ceq a, Ccompare a) => Lattice (Set a) where {
};

list_all2_fusion ::
  forall a b c d.
    (a -> b -> Bool) -> Generator a c -> Generator b d -> c -> d -> Bool;
list_all2_fusion p g1 g2 s1 s2 =
  (if has_next g1 s1
    then has_next g2 s2 &&
           (case next g1 s1 of {
             (x, s1a) ->
               (case next g2 s2 of {
                 (y, s2a) -> p x y && list_all2_fusion p g1 g2 s1a s2a;
               });
           })
    else not (has_next g2 s2));

set_eq :: forall a. (Cenum a, Ceq a, Ccompare a) => Set a -> Set a -> Bool;
set_eq (RBT_set rbt1) (RBT_set rbt2) =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "set_eq RBT_set RBT_set: ccompare = None"
        (\ _ -> set_eq (RBT_set rbt1) (RBT_set rbt2));
    Just c ->
      (case ceq of {
        Nothing ->
          list_all2_fusion (\ x y -> equal_order (c x y) Eqa) rbt_keys_generator
            rbt_keys_generator (init rbt1) (init rbt2);
        Just eq ->
          list_all2_fusion eq rbt_keys_generator rbt_keys_generator (init rbt1)
            (init rbt2);
      });
  });
set_eq (Complement a) (Complement b) = set_eq a b;
set_eq a b = less_eq_set a b && less_eq_set b a;

ceq_set ::
  forall a. (Cenum a, Ceq a, Ccompare a) => Maybe (Set a -> Set a -> Bool);
ceq_set = (case (ceq :: Maybe (a -> a -> Bool)) of {
            Nothing -> Nothing;
            Just _ -> Just set_eq;
          });

instance (Cenum a, Ceq a, Ccompare a) => Ceq (Set a) where {
  ceq = ceq_set;
};

set_impl_set :: forall a. Phantom (Set a) Set_impla;
set_impl_set = Phantom Set_Choose;

instance Set_impl (Set a) where {
  set_impl = set_impl_set;
};

of_phantom :: forall a b. Phantom a b -> b;
of_phantom (Phantom x) = x;

finite_UNIV_set :: forall a. (Finite_UNIV a) => Phantom (Set a) Bool;
finite_UNIV_set = Phantom (of_phantom (finite_UNIV :: Phantom a Bool));

instance (Finite_UNIV a) => Finite_UNIV (Set a) where {
  finite_UNIV = finite_UNIV_set;
};

set_less_eq_aux_Compl_fusion ::
  forall a b c.
    (a -> a -> Bool) ->
      (Maybe a -> Maybe a -> Bool) ->
        Generator a b -> Generator a c -> Maybe a -> b -> c -> Bool;
set_less_eq_aux_Compl_fusion less proper_interval g1 g2 ao s1 s2 =
  (if has_next g1 s1
    then (if has_next g2 s2
           then (case next g1 s1 of {
                  (x, s1a) ->
                    (case next g2 s2 of {
                      (y, s2a) ->
                        (if less x y
                          then proper_interval ao (Just x) ||
                                 set_less_eq_aux_Compl_fusion less
                                   proper_interval g1 g2 (Just x) s1a s2
                          else (if less y x
                                 then proper_interval ao (Just y) ||
set_less_eq_aux_Compl_fusion less proper_interval g1 g2 (Just y) s1 s2a
                                 else proper_interval ao (Just y)));
                    });
                })
           else True)
    else True);

compl_set_less_eq_aux_fusion ::
  forall a b c.
    (a -> a -> Bool) ->
      (Maybe a -> Maybe a -> Bool) ->
        Generator a b -> Generator a c -> Maybe a -> b -> c -> Bool;
compl_set_less_eq_aux_fusion less proper_interval g1 g2 ao s1 s2 =
  (if has_next g1 s1
    then (case next g1 s1 of {
           (x, s1a) ->
             (if has_next g2 s2
               then (case next g2 s2 of {
                      (y, s2a) ->
                        (if less x y
                          then not (proper_interval ao (Just x)) &&
                                 compl_set_less_eq_aux_fusion less
                                   proper_interval g1 g2 (Just x) s1a s2
                          else (if less y x
                                 then not (proper_interval ao (Just y)) &&
compl_set_less_eq_aux_fusion less proper_interval g1 g2 (Just y) s1 s2a
                                 else not (proper_interval ao (Just y))));
                    })
               else not (proper_interval ao (Just x)) &&
                      compl_set_less_eq_aux_fusion less proper_interval g1 g2
                        (Just x) s1a s2);
         })
    else (if has_next g2 s2
           then (case next g2 s2 of {
                  (y, s2a) ->
                    not (proper_interval ao (Just y)) &&
                      compl_set_less_eq_aux_fusion less proper_interval g1 g2
                        (Just y) s1 s2a;
                })
           else not (proper_interval ao Nothing)));

set_less_eq_aux_Compl ::
  forall a.
    (a -> a -> Bool) ->
      (Maybe a -> Maybe a -> Bool) -> Maybe a -> [a] -> [a] -> Bool;
set_less_eq_aux_Compl less proper_interval ao (x : xs) (y : ys) =
  (if less x y
    then proper_interval ao (Just x) ||
           set_less_eq_aux_Compl less proper_interval (Just x) xs (y : ys)
    else (if less y x
           then proper_interval ao (Just y) ||
                  set_less_eq_aux_Compl less proper_interval (Just y) (x : xs)
                    ys
           else proper_interval ao (Just y)));
set_less_eq_aux_Compl less proper_interval ao xs [] = True;
set_less_eq_aux_Compl less proper_interval ao [] ys = True;

compl_set_less_eq_aux ::
  forall a.
    (a -> a -> Bool) ->
      (Maybe a -> Maybe a -> Bool) -> Maybe a -> [a] -> [a] -> Bool;
compl_set_less_eq_aux less proper_interval ao (x : xs) (y : ys) =
  (if less x y
    then not (proper_interval ao (Just x)) &&
           compl_set_less_eq_aux less proper_interval (Just x) xs (y : ys)
    else (if less y x
           then not (proper_interval ao (Just y)) &&
                  compl_set_less_eq_aux less proper_interval (Just y) (x : xs)
                    ys
           else not (proper_interval ao (Just y))));
compl_set_less_eq_aux less proper_interval ao (x : xs) [] =
  not (proper_interval ao (Just x)) &&
    compl_set_less_eq_aux less proper_interval (Just x) xs [];
compl_set_less_eq_aux less proper_interval ao [] (y : ys) =
  not (proper_interval ao (Just y)) &&
    compl_set_less_eq_aux less proper_interval (Just y) [] ys;
compl_set_less_eq_aux less proper_interval ao [] [] =
  not (proper_interval ao Nothing);

lexord_eq_fusion ::
  forall a b c.
    (a -> a -> Bool) -> Generator a b -> Generator a c -> b -> c -> Bool;
lexord_eq_fusion less g1 g2 s1 s2 =
  (if has_next g1 s1
    then has_next g2 s2 &&
           (case next g1 s1 of {
             (x, s1a) ->
               (case next g2 s2 of {
                 (y, s2a) ->
                   less x y ||
                     not (less y x) && lexord_eq_fusion less g1 g2 s1a s2a;
               });
           })
    else True);

remdups_sorted :: forall a. (a -> a -> Bool) -> [a] -> [a];
remdups_sorted less (x : y : xs) =
  (if less x y then x : remdups_sorted less (y : xs)
    else remdups_sorted less (y : xs));
remdups_sorted less [x] = [x];
remdups_sorted less [] = [];

quicksort_acc :: forall a. (a -> a -> Bool) -> [a] -> [a] -> [a];
quicksort_acc less ac (x : v : va) = quicksort_part less ac x [] [] [] (v : va);
quicksort_acc less ac [x] = x : ac;
quicksort_acc less ac [] = ac;

quicksort_part ::
  forall a. (a -> a -> Bool) -> [a] -> a -> [a] -> [a] -> [a] -> [a] -> [a];
quicksort_part less ac x lts eqs gts (z : zs) =
  (if less x z then quicksort_part less ac x lts eqs (z : gts) zs
    else (if less z x then quicksort_part less ac x (z : lts) eqs gts zs
           else quicksort_part less ac x lts (z : eqs) gts zs));
quicksort_part less ac x lts eqs gts [] =
  quicksort_acc less (eqs ++ x : quicksort_acc less ac gts) lts;

quicksort :: forall a. (a -> a -> Bool) -> [a] -> [a];
quicksort less = quicksort_acc less [];

gen_keys :: forall a b. [(a, Rbt a b)] -> Rbt a b -> [a];
gen_keys kts (Branch c l k v r) = gen_keys ((k, r) : kts) l;
gen_keys ((k, t) : kts) Empty = k : gen_keys kts t;
gen_keys [] Empty = [];

keys :: forall a b. Rbt a b -> [a];
keys = gen_keys [];

keysa :: forall a. (Ccompare a) => Mapping_rbt a () -> [a];
keysa xa = keys (impl_of xa);

csorted_list_of_set :: forall a. (Ceq a, Ccompare a) => Set a -> [a];
csorted_list_of_set (Set_Monad xs) =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "csorted_list_of_set Set_Monad: ccompare = None"
        (\ _ -> csorted_list_of_set (Set_Monad xs));
    Just c -> remdups_sorted (lt_of_comp c) (quicksort (lt_of_comp c) xs);
  });
csorted_list_of_set (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "csorted_list_of_set DList_set: ceq = None"
        (\ _ -> csorted_list_of_set (DList_set dxs));
    Just _ ->
      (case ccompare of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "csorted_list_of_set DList_set: ccompare = None"
            (\ _ -> csorted_list_of_set (DList_set dxs));
        Just c -> quicksort (lt_of_comp c) (list_of_dlist dxs);
      });
  });
csorted_list_of_set (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "csorted_list_of_set RBT_set: ccompare = None"
        (\ _ -> csorted_list_of_set (RBT_set rbt));
    Just _ -> keysa rbt;
  });

emptya :: forall a b. (Ccompare a) => Mapping_rbt a b;
emptya = Mapping_RBT Empty;

empty :: forall a. (Ceq a) => Set_dlist a;
empty = Abs_dlist [];

set_empty_choose :: forall a. (Ceq a, Ccompare a) => Set a;
set_empty_choose = (case (ccompare :: Maybe (a -> a -> Ordera)) of {
                     Nothing -> (case (ceq :: Maybe (a -> a -> Bool)) of {
                                  Nothing -> Set_Monad [];
                                  Just _ -> DList_set empty;
                                });
                     Just _ -> RBT_set emptya;
                   });

set_empty :: forall a. (Ceq a, Ccompare a) => Set_impla -> Set a;
set_empty Set_Choose = set_empty_choose;
set_empty Set_Monada = Set_Monad [];
set_empty Set_RBT = RBT_set emptya;
set_empty Set_DList = DList_set empty;
set_empty Set_Collect = Collect_set (\ _ -> False);

bot_set :: forall a. (Ceq a, Ccompare a, Set_impl a) => Set a;
bot_set = set_empty (of_phantom (set_impl :: Phantom a Set_impla));

top_set :: forall a. (Ceq a, Ccompare a, Set_impl a) => Set a;
top_set = uminus_set bot_set;

le_of_comp :: forall a. (a -> a -> Ordera) -> a -> a -> Bool;
le_of_comp acomp x y = (case acomp x y of {
                         Eqa -> True;
                         Lt -> True;
                         Gt -> False;
                       });

lexordp_eq :: forall a. (a -> a -> Bool) -> [a] -> [a] -> Bool;
lexordp_eq less (x : xs) (y : ys) =
  less x y || not (less y x) && lexordp_eq less xs ys;
lexordp_eq less (x : xs) [] = False;
lexordp_eq less xs [] = null xs;
lexordp_eq less [] ys = True;

finitea :: forall a. (Finite_UNIV a) => Set a -> Bool;
finitea = finitea;

finite :: forall a. (Finite_UNIV a, Ceq a, Ccompare a) => Set a -> Bool;
finite (Collect_set p) =
  of_phantom (finite_UNIV :: Phantom a Bool) ||
    (error :: forall a. String -> (() -> a) -> a) "finite Collect_set"
      (\ _ -> finitea (Collect_set p));
finite (Set_Monad xs) = True;
finite (Complement a) =
  (if of_phantom (finite_UNIV :: Phantom a Bool) then True
    else (if finitea a then False
           else (error :: forall a. String -> (() -> a) -> a)
                  "finite Complement: infinite set"
                  (\ _ -> finitea (Complement a))));
finite (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "finite RBT_set: ccompare = None" (\ _ -> finite (RBT_set rbt));
    Just _ -> True;
  });
finite (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "finite DList_set: ceq = None" (\ _ -> finite (DList_set dxs));
    Just _ -> True;
  });

set_less_aux_Compl_fusion ::
  forall a b c.
    (a -> a -> Bool) ->
      (Maybe a -> Maybe a -> Bool) ->
        Generator a b -> Generator a c -> Maybe a -> b -> c -> Bool;
set_less_aux_Compl_fusion less proper_interval g1 g2 ao s1 s2 =
  (if has_next g1 s1
    then (case next g1 s1 of {
           (x, s1a) ->
             (if has_next g2 s2
               then (case next g2 s2 of {
                      (y, s2a) ->
                        (if less x y
                          then proper_interval ao (Just x) ||
                                 set_less_aux_Compl_fusion less proper_interval
                                   g1 g2 (Just x) s1a s2
                          else (if less y x
                                 then proper_interval ao (Just y) ||
set_less_aux_Compl_fusion less proper_interval g1 g2 (Just y) s1 s2a
                                 else proper_interval ao (Just y)));
                    })
               else proper_interval ao (Just x) ||
                      set_less_aux_Compl_fusion less proper_interval g1 g2
                        (Just x) s1a s2);
         })
    else (if has_next g2 s2
           then (case next g2 s2 of {
                  (y, s2a) ->
                    proper_interval ao (Just y) ||
                      set_less_aux_Compl_fusion less proper_interval g1 g2
                        (Just y) s1 s2a;
                })
           else proper_interval ao Nothing));

compl_set_less_aux_fusion ::
  forall a b c.
    (a -> a -> Bool) ->
      (Maybe a -> Maybe a -> Bool) ->
        Generator a b -> Generator a c -> Maybe a -> b -> c -> Bool;
compl_set_less_aux_fusion less proper_interval g1 g2 ao s1 s2 =
  has_next g1 s1 &&
    has_next g2 s2 &&
      (case next g1 s1 of {
        (x, s1a) ->
          (case next g2 s2 of {
            (y, s2a) ->
              (if less x y
                then not (proper_interval ao (Just x)) &&
                       compl_set_less_aux_fusion less proper_interval g1 g2
                         (Just x) s1a s2
                else (if less y x
                       then not (proper_interval ao (Just y)) &&
                              compl_set_less_aux_fusion less proper_interval g1
                                g2 (Just y) s1 s2a
                       else not (proper_interval ao (Just y))));
          });
      });

set_less_aux_Compl ::
  forall a.
    (a -> a -> Bool) ->
      (Maybe a -> Maybe a -> Bool) -> Maybe a -> [a] -> [a] -> Bool;
set_less_aux_Compl less proper_interval ao (x : xs) (y : ys) =
  (if less x y
    then proper_interval ao (Just x) ||
           set_less_aux_Compl less proper_interval (Just x) xs (y : ys)
    else (if less y x
           then proper_interval ao (Just y) ||
                  set_less_aux_Compl less proper_interval (Just y) (x : xs) ys
           else proper_interval ao (Just y)));
set_less_aux_Compl less proper_interval ao (x : xs) [] =
  proper_interval ao (Just x) ||
    set_less_aux_Compl less proper_interval (Just x) xs [];
set_less_aux_Compl less proper_interval ao [] (y : ys) =
  proper_interval ao (Just y) ||
    set_less_aux_Compl less proper_interval (Just y) [] ys;
set_less_aux_Compl less proper_interval ao [] [] = proper_interval ao Nothing;

compl_set_less_aux ::
  forall a.
    (a -> a -> Bool) ->
      (Maybe a -> Maybe a -> Bool) -> Maybe a -> [a] -> [a] -> Bool;
compl_set_less_aux less proper_interval ao (x : xs) (y : ys) =
  (if less x y
    then not (proper_interval ao (Just x)) &&
           compl_set_less_aux less proper_interval (Just x) xs (y : ys)
    else (if less y x
           then not (proper_interval ao (Just y)) &&
                  compl_set_less_aux less proper_interval (Just y) (x : xs) ys
           else not (proper_interval ao (Just y))));
compl_set_less_aux less proper_interval ao xs [] = False;
compl_set_less_aux less proper_interval ao [] ys = False;

lexord_fusion ::
  forall a b c.
    (a -> a -> Bool) -> Generator a b -> Generator a c -> b -> c -> Bool;
lexord_fusion less g1 g2 s1 s2 =
  (if has_next g1 s1
    then (if has_next g2 s2
           then (case next g1 s1 of {
                  (x, s1a) ->
                    (case next g2 s2 of {
                      (y, s2a) ->
                        less x y ||
                          not (less y x) && lexord_fusion less g1 g2 s1a s2a;
                    });
                })
           else False)
    else has_next g2 s2);

lexordp :: forall a. (a -> a -> Bool) -> [a] -> [a] -> Bool;
lexordp less (x : xs) (y : ys) =
  less x y || not (less y x) && lexordp less xs ys;
lexordp less xs [] = False;
lexordp less [] ys = not (null ys);

comp_of_ords ::
  forall a. (a -> a -> Bool) -> (a -> a -> Bool) -> a -> a -> Ordera;
comp_of_ords le lt x y = (if lt x y then Lt else (if le x y then Eqa else Gt));

ccompare_set ::
  forall a.
    (Finite_UNIV a, Ceq a, Cproper_interval a,
      Set_impl a) => Maybe (Set a -> Set a -> Ordera);
ccompare_set = (case (ccompare :: Maybe (a -> a -> Ordera)) of {
                 Nothing -> Nothing;
                 Just _ -> Just (comp_of_ords cless_eq_set cless_set);
               });

cless_set ::
  forall a.
    (Finite_UNIV a, Ceq a, Cproper_interval a,
      Set_impl a) => Set a -> Set a -> Bool;
cless_set (Complement (RBT_set rbt1)) (RBT_set rbt2) =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "cless_set (Complement RBT_set) RBT_set: ccompare = None"
        (\ _ -> cless_set (Complement (RBT_set rbt1)) (RBT_set rbt2));
    Just c ->
      (finite :: Set a -> Bool) (top_set :: Set a) &&
        compl_set_less_aux_fusion (lt_of_comp c) cproper_interval
          rbt_keys_generator rbt_keys_generator Nothing (init rbt1) (init rbt2);
  });
cless_set (RBT_set rbt1) (Complement (RBT_set rbt2)) =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "cless_set RBT_set (Complement RBT_set): ccompare = None"
        (\ _ -> cless_set (RBT_set rbt1) (Complement (RBT_set rbt2)));
    Just c ->
      (if (finite :: Set a -> Bool) (top_set :: Set a)
        then set_less_aux_Compl_fusion (lt_of_comp c) cproper_interval
               rbt_keys_generator rbt_keys_generator Nothing (init rbt1)
               (init rbt2)
        else True);
  });
cless_set (RBT_set rbta) (RBT_set rbt) =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "cless_set RBT_set RBT_set: ccompare = None"
        (\ _ -> cless_set (RBT_set rbta) (RBT_set rbt));
    Just c ->
      lexord_fusion (\ x y -> lt_of_comp c y x) rbt_keys_generator
        rbt_keys_generator (init rbta) (init rbt);
  });
cless_set (Complement a) (Complement b) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "cless_set Complement Complement: ccompare = None"
        (\ _ -> cless_set (Complement a) (Complement b));
    Just _ -> lt_of_comp (the ccompare_set) b a;
  });
cless_set (Complement a) b =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "cless_set Complement1: ccompare = None"
        (\ _ -> cless_set (Complement a) b);
    Just c ->
      (if finite a && finite b
        then (finite :: Set a -> Bool) (top_set :: Set a) &&
               compl_set_less_aux (lt_of_comp c) cproper_interval Nothing
                 (csorted_list_of_set a) (csorted_list_of_set b)
        else (error :: forall a. String -> (() -> a) -> a)
               "cless_set Complement1: infinite set"
               (\ _ -> cless_set (Complement a) b));
  });
cless_set a (Complement b) =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "cless_set Complement2: ccompare = None"
        (\ _ -> cless_set a (Complement b));
    Just c ->
      (if finite a && finite b
        then (if (finite :: Set a -> Bool) (top_set :: Set a)
               then set_less_aux_Compl (lt_of_comp c) cproper_interval Nothing
                      (csorted_list_of_set a) (csorted_list_of_set b)
               else True)
        else (error :: forall a. String -> (() -> a) -> a)
               "cless_set Complement2: infinite set"
               (\ _ -> cless_set a (Complement b)));
  });
cless_set a b =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a) "cless_set: ccompare = None"
        (\ _ -> cless_set a b);
    Just c ->
      (if finite a && finite b
        then lexordp (\ x y -> lt_of_comp c y x) (csorted_list_of_set a)
               (csorted_list_of_set b)
        else (error :: forall a. String -> (() -> a) -> a)
               "cless_set: infinite set" (\ _ -> cless_set a b));
  });

cless_eq_set ::
  forall a.
    (Finite_UNIV a, Ceq a, Cproper_interval a,
      Set_impl a) => Set a -> Set a -> Bool;
cless_eq_set (Complement (RBT_set rbt1)) (RBT_set rbt2) =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "cless_eq_set (Complement RBT_set) RBT_set: ccompare = None"
        (\ _ -> cless_eq_set (Complement (RBT_set rbt1)) (RBT_set rbt2));
    Just c ->
      (finite :: Set a -> Bool) (top_set :: Set a) &&
        compl_set_less_eq_aux_fusion (lt_of_comp c) cproper_interval
          rbt_keys_generator rbt_keys_generator Nothing (init rbt1) (init rbt2);
  });
cless_eq_set (RBT_set rbt1) (Complement (RBT_set rbt2)) =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "cless_eq_set RBT_set (Complement RBT_set): ccompare = None"
        (\ _ -> cless_eq_set (RBT_set rbt1) (Complement (RBT_set rbt2)));
    Just c ->
      (if (finite :: Set a -> Bool) (top_set :: Set a)
        then set_less_eq_aux_Compl_fusion (lt_of_comp c) cproper_interval
               rbt_keys_generator rbt_keys_generator Nothing (init rbt1)
               (init rbt2)
        else True);
  });
cless_eq_set (RBT_set rbta) (RBT_set rbt) =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "cless_eq_set RBT_set RBT_set: ccompare = None"
        (\ _ -> cless_eq_set (RBT_set rbta) (RBT_set rbt));
    Just c ->
      lexord_eq_fusion (\ x y -> lt_of_comp c y x) rbt_keys_generator
        rbt_keys_generator (init rbta) (init rbt);
  });
cless_eq_set (Complement a) (Complement b) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "cless_eq_set Complement Complement: ccompare = None"
        (\ _ -> le_of_comp (the ccompare_set) (Complement a) (Complement b));
    Just _ -> cless_eq_set b a;
  });
cless_eq_set (Complement a) b =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "cless_eq_set Complement1: ccompare = None"
        (\ _ -> cless_eq_set (Complement a) b);
    Just c ->
      (if finite a && finite b
        then (finite :: Set a -> Bool) (top_set :: Set a) &&
               compl_set_less_eq_aux (lt_of_comp c) cproper_interval Nothing
                 (csorted_list_of_set a) (csorted_list_of_set b)
        else (error :: forall a. String -> (() -> a) -> a)
               "cless_eq_set Complement1: infinite set"
               (\ _ -> cless_eq_set (Complement a) b));
  });
cless_eq_set a (Complement b) =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "cless_eq_set Complement2: ccompare = None"
        (\ _ -> cless_eq_set a (Complement b));
    Just c ->
      (if finite a && finite b
        then (if (finite :: Set a -> Bool) (top_set :: Set a)
               then set_less_eq_aux_Compl (lt_of_comp c) cproper_interval
                      Nothing (csorted_list_of_set a) (csorted_list_of_set b)
               else True)
        else (error :: forall a. String -> (() -> a) -> a)
               "cless_eq_set Complement2: infinite set"
               (\ _ -> cless_eq_set a (Complement b)));
  });
cless_eq_set a b =
  (case ccompare of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "cless_eq_set: ccompare = None" (\ _ -> cless_eq_set a b);
    Just c ->
      (if finite a && finite b
        then lexordp_eq (\ x y -> lt_of_comp c y x) (csorted_list_of_set a)
               (csorted_list_of_set b)
        else (error :: forall a. String -> (() -> a) -> a)
               "cless_eq_set: infinite set" (\ _ -> cless_eq_set a b));
  });

instance (Finite_UNIV a, Ceq a, Cproper_interval a,
           Set_impl a) => Ccompare (Set a) where {
  ccompare = ccompare_set;
};

comparator_bool :: Bool -> Bool -> Ordera;
comparator_bool False False = Eqa;
comparator_bool False True = Lt;
comparator_bool True True = Eqa;
comparator_bool True False = Gt;

compare_bool :: Bool -> Bool -> Ordera;
compare_bool = comparator_bool;

instance Compare Bool where {
  compare = compare_bool;
};

ceq_bool :: Maybe (Bool -> Bool -> Bool);
ceq_bool = Just (\ a b -> a == b);

instance Ceq Bool where {
  ceq = ceq_bool;
};

set_impl_bool :: Phantom Bool Set_impla;
set_impl_bool = Phantom Set_DList;

instance Set_impl Bool where {
  set_impl = set_impl_bool;
};

finite_UNIV_bool :: Phantom Bool Bool;
finite_UNIV_bool = Phantom True;

card_UNIV_bool :: Phantom Bool Nat;
card_UNIV_bool = Phantom (nat_of_integer (2 :: Integer));

instance Finite_UNIV Bool where {
  finite_UNIV = finite_UNIV_bool;
};

instance Card_UNIV Bool where {
  card_UNIV = card_UNIV_bool;
};

enum_all_bool :: (Bool -> Bool) -> Bool;
enum_all_bool p = p False && p True;

enum_ex_bool :: (Bool -> Bool) -> Bool;
enum_ex_bool p = p False || p True;

enum_bool :: [Bool];
enum_bool = [False, True];

cEnum_bool :: Maybe ([Bool], ((Bool -> Bool) -> Bool, (Bool -> Bool) -> Bool));
cEnum_bool = Just (enum_bool, (enum_all_bool, enum_ex_bool));

instance Cenum Bool where {
  cEnum = cEnum_bool;
};

ccompare_bool :: Maybe (Bool -> Bool -> Ordera);
ccompare_bool = Just compare_bool;

instance Ccompare Bool where {
  ccompare = ccompare_bool;
};

proper_interval_bool :: Maybe Bool -> Maybe Bool -> Bool;
proper_interval_bool (Just x) (Just y) = False;
proper_interval_bool (Just x) Nothing = not x;
proper_interval_bool Nothing (Just y) = y;
proper_interval_bool Nothing Nothing = True;

cproper_interval_bool :: Maybe Bool -> Maybe Bool -> Bool;
cproper_interval_bool = proper_interval_bool;

instance Cproper_interval Bool where {
  cproper_interval = cproper_interval_bool;
};

newtype Fset a = Abs_fset (Set a);

fset :: forall a. Fset a -> Set a;
fset (Abs_fset x) = x;

less_eq_fset ::
  forall a. (Cenum a, Ceq a, Ccompare a) => Fset a -> Fset a -> Bool;
less_eq_fset xa xc = less_eq_set (fset xa) (fset xc);

equal_fset ::
  forall a. (Cenum a, Ceq a, Ccompare a, Eq a) => Fset a -> Fset a -> Bool;
equal_fset a b = less_eq_fset a b && less_eq_fset b a;

instance (Cenum a, Ceq a, Ccompare a, Eq a) => Eq (Fset a) where {
  a == b = equal_fset a b;
};

ceq_fset ::
  forall a.
    (Cenum a, Ceq a, Ccompare a, Eq a) => Maybe (Fset a -> Fset a -> Bool);
ceq_fset = Just (\ a b -> a == b);

instance (Cenum a, Ceq a, Ccompare a, Eq a) => Ceq (Fset a) where {
  ceq = ceq_fset;
};

set_impl_fset :: forall a. Phantom (Fset a) Set_impla;
set_impl_fset = Phantom Set_RBT;

instance Set_impl (Fset a) where {
  set_impl = set_impl_fset;
};

less_list :: forall a. (Eq a, Order a) => [a] -> [a] -> Bool;
less_list (x : xs) (y : ys) = less x y || x == y && less_list xs ys;
less_list [] (x : xs) = True;
less_list xs [] = False;

apsnd :: forall a b c. (a -> b) -> (c, a) -> (c, b);
apsnd f (x, y) = (x, f y);

divmod_integer :: Integer -> Integer -> (Integer, Integer);
divmod_integer k l =
  (if k == (0 :: Integer) then ((0 :: Integer), (0 :: Integer))
    else (if (0 :: Integer) < l
           then (if (0 :: Integer) < k then divMod (abs k) (abs l)
                  else (case divMod (abs k) (abs l) of {
                         (r, s) ->
                           (if s == (0 :: Integer)
                             then (negate r, (0 :: Integer))
                             else (negate r - (1 :: Integer), l - s));
                       }))
           else (if l == (0 :: Integer) then ((0 :: Integer), k)
                  else apsnd negate
                         (if k < (0 :: Integer) then divMod (abs k) (abs l)
                           else (case divMod (abs k) (abs l) of {
                                  (r, s) ->
                                    (if s == (0 :: Integer)
                                      then (negate r, (0 :: Integer))
                                      else (negate r - (1 :: Integer),
     negate l - s));
                                })))));

divide_integer :: Integer -> Integer -> Integer;
divide_integer k l = fst (divmod_integer k l);

divide_nat :: Nat -> Nat -> Nat;
divide_nat m n = Nat (divide_integer (integer_of_nat m) (integer_of_nat n));

part :: forall a b. (Linorder b) => (a -> b) -> b -> [a] -> ([a], ([a], [a]));
part f pivot (x : xs) =
  (case part f pivot xs of {
    (lts, (eqs, gts)) ->
      let {
        xa = f x;
      } in (if less xa pivot then (x : lts, (eqs, gts))
             else (if less pivot xa then (lts, (eqs, x : gts))
                    else (lts, (x : eqs, gts))));
  });
part f pivot [] = ([], ([], []));

nth :: forall a. [a] -> Nat -> a;
nth (x : xs) n =
  (if equal_nat n zero_nat then x else nth xs (minus_nat n one_nat));

sort_key :: forall a b. (Linorder b) => (a -> b) -> [a] -> [a];
sort_key f xs =
  (case xs of {
    [] -> [];
    [_] -> xs;
    [x, y] -> (if less_eq (f x) (f y) then xs else [y, x]);
    _ : _ : _ : _ ->
      (case part f
              (f (nth xs
                   (divide_nat (size_list xs) (nat_of_integer (2 :: Integer)))))
              xs
        of {
        (lts, (eqs, gts)) -> sort_key f lts ++ eqs ++ sort_key f gts;
      });
  });

membera :: forall a. (Eq a) => [a] -> a -> Bool;
membera [] y = False;
membera (x : xs) y = x == y || membera xs y;

remdups :: forall a. (Eq a) => [a] -> [a];
remdups [] = [];
remdups (x : xs) = (if membera xs x then remdups xs else x : remdups xs);

sorted_list_of_set ::
  forall a. (Ceq a, Ccompare a, Eq a, Linorder a) => Set a -> [a];
sorted_list_of_set (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "sorted_list_of_set RBT_set: ccompare = None"
        (\ _ -> sorted_list_of_set (RBT_set rbt));
    Just _ -> sort_key (\ x -> x) (keysa rbt);
  });
sorted_list_of_set (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "sorted_list_of_set DList_set: ceq = None"
        (\ _ -> sorted_list_of_set (DList_set dxs));
    Just _ -> sort_key (\ x -> x) (list_of_dlist dxs);
  });
sorted_list_of_set (Set_Monad xs) = sort_key (\ x -> x) (remdups xs);

sorted_list_of_fset ::
  forall a. (Ceq a, Ccompare a, Eq a, Linorder a) => Fset a -> [a];
sorted_list_of_fset xa = sorted_list_of_set (fset xa);

ccompare_fset ::
  forall a.
    (Ceq a, Ccompare a, Eq a, Linorder a) => Maybe (Fset a -> Fset a -> Ordera);
ccompare_fset =
  Just (\ a b ->
         let {
           aa = sorted_list_of_fset a;
           ba = sorted_list_of_fset b;
         } in (if less_list aa ba then Lt
                else (if less_list ba aa then Gt else Eqa)));

instance (Ceq a, Ccompare a, Eq a, Linorder a) => Ccompare (Fset a) where {
  ccompare = ccompare_fset;
};

less_eq_list :: forall a. (Eq a, Order a) => [a] -> [a] -> Bool;
less_eq_list (x : xs) (y : ys) = less x y || x == y && less_eq_list xs ys;
less_eq_list [] xs = True;
less_eq_list (x : xs) [] = False;

instance (Eq a, Order a) => Ord [a] where {
  less_eq = less_eq_list;
  less = less_list;
};

comparator_list :: forall a. (a -> a -> Ordera) -> [a] -> [a] -> Ordera;
comparator_list comp_a (x : xa) (y : ya) =
  (case comp_a x y of {
    Eqa -> comparator_list comp_a xa ya;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_list comp_a (x : xa) [] = Gt;
comparator_list comp_a [] (y : ya) = Lt;
comparator_list comp_a [] [] = Eqa;

compare_list :: forall a. (Compare a) => [a] -> [a] -> Ordera;
compare_list = comparator_list compare;

instance (Compare a) => Compare [a] where {
  compare = compare_list;
};

instance (Eq a, Order a) => Preorder [a] where {
};

instance (Eq a, Order a) => Order [a] where {
};

equality_list :: forall a. (a -> a -> Bool) -> [a] -> [a] -> Bool;
equality_list eq_a (x : xa) (y : ya) = eq_a x y && equality_list eq_a xa ya;
equality_list eq_a (x : xa) [] = False;
equality_list eq_a [] (y : ya) = False;
equality_list eq_a [] [] = True;

ceq_list :: forall a. (Ceq a) => Maybe ([a] -> [a] -> Bool);
ceq_list = (case ceq of {
             Nothing -> Nothing;
             Just eq_a -> Just (equality_list eq_a);
           });

instance (Ceq a) => Ceq [a] where {
  ceq = ceq_list;
};

set_impl_list :: forall a. Phantom [a] Set_impla;
set_impl_list = Phantom Set_Choose;

instance Set_impl [a] where {
  set_impl = set_impl_list;
};

instance (Eq a, Linorder a) => Linorder [a] where {
};

finite_UNIV_list :: forall a. Phantom [a] Bool;
finite_UNIV_list = Phantom False;

card_UNIV_list :: forall a. Phantom [a] Nat;
card_UNIV_list = Phantom zero_nat;

instance Finite_UNIV [a] where {
  finite_UNIV = finite_UNIV_list;
};

instance Card_UNIV [a] where {
  card_UNIV = card_UNIV_list;
};

cEnum_list ::
  forall a. Maybe ([[a]], (([a] -> Bool) -> Bool, ([a] -> Bool) -> Bool));
cEnum_list = Nothing;

instance Cenum [a] where {
  cEnum = cEnum_list;
};

ccompare_list :: forall a. (Ccompare a) => Maybe ([a] -> [a] -> Ordera);
ccompare_list = (case ccompare of {
                  Nothing -> Nothing;
                  Just comp_a -> Just (comparator_list comp_a);
                });

instance (Ccompare a) => Ccompare [a] where {
  ccompare = ccompare_list;
};

cproper_interval_list ::
  forall a. (Ccompare a) => Maybe [a] -> Maybe [a] -> Bool;
cproper_interval_list xso yso = error "undefined";

instance (Ccompare a) => Cproper_interval [a] where {
  cproper_interval = cproper_interval_list;
};

data Term a b = Var b | Fun a [Term a b];

instance (Eq a, Eq b) => Eq (Term a b) where {
  a == b = equal_term a b;
};

equal_term :: forall a b. (Eq a, Eq b) => Term a b -> Term a b -> Bool;
equal_term (Var x1) (Fun x21 x22) = False;
equal_term (Fun x21 x22) (Var x1) = False;
equal_term (Fun x21 x22) (Fun y21 y22) = x21 == y21 && x22 == y22;
equal_term (Var x1) (Var y1) = x1 == y1;

comparator_terma ::
  forall a b.
    (a -> a -> Ordera) -> (b -> b -> Ordera) -> Term a b -> Term a b -> Ordera;
comparator_terma comp_f comp_v (Fun x xa) (Fun ya yb) =
  (case comp_f x ya of {
    Eqa -> comparator_list (comparator_terma comp_f comp_v) xa yb;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_terma comp_f comp_v (Fun x xa) (Var y) = Gt;
comparator_terma comp_f comp_v (Var x) (Fun ya yb) = Lt;
comparator_terma comp_f comp_v (Var x) (Var y) = comp_v x y;

compare_term ::
  forall a b. (Compare a, Compare b) => Term a b -> Term a b -> Ordera;
compare_term = comparator_terma compare compare;

less_eq_term ::
  forall a b. (Compare a, Compare b) => Term a b -> Term a b -> Bool;
less_eq_term = le_of_comp compare_term;

less_term :: forall a b. (Compare a, Compare b) => Term a b -> Term a b -> Bool;
less_term = lt_of_comp compare_term;

instance (Compare a, Compare b) => Ord (Term a b) where {
  less_eq = less_eq_term;
  less = less_term;
};

instance (Compare a, Compare b) => Preorder (Term a b) where {
};

instance (Compare a, Compare b) => Order (Term a b) where {
};

ceq_term :: forall a b. (Eq a, Eq b) => Maybe (Term a b -> Term a b -> Bool);
ceq_term = Just equal_term;

instance (Eq a, Eq b) => Ceq (Term a b) where {
  ceq = ceq_term;
};

set_impl_term :: forall a b. Phantom (Term a b) Set_impla;
set_impl_term = Phantom Set_RBT;

instance Set_impl (Term a b) where {
  set_impl = set_impl_term;
};

instance (Compare a, Compare b) => Linorder (Term a b) where {
};

cEnum_term ::
  forall a b.
    Maybe ([Term a b],
            ((Term a b -> Bool) -> Bool, (Term a b -> Bool) -> Bool));
cEnum_term = Nothing;

instance Cenum (Term a b) where {
  cEnum = cEnum_term;
};

finite_UNIV_term :: forall a b. Phantom (Term a b) Bool;
finite_UNIV_term = Phantom False;

instance Finite_UNIV (Term a b) where {
  finite_UNIV = finite_UNIV_term;
};

ccompare_term ::
  forall a b. (Compare a, Compare b) => Maybe (Term a b -> Term a b -> Ordera);
ccompare_term = Just compare_term;

instance (Compare a, Compare b) => Ccompare (Term a b) where {
  ccompare = ccompare_term;
};

cproper_interval_term ::
  forall a b.
    (Compare a, Compare b) => Maybe (Term a b) -> Maybe (Term a b) -> Bool;
cproper_interval_term = (\ _ _ -> False);

instance (Compare a, Compare b) => Cproper_interval (Term a b) where {
  cproper_interval = cproper_interval_term;
};

data Sum a b = Inl a | Inr b;

equal_sum :: forall a b. (Eq a, Eq b) => Sum a b -> Sum a b -> Bool;
equal_sum (Inl x1) (Inr x2) = False;
equal_sum (Inr x2) (Inl x1) = False;
equal_sum (Inr x2) (Inr y2) = x2 == y2;
equal_sum (Inl x1) (Inl y1) = x1 == y1;

instance (Eq a, Eq b) => Eq (Sum a b) where {
  a == b = equal_sum a b;
};

comparator_sum ::
  forall a b.
    (a -> a -> Ordera) -> (b -> b -> Ordera) -> Sum a b -> Sum a b -> Ordera;
comparator_sum comp_a comp_b (Inr x) (Inr ya) = comp_b x ya;
comparator_sum comp_a comp_b (Inr x) (Inl y) = Gt;
comparator_sum comp_a comp_b (Inl x) (Inr ya) = Lt;
comparator_sum comp_a comp_b (Inl x) (Inl y) = comp_a x y;

compare_sum ::
  forall a b. (Compare a, Compare b) => Sum a b -> Sum a b -> Ordera;
compare_sum = comparator_sum compare compare;

less_eq_sum :: forall a b. (Compare a, Compare b) => Sum a b -> Sum a b -> Bool;
less_eq_sum = le_of_comp compare_sum;

less_sum :: forall a b. (Compare a, Compare b) => Sum a b -> Sum a b -> Bool;
less_sum = lt_of_comp compare_sum;

instance (Compare a, Compare b) => Ord (Sum a b) where {
  less_eq = less_eq_sum;
  less = less_sum;
};

instance (Compare a, Compare b) => Compare (Sum a b) where {
  compare = compare_sum;
};

instance (Compare a, Compare b) => Preorder (Sum a b) where {
};

instance (Compare a, Compare b) => Order (Sum a b) where {
};

equality_sum ::
  forall a b.
    (a -> a -> Bool) -> (b -> b -> Bool) -> Sum a b -> Sum a b -> Bool;
equality_sum eq_a eq_b (Inr x) (Inr ya) = eq_b x ya;
equality_sum eq_a eq_b (Inr x) (Inl y) = False;
equality_sum eq_a eq_b (Inl x) (Inr ya) = False;
equality_sum eq_a eq_b (Inl x) (Inl y) = eq_a x y;

ceq_sum :: forall a b. (Ceq a, Ceq b) => Maybe (Sum a b -> Sum a b -> Bool);
ceq_sum = (case ceq of {
            Nothing -> Nothing;
            Just eq_a -> (case ceq of {
                           Nothing -> Nothing;
                           Just eq_b -> Just (equality_sum eq_a eq_b);
                         });
          });

instance (Ceq a, Ceq b) => Ceq (Sum a b) where {
  ceq = ceq_sum;
};

set_impl_choose2 :: Set_impla -> Set_impla -> Set_impla;
set_impl_choose2 Set_Monada Set_Monada = Set_Monada;
set_impl_choose2 Set_RBT Set_RBT = Set_RBT;
set_impl_choose2 Set_DList Set_DList = Set_DList;
set_impl_choose2 Set_Collect Set_Collect = Set_Collect;
set_impl_choose2 x y = Set_Choose;

set_impl_sum ::
  forall a b. (Set_impl a, Set_impl b) => Phantom (Sum a b) Set_impla;
set_impl_sum =
  Phantom
    (set_impl_choose2 (of_phantom (set_impl :: Phantom a Set_impla))
      (of_phantom (set_impl :: Phantom b Set_impla)));

instance (Set_impl a, Set_impl b) => Set_impl (Sum a b) where {
  set_impl = set_impl_sum;
};

instance (Compare a, Compare b) => Linorder (Sum a b) where {
};

finite_UNIV_sum ::
  forall a b. (Finite_UNIV a, Finite_UNIV b) => Phantom (Sum a b) Bool;
finite_UNIV_sum =
  Phantom
    (of_phantom (finite_UNIV :: Phantom a Bool) &&
      of_phantom (finite_UNIV :: Phantom b Bool));

card_UNIV_sum ::
  forall a b. (Card_UNIV a, Card_UNIV b) => Phantom (Sum a b) Nat;
card_UNIV_sum =
  Phantom
    (let {
       ca = of_phantom (card_UNIV :: Phantom a Nat);
       cb = of_phantom (card_UNIV :: Phantom b Nat);
     } in (if not (equal_nat ca zero_nat) && not (equal_nat cb zero_nat)
            then plus_nat ca cb else zero_nat));

instance (Finite_UNIV a, Finite_UNIV b) => Finite_UNIV (Sum a b) where {
  finite_UNIV = finite_UNIV_sum;
};

instance (Card_UNIV a, Card_UNIV b) => Card_UNIV (Sum a b) where {
  card_UNIV = card_UNIV_sum;
};

cEnum_sum ::
  forall a b.
    (Cenum a,
      Cenum b) => Maybe ([Sum a b],
                          ((Sum a b -> Bool) -> Bool,
                            (Sum a b -> Bool) -> Bool));
cEnum_sum =
  (case cEnum of {
    Nothing -> Nothing;
    Just (enum_a, (enum_all_a, enum_ex_a)) ->
      (case cEnum of {
        Nothing -> Nothing;
        Just (enum_b, (enum_all_b, enum_ex_b)) ->
          Just (map Inl enum_a ++ map Inr enum_b,
                 ((\ p ->
                    enum_all_a (\ x -> p (Inl x)) &&
                      enum_all_b (\ x -> p (Inr x))),
                   (\ p ->
                     enum_ex_a (\ x -> p (Inl x)) ||
                       enum_ex_b (\ x -> p (Inr x)))));
      });
  });

instance (Cenum a, Cenum b) => Cenum (Sum a b) where {
  cEnum = cEnum_sum;
};

ccompare_sum ::
  forall a b. (Ccompare a, Ccompare b) => Maybe (Sum a b -> Sum a b -> Ordera);
ccompare_sum =
  (case ccompare of {
    Nothing -> Nothing;
    Just comp_a -> (case ccompare of {
                     Nothing -> Nothing;
                     Just comp_b -> Just (comparator_sum comp_a comp_b);
                   });
  });

instance (Ccompare a, Ccompare b) => Ccompare (Sum a b) where {
  ccompare = ccompare_sum;
};

cproper_interval_sum ::
  forall a b.
    (Cproper_interval a,
      Cproper_interval b) => Maybe (Sum a b) -> Maybe (Sum a b) -> Bool;
cproper_interval_sum Nothing Nothing = True;
cproper_interval_sum Nothing (Just (Inl x)) = cproper_interval Nothing (Just x);
cproper_interval_sum Nothing (Just (Inr y)) = True;
cproper_interval_sum (Just (Inl x)) Nothing = True;
cproper_interval_sum (Just (Inl x)) (Just (Inl y)) =
  cproper_interval (Just x) (Just y);
cproper_interval_sum (Just (Inl x)) (Just (Inr y)) =
  cproper_interval (Just x) Nothing || cproper_interval Nothing (Just y);
cproper_interval_sum (Just (Inr y)) Nothing = cproper_interval (Just y) Nothing;
cproper_interval_sum (Just (Inr y)) (Just (Inl x)) = False;
cproper_interval_sum (Just (Inr x)) (Just (Inr y)) =
  cproper_interval (Just x) (Just y);

instance (Cproper_interval a,
           Cproper_interval b) => Cproper_interval (Sum a b) where {
  cproper_interval = cproper_interval_sum;
};

less_eq_option :: forall a. (Preorder a) => Maybe a -> Maybe a -> Bool;
less_eq_option (Just x) (Just y) = less_eq x y;
less_eq_option (Just x) Nothing = False;
less_eq_option Nothing x = True;

less_option :: forall a. (Preorder a) => Maybe a -> Maybe a -> Bool;
less_option (Just x) (Just y) = less x y;
less_option Nothing (Just x) = True;
less_option x Nothing = False;

instance (Preorder a) => Ord (Maybe a) where {
  less_eq = less_eq_option;
  less = less_option;
};

comparator_option ::
  forall a. (a -> a -> Ordera) -> Maybe a -> Maybe a -> Ordera;
comparator_option comp_a (Just x) (Just y) = comp_a x y;
comparator_option comp_a (Just x) Nothing = Gt;
comparator_option comp_a Nothing (Just y) = Lt;
comparator_option comp_a Nothing Nothing = Eqa;

compare_option :: forall a. (Compare a) => Maybe a -> Maybe a -> Ordera;
compare_option = comparator_option compare;

instance (Compare a) => Compare (Maybe a) where {
  compare = compare_option;
};

instance (Preorder a) => Preorder (Maybe a) where {
};

instance (Order a) => Order (Maybe a) where {
};

equality_option :: forall a. (a -> a -> Bool) -> Maybe a -> Maybe a -> Bool;
equality_option eq_a (Just x) (Just y) = eq_a x y;
equality_option eq_a (Just x) Nothing = False;
equality_option eq_a Nothing (Just y) = False;
equality_option eq_a Nothing Nothing = True;

ceq_option :: forall a. (Ceq a) => Maybe (Maybe a -> Maybe a -> Bool);
ceq_option = (case ceq of {
               Nothing -> Nothing;
               Just eq_a -> Just (equality_option eq_a);
             });

instance (Ceq a) => Ceq (Maybe a) where {
  ceq = ceq_option;
};

set_impl_option :: forall a. (Set_impl a) => Phantom (Maybe a) Set_impla;
set_impl_option = Phantom (of_phantom (set_impl :: Phantom a Set_impla));

instance (Set_impl a) => Set_impl (Maybe a) where {
  set_impl = set_impl_option;
};

instance (Linorder a) => Linorder (Maybe a) where {
};

finite_UNIV_option :: forall a. (Finite_UNIV a) => Phantom (Maybe a) Bool;
finite_UNIV_option = Phantom (of_phantom (finite_UNIV :: Phantom a Bool));

card_UNIV_option :: forall a. (Card_UNIV a) => Phantom (Maybe a) Nat;
card_UNIV_option =
  Phantom (let {
             c = of_phantom (card_UNIV :: Phantom a Nat);
           } in (if not (equal_nat c zero_nat) then suc c else zero_nat));

instance (Finite_UNIV a) => Finite_UNIV (Maybe a) where {
  finite_UNIV = finite_UNIV_option;
};

instance (Card_UNIV a) => Card_UNIV (Maybe a) where {
  card_UNIV = card_UNIV_option;
};

cEnum_option ::
  forall a.
    (Cenum a) => Maybe ([Maybe a],
                         ((Maybe a -> Bool) -> Bool,
                           (Maybe a -> Bool) -> Bool));
cEnum_option =
  (case cEnum of {
    Nothing -> Nothing;
    Just (enum_a, (enum_all_a, enum_ex_a)) ->
      Just (Nothing : map Just enum_a,
             ((\ p -> p Nothing && enum_all_a (\ x -> p (Just x))),
               (\ p -> p Nothing || enum_ex_a (\ x -> p (Just x)))));
  });

instance (Cenum a) => Cenum (Maybe a) where {
  cEnum = cEnum_option;
};

ccompare_option ::
  forall a. (Ccompare a) => Maybe (Maybe a -> Maybe a -> Ordera);
ccompare_option = (case ccompare of {
                    Nothing -> Nothing;
                    Just comp_a -> Just (comparator_option comp_a);
                  });

instance (Ccompare a) => Ccompare (Maybe a) where {
  ccompare = ccompare_option;
};

cproper_interval_option ::
  forall a. (Cproper_interval a) => Maybe (Maybe a) -> Maybe (Maybe a) -> Bool;
cproper_interval_option Nothing Nothing = True;
cproper_interval_option Nothing (Just x) = not (is_none x);
cproper_interval_option (Just x) Nothing = cproper_interval x Nothing;
cproper_interval_option (Just x) (Just Nothing) = False;
cproper_interval_option (Just x) (Just (Just y)) = cproper_interval x (Just y);

instance (Cproper_interval a) => Cproper_interval (Maybe a) where {
  cproper_interval = cproper_interval_option;
};

data Terma a = Vara Nat | App a [Terma a];

instance (Eq a) => Eq (Terma a) where {
  a == b = equal_terma a b;
};

equal_terma :: forall a. (Eq a) => Terma a -> Terma a -> Bool;
equal_terma (Vara x1) (App x21 x22) = False;
equal_terma (App x21 x22) (Vara x1) = False;
equal_terma (App x21 x22) (App y21 y22) = x21 == y21 && x22 == y22;
equal_terma (Vara x1) (Vara y1) = equal_nat x1 y1;

less_eq_prod :: forall a b. (Ord a, Ord b) => (a, b) -> (a, b) -> Bool;
less_eq_prod (x1, y1) (x2, y2) = less x1 x2 || less_eq x1 x2 && less_eq y1 y2;

less_prod :: forall a b. (Ord a, Ord b) => (a, b) -> (a, b) -> Bool;
less_prod (x1, y1) (x2, y2) = less x1 x2 || less_eq x1 x2 && less y1 y2;

instance (Ord a, Ord b) => Ord (a, b) where {
  less_eq = less_eq_prod;
  less = less_prod;
};

comparator_prod ::
  forall a b.
    (a -> a -> Ordera) -> (b -> b -> Ordera) -> (a, b) -> (a, b) -> Ordera;
comparator_prod comp_a comp_b (x, xa) (y, ya) = (case comp_a x y of {
          Eqa -> comp_b xa ya;
          Lt -> Lt;
          Gt -> Gt;
        });

compare_prod ::
  forall a b. (Compare a, Compare b) => (a, b) -> (a, b) -> Ordera;
compare_prod = comparator_prod compare compare;

instance (Compare a, Compare b) => Compare (a, b) where {
  compare = compare_prod;
};

instance (Preorder a, Preorder b) => Preorder (a, b) where {
};

instance (Order a, Order b) => Order (a, b) where {
};

equality_prod ::
  forall a b. (a -> a -> Bool) -> (b -> b -> Bool) -> (a, b) -> (a, b) -> Bool;
equality_prod eq_a eq_b (x, xa) (y, ya) = eq_a x y && eq_b xa ya;

ceq_prod :: forall a b. (Ceq a, Ceq b) => Maybe ((a, b) -> (a, b) -> Bool);
ceq_prod = (case ceq of {
             Nothing -> Nothing;
             Just eq_a -> (case ceq of {
                            Nothing -> Nothing;
                            Just eq_b -> Just (equality_prod eq_a eq_b);
                          });
           });

instance (Ceq a, Ceq b) => Ceq (a, b) where {
  ceq = ceq_prod;
};

set_impl_prod ::
  forall a b. (Set_impl a, Set_impl b) => Phantom (a, b) Set_impla;
set_impl_prod =
  Phantom
    (set_impl_choose2 (of_phantom (set_impl :: Phantom a Set_impla))
      (of_phantom (set_impl :: Phantom b Set_impla)));

instance (Set_impl a, Set_impl b) => Set_impl (a, b) where {
  set_impl = set_impl_prod;
};

instance (Linorder a, Linorder b) => Linorder (a, b) where {
};

finite_UNIV_prod ::
  forall a b. (Finite_UNIV a, Finite_UNIV b) => Phantom (a, b) Bool;
finite_UNIV_prod =
  Phantom
    (of_phantom (finite_UNIV :: Phantom a Bool) &&
      of_phantom (finite_UNIV :: Phantom b Bool));

times_nat :: Nat -> Nat -> Nat;
times_nat m n = Nat (integer_of_nat m * integer_of_nat n);

card_UNIV_prod :: forall a b. (Card_UNIV a, Card_UNIV b) => Phantom (a, b) Nat;
card_UNIV_prod =
  Phantom
    (times_nat (of_phantom (card_UNIV :: Phantom a Nat))
      (of_phantom (card_UNIV :: Phantom b Nat)));

instance (Finite_UNIV a, Finite_UNIV b) => Finite_UNIV (a, b) where {
  finite_UNIV = finite_UNIV_prod;
};

instance (Card_UNIV a, Card_UNIV b) => Card_UNIV (a, b) where {
  card_UNIV = card_UNIV_prod;
};

product :: forall a b. [a] -> [b] -> [(a, b)];
product [] uu = [];
product (x : xs) ys = map (\ a -> (x, a)) ys ++ product xs ys;

cEnum_prod ::
  forall a b.
    (Cenum a,
      Cenum b) => Maybe ([(a, b)],
                          (((a, b) -> Bool) -> Bool, ((a, b) -> Bool) -> Bool));
cEnum_prod =
  (case cEnum of {
    Nothing -> Nothing;
    Just (enum_a, (enum_all_a, enum_ex_a)) ->
      (case cEnum of {
        Nothing -> Nothing;
        Just (enum_b, (enum_all_b, enum_ex_b)) ->
          Just (product enum_a enum_b,
                 ((\ p -> enum_all_a (\ x -> enum_all_b (\ y -> p (x, y)))),
                   (\ p -> enum_ex_a (\ x -> enum_ex_b (\ y -> p (x, y))))));
      });
  });

instance (Cenum a, Cenum b) => Cenum (a, b) where {
  cEnum = cEnum_prod;
};

ccompare_prod ::
  forall a b. (Ccompare a, Ccompare b) => Maybe ((a, b) -> (a, b) -> Ordera);
ccompare_prod =
  (case ccompare of {
    Nothing -> Nothing;
    Just comp_a -> (case ccompare of {
                     Nothing -> Nothing;
                     Just comp_b -> Just (comparator_prod comp_a comp_b);
                   });
  });

instance (Ccompare a, Ccompare b) => Ccompare (a, b) where {
  ccompare = ccompare_prod;
};

cproper_interval_prod ::
  forall a b.
    (Cproper_interval a,
      Cproper_interval b) => Maybe (a, b) -> Maybe (a, b) -> Bool;
cproper_interval_prod Nothing Nothing = True;
cproper_interval_prod Nothing (Just (y1, y2)) =
  cproper_interval Nothing (Just y1) || cproper_interval Nothing (Just y2);
cproper_interval_prod (Just (x1, x2)) Nothing =
  cproper_interval (Just x1) Nothing || cproper_interval (Just x2) Nothing;
cproper_interval_prod (Just (x1, x2)) (Just (y1, y2)) =
  cproper_interval (Just x1) (Just y1) ||
    (lt_of_comp (the ccompare) x1 y1 &&
       (cproper_interval (Just x2) Nothing ||
         cproper_interval Nothing (Just y2)) ||
      not (lt_of_comp (the ccompare) y1 x1) &&
        cproper_interval (Just x2) (Just y2));

instance (Cproper_interval a,
           Cproper_interval b) => Cproper_interval (a, b) where {
  cproper_interval = cproper_interval_prod;
};

less_eq_unit :: () -> () -> Bool;
less_eq_unit uu uv = True;

less_unit :: () -> () -> Bool;
less_unit uu uv = False;

instance Ord () where {
  less_eq = less_eq_unit;
  less = less_unit;
};

comparator_unit :: () -> () -> Ordera;
comparator_unit x y = Eqa;

compare_unit :: () -> () -> Ordera;
compare_unit = comparator_unit;

instance Compare () where {
  compare = compare_unit;
};

instance Preorder () where {
};

instance Order () where {
};

ceq_unit :: Maybe (() -> () -> Bool);
ceq_unit = Just (\ _ _ -> True);

instance Ceq () where {
  ceq = ceq_unit;
};

set_impl_unit :: Phantom () Set_impla;
set_impl_unit = Phantom Set_DList;

instance Set_impl () where {
  set_impl = set_impl_unit;
};

instance Linorder () where {
};

finite_UNIV_unit :: Phantom () Bool;
finite_UNIV_unit = Phantom True;

card_UNIV_unit :: Phantom () Nat;
card_UNIV_unit = Phantom one_nat;

instance Finite_UNIV () where {
  finite_UNIV = finite_UNIV_unit;
};

instance Card_UNIV () where {
  card_UNIV = card_UNIV_unit;
};

enum_all_unit :: (() -> Bool) -> Bool;
enum_all_unit p = p ();

enum_ex_unit :: (() -> Bool) -> Bool;
enum_ex_unit p = p ();

enum_unit :: [()];
enum_unit = [()];

cEnum_unit :: Maybe ([()], ((() -> Bool) -> Bool, (() -> Bool) -> Bool));
cEnum_unit = Just (enum_unit, (enum_all_unit, enum_ex_unit));

instance Cenum () where {
  cEnum = cEnum_unit;
};

ccompare_unit :: Maybe (() -> () -> Ordera);
ccompare_unit = Just compare_unit;

instance Ccompare () where {
  ccompare = ccompare_unit;
};

proper_interval_unit :: Maybe () -> Maybe () -> Bool;
proper_interval_unit Nothing Nothing = True;
proper_interval_unit (Just v) uv = False;
proper_interval_unit uu (Just v) = False;

cproper_interval_unit :: Maybe () -> Maybe () -> Bool;
cproper_interval_unit = proper_interval_unit;

instance Cproper_interval () where {
  cproper_interval = cproper_interval_unit;
};

data Bot_term a = Bot | BFun a [Bot_term a];

instance (Eq a) => Eq (Bot_term a) where {
  a == b = equal_bot_term a b;
};

equal_bot_term :: forall a. (Eq a) => Bot_term a -> Bot_term a -> Bool;
equal_bot_term Bot (BFun x21 x22) = False;
equal_bot_term (BFun x21 x22) Bot = False;
equal_bot_term (BFun x21 x22) (BFun y21 y22) = x21 == y21 && x22 == y22;
equal_bot_term Bot Bot = True;

comparator_bot_term ::
  forall a. (a -> a -> Ordera) -> Bot_term a -> Bot_term a -> Ordera;
comparator_bot_term comp_f (BFun x xa) (BFun y ya) =
  (case comp_f x y of {
    Eqa -> comparator_list (comparator_bot_term comp_f) xa ya;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_bot_term comp_f (BFun x xa) Bot = Gt;
comparator_bot_term comp_f Bot (BFun y ya) = Lt;
comparator_bot_term comp_f Bot Bot = Eqa;

compare_bot_term :: forall a. (Compare a) => Bot_term a -> Bot_term a -> Ordera;
compare_bot_term = comparator_bot_term compare;

less_eq_bot_term :: forall a. (Compare a) => Bot_term a -> Bot_term a -> Bool;
less_eq_bot_term = le_of_comp compare_bot_term;

less_bot_term :: forall a. (Compare a) => Bot_term a -> Bot_term a -> Bool;
less_bot_term = lt_of_comp compare_bot_term;

instance (Compare a) => Ord (Bot_term a) where {
  less_eq = less_eq_bot_term;
  less = less_bot_term;
};

instance (Compare a) => Compare (Bot_term a) where {
  compare = compare_bot_term;
};

instance (Compare a) => Preorder (Bot_term a) where {
};

instance (Compare a) => Order (Bot_term a) where {
};

ceq_bot_term :: forall a. (Eq a) => Maybe (Bot_term a -> Bot_term a -> Bool);
ceq_bot_term = Just equal_bot_term;

instance (Eq a) => Ceq (Bot_term a) where {
  ceq = ceq_bot_term;
};

set_impl_bot_term :: forall a. Phantom (Bot_term a) Set_impla;
set_impl_bot_term = Phantom Set_RBT;

instance Set_impl (Bot_term a) where {
  set_impl = set_impl_bot_term;
};

instance (Compare a) => Linorder (Bot_term a) where {
};

cEnum_bot_term ::
  forall a.
    Maybe ([Bot_term a],
            ((Bot_term a -> Bool) -> Bool, (Bot_term a -> Bool) -> Bool));
cEnum_bot_term = Nothing;

instance Cenum (Bot_term a) where {
  cEnum = cEnum_bot_term;
};

finite_UNIV_bot_term :: forall a. Phantom (Bot_term a) Bool;
finite_UNIV_bot_term = Phantom False;

instance Finite_UNIV (Bot_term a) where {
  finite_UNIV = finite_UNIV_bot_term;
};

ccompare_bot_term ::
  forall a. (Compare a) => Maybe (Bot_term a -> Bot_term a -> Ordera);
ccompare_bot_term = Just compare_bot_term;

instance (Compare a) => Ccompare (Bot_term a) where {
  ccompare = ccompare_bot_term;
};

cproper_interval_bot_term ::
  forall a. (Compare a) => Maybe (Bot_term a) -> Maybe (Bot_term a) -> Bool;
cproper_interval_bot_term = (\ _ _ -> False);

instance (Compare a) => Cproper_interval (Bot_term a) where {
  cproper_interval = cproper_interval_bot_term;
};

instance Preorder Integer where {
};

instance Order Integer where {
};

instance Linorder Integer where {
};

compare_integer :: Integer -> Integer -> Ordera;
compare_integer = comparator_of;

instance Compare Integer where {
  compare = compare_integer;
};

ceq_integer :: Maybe (Integer -> Integer -> Bool);
ceq_integer = Just (\ a b -> a == b);

instance Ceq Integer where {
  ceq = ceq_integer;
};

ccompare_integer :: Maybe (Integer -> Integer -> Ordera);
ccompare_integer = Just compare_integer;

instance Ccompare Integer where {
  ccompare = ccompare_integer;
};

data Ftrs = Fwd Nat | Bwd Nat;

equal_ftrs :: Ftrs -> Ftrs -> Bool;
equal_ftrs (Fwd x1) (Bwd x2) = False;
equal_ftrs (Bwd x2) (Fwd x1) = False;
equal_ftrs (Bwd x2) (Bwd y2) = equal_nat x2 y2;
equal_ftrs (Fwd x1) (Fwd y1) = equal_nat x1 y1;

instance Eq Ftrs where {
  a == b = equal_ftrs a b;
};

comparator_ftrs :: Ftrs -> Ftrs -> Ordera;
comparator_ftrs (Bwd x) (Bwd ya) = comparator_of x ya;
comparator_ftrs (Bwd x) (Fwd y) = Gt;
comparator_ftrs (Fwd x) (Bwd ya) = Lt;
comparator_ftrs (Fwd x) (Fwd y) = comparator_of x y;

compare_ftrs :: Ftrs -> Ftrs -> Ordera;
compare_ftrs = comparator_ftrs;

instance Compare Ftrs where {
  compare = compare_ftrs;
};

data Ta_rule a b = TA_rule b [a] a;

equal_ta_rule :: forall a b. (Eq a, Eq b) => Ta_rule a b -> Ta_rule a b -> Bool;
equal_ta_rule (TA_rule x1 x2 x3) (TA_rule y1 y2 y3) =
  x1 == y1 && x2 == y2 && x3 == y3;

instance (Eq a, Eq b) => Eq (Ta_rule a b) where {
  a == b = equal_ta_rule a b;
};

comparator_ta_rule ::
  forall a b.
    (a -> a -> Ordera) ->
      (b -> b -> Ordera) -> Ta_rule a b -> Ta_rule a b -> Ordera;
comparator_ta_rule comp_q comp_f (TA_rule x xa xb) (TA_rule y ya yb) =
  (case comp_f x y of {
    Eqa -> (case comparator_list comp_q xa ya of {
             Eqa -> comp_q xb yb;
             Lt -> Lt;
             Gt -> Gt;
           });
    Lt -> Lt;
    Gt -> Gt;
  });

less_eq_ta_rule ::
  forall a b.
    (Eq a, Linorder a, Eq b, Linorder b) => Ta_rule a b -> Ta_rule a b -> Bool;
less_eq_ta_rule = le_of_comp (comparator_ta_rule comparator_of comparator_of);

less_ta_rule ::
  forall a b.
    (Eq a, Linorder a, Eq b, Linorder b) => Ta_rule a b -> Ta_rule a b -> Bool;
less_ta_rule = lt_of_comp (comparator_ta_rule comparator_of comparator_of);

instance (Eq a, Linorder a, Eq b, Linorder b) => Ord (Ta_rule a b) where {
  less_eq = less_eq_ta_rule;
  less = less_ta_rule;
};

instance (Eq a, Linorder a, Eq b, Linorder b) => Preorder (Ta_rule a b) where {
};

instance (Eq a, Linorder a, Eq b, Linorder b) => Order (Ta_rule a b) where {
};

equality_ta_rule ::
  forall a b.
    (a -> a -> Bool) -> (b -> b -> Bool) -> Ta_rule a b -> Ta_rule a b -> Bool;
equality_ta_rule eq_q eq_f (TA_rule x xa xb) (TA_rule y ya yb) =
  eq_f x y && equality_list eq_q xa ya && eq_q xb yb;

ceq_ta_rule ::
  forall a b. (Ceq a, Ceq b) => Maybe (Ta_rule a b -> Ta_rule a b -> Bool);
ceq_ta_rule = (case ceq of {
                Nothing -> Nothing;
                Just eq_q -> (case ceq of {
                               Nothing -> Nothing;
                               Just eq_f -> Just (equality_ta_rule eq_q eq_f);
                             });
              });

instance (Ceq a, Ceq b) => Ceq (Ta_rule a b) where {
  ceq = ceq_ta_rule;
};

set_impl_ta_rule :: forall a b. Phantom (Ta_rule a b) Set_impla;
set_impl_ta_rule = Phantom Set_RBT;

instance Set_impl (Ta_rule a b) where {
  set_impl = set_impl_ta_rule;
};

instance (Eq a, Linorder a, Eq b, Linorder b) => Linorder (Ta_rule a b) where {
};

cEnum_ta_rule ::
  forall a b.
    Maybe ([Ta_rule a b],
            ((Ta_rule a b -> Bool) -> Bool, (Ta_rule a b -> Bool) -> Bool));
cEnum_ta_rule = Nothing;

instance Cenum (Ta_rule a b) where {
  cEnum = cEnum_ta_rule;
};

finite_UNIV_ta_rule :: forall a b. Phantom (Ta_rule a b) Bool;
finite_UNIV_ta_rule = Phantom False;

instance Finite_UNIV (Ta_rule a b) where {
  finite_UNIV = finite_UNIV_ta_rule;
};

ccompare_ta_rule ::
  forall a b.
    (Ccompare a, Ccompare b) => Maybe (Ta_rule a b -> Ta_rule a b -> Ordera);
ccompare_ta_rule =
  (case ccompare of {
    Nothing -> Nothing;
    Just comp_q -> (case ccompare of {
                     Nothing -> Nothing;
                     Just comp_f -> Just (comparator_ta_rule comp_q comp_f);
                   });
  });

instance (Ccompare a, Ccompare b) => Ccompare (Ta_rule a b) where {
  ccompare = ccompare_ta_rule;
};

cproper_interval_ta_rule ::
  forall a b.
    (Ccompare a,
      Ccompare b) => Maybe (Ta_rule a b) -> Maybe (Ta_rule a b) -> Bool;
cproper_interval_ta_rule = (\ _ _ -> False);

instance (Ccompare a, Ccompare b) => Cproper_interval (Ta_rule a b) where {
  cproper_interval = cproper_interval_ta_rule;
};

data Form_list_aci a b = TT_aci | FF_aci | Pred_aci Bool b [Terma a]
  | And_aci [Form_list_aci a b] | Or_aci [Form_list_aci a b]
  | Forall_aci (Form_list_aci a b) | Exists_aci (Form_list_aci a b);

instance (Eq a, Eq b) => Eq (Form_list_aci a b) where {
  a == b = equal_form_list_aci a b;
};

equal_form_list_aci ::
  forall a b. (Eq a, Eq b) => Form_list_aci a b -> Form_list_aci a b -> Bool;
equal_form_list_aci (Forall_aci x6) (Exists_aci x7) = False;
equal_form_list_aci (Exists_aci x7) (Forall_aci x6) = False;
equal_form_list_aci (Or_aci x5) (Exists_aci x7) = False;
equal_form_list_aci (Exists_aci x7) (Or_aci x5) = False;
equal_form_list_aci (Or_aci x5) (Forall_aci x6) = False;
equal_form_list_aci (Forall_aci x6) (Or_aci x5) = False;
equal_form_list_aci (And_aci x4) (Exists_aci x7) = False;
equal_form_list_aci (Exists_aci x7) (And_aci x4) = False;
equal_form_list_aci (And_aci x4) (Forall_aci x6) = False;
equal_form_list_aci (Forall_aci x6) (And_aci x4) = False;
equal_form_list_aci (And_aci x4) (Or_aci x5) = False;
equal_form_list_aci (Or_aci x5) (And_aci x4) = False;
equal_form_list_aci (Pred_aci x31 x32 x33) (Exists_aci x7) = False;
equal_form_list_aci (Exists_aci x7) (Pred_aci x31 x32 x33) = False;
equal_form_list_aci (Pred_aci x31 x32 x33) (Forall_aci x6) = False;
equal_form_list_aci (Forall_aci x6) (Pred_aci x31 x32 x33) = False;
equal_form_list_aci (Pred_aci x31 x32 x33) (Or_aci x5) = False;
equal_form_list_aci (Or_aci x5) (Pred_aci x31 x32 x33) = False;
equal_form_list_aci (Pred_aci x31 x32 x33) (And_aci x4) = False;
equal_form_list_aci (And_aci x4) (Pred_aci x31 x32 x33) = False;
equal_form_list_aci FF_aci (Exists_aci x7) = False;
equal_form_list_aci (Exists_aci x7) FF_aci = False;
equal_form_list_aci FF_aci (Forall_aci x6) = False;
equal_form_list_aci (Forall_aci x6) FF_aci = False;
equal_form_list_aci FF_aci (Or_aci x5) = False;
equal_form_list_aci (Or_aci x5) FF_aci = False;
equal_form_list_aci FF_aci (And_aci x4) = False;
equal_form_list_aci (And_aci x4) FF_aci = False;
equal_form_list_aci FF_aci (Pred_aci x31 x32 x33) = False;
equal_form_list_aci (Pred_aci x31 x32 x33) FF_aci = False;
equal_form_list_aci TT_aci (Exists_aci x7) = False;
equal_form_list_aci (Exists_aci x7) TT_aci = False;
equal_form_list_aci TT_aci (Forall_aci x6) = False;
equal_form_list_aci (Forall_aci x6) TT_aci = False;
equal_form_list_aci TT_aci (Or_aci x5) = False;
equal_form_list_aci (Or_aci x5) TT_aci = False;
equal_form_list_aci TT_aci (And_aci x4) = False;
equal_form_list_aci (And_aci x4) TT_aci = False;
equal_form_list_aci TT_aci (Pred_aci x31 x32 x33) = False;
equal_form_list_aci (Pred_aci x31 x32 x33) TT_aci = False;
equal_form_list_aci TT_aci FF_aci = False;
equal_form_list_aci FF_aci TT_aci = False;
equal_form_list_aci (Exists_aci x7) (Exists_aci y7) = equal_form_list_aci x7 y7;
equal_form_list_aci (Forall_aci x6) (Forall_aci y6) = equal_form_list_aci x6 y6;
equal_form_list_aci (Or_aci x5) (Or_aci y5) = x5 == y5;
equal_form_list_aci (And_aci x4) (And_aci y4) = x4 == y4;
equal_form_list_aci (Pred_aci x31 x32 x33) (Pred_aci y31 y32 y33) =
  x31 == y31 && x32 == y32 && x33 == y33;
equal_form_list_aci FF_aci FF_aci = True;
equal_form_list_aci TT_aci TT_aci = True;

comparator_term :: forall a. (a -> a -> Ordera) -> Terma a -> Terma a -> Ordera;
comparator_term comp_a (App x xa) (App ya yb) =
  (case comp_a x ya of {
    Eqa -> comparator_list (comparator_term comp_a) xa yb;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_term comp_a (App x xa) (Vara y) = Gt;
comparator_term comp_a (Vara x) (App ya yb) = Lt;
comparator_term comp_a (Vara x) (Vara y) = comparator_of x y;

comparator_form_list_aci ::
  forall a b.
    (a -> a -> Ordera) ->
      (b -> b -> Ordera) -> Form_list_aci a b -> Form_list_aci a b -> Ordera;
comparator_form_list_aci comp_a comp_b (Exists_aci x) (Exists_aci yf) =
  comparator_form_list_aci comp_a comp_b x yf;
comparator_form_list_aci comp_a comp_b (Exists_aci x) (Forall_aci ye) = Gt;
comparator_form_list_aci comp_a comp_b (Exists_aci x) (Or_aci yd) = Gt;
comparator_form_list_aci comp_a comp_b (Exists_aci x) (And_aci yc) = Gt;
comparator_form_list_aci comp_a comp_b (Exists_aci x) (Pred_aci y ya yb) = Gt;
comparator_form_list_aci comp_a comp_b (Exists_aci x) FF_aci = Gt;
comparator_form_list_aci comp_a comp_b (Exists_aci x) TT_aci = Gt;
comparator_form_list_aci comp_a comp_b (Forall_aci x) (Exists_aci yf) = Lt;
comparator_form_list_aci comp_a comp_b (Forall_aci x) (Forall_aci ye) =
  comparator_form_list_aci comp_a comp_b x ye;
comparator_form_list_aci comp_a comp_b (Forall_aci x) (Or_aci yd) = Gt;
comparator_form_list_aci comp_a comp_b (Forall_aci x) (And_aci yc) = Gt;
comparator_form_list_aci comp_a comp_b (Forall_aci x) (Pred_aci y ya yb) = Gt;
comparator_form_list_aci comp_a comp_b (Forall_aci x) FF_aci = Gt;
comparator_form_list_aci comp_a comp_b (Forall_aci x) TT_aci = Gt;
comparator_form_list_aci comp_a comp_b (Or_aci x) (Exists_aci yf) = Lt;
comparator_form_list_aci comp_a comp_b (Or_aci x) (Forall_aci ye) = Lt;
comparator_form_list_aci comp_a comp_b (Or_aci x) (Or_aci yd) =
  comparator_list (comparator_form_list_aci comp_a comp_b) x yd;
comparator_form_list_aci comp_a comp_b (Or_aci x) (And_aci yc) = Gt;
comparator_form_list_aci comp_a comp_b (Or_aci x) (Pred_aci y ya yb) = Gt;
comparator_form_list_aci comp_a comp_b (Or_aci x) FF_aci = Gt;
comparator_form_list_aci comp_a comp_b (Or_aci x) TT_aci = Gt;
comparator_form_list_aci comp_a comp_b (And_aci x) (Exists_aci yf) = Lt;
comparator_form_list_aci comp_a comp_b (And_aci x) (Forall_aci ye) = Lt;
comparator_form_list_aci comp_a comp_b (And_aci x) (Or_aci yd) = Lt;
comparator_form_list_aci comp_a comp_b (And_aci x) (And_aci yc) =
  comparator_list (comparator_form_list_aci comp_a comp_b) x yc;
comparator_form_list_aci comp_a comp_b (And_aci x) (Pred_aci y ya yb) = Gt;
comparator_form_list_aci comp_a comp_b (And_aci x) FF_aci = Gt;
comparator_form_list_aci comp_a comp_b (And_aci x) TT_aci = Gt;
comparator_form_list_aci comp_a comp_b (Pred_aci x xa xb) (Exists_aci yf) = Lt;
comparator_form_list_aci comp_a comp_b (Pred_aci x xa xb) (Forall_aci ye) = Lt;
comparator_form_list_aci comp_a comp_b (Pred_aci x xa xb) (Or_aci yd) = Lt;
comparator_form_list_aci comp_a comp_b (Pred_aci x xa xb) (And_aci yc) = Lt;
comparator_form_list_aci comp_a comp_b (Pred_aci x xa xb) (Pred_aci y ya yb) =
  (case comparator_bool x y of {
    Eqa -> (case comp_b xa ya of {
             Eqa -> comparator_list (comparator_term comp_a) xb yb;
             Lt -> Lt;
             Gt -> Gt;
           });
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_form_list_aci comp_a comp_b (Pred_aci x xa xb) FF_aci = Gt;
comparator_form_list_aci comp_a comp_b (Pred_aci x xa xb) TT_aci = Gt;
comparator_form_list_aci comp_a comp_b FF_aci (Exists_aci yf) = Lt;
comparator_form_list_aci comp_a comp_b FF_aci (Forall_aci ye) = Lt;
comparator_form_list_aci comp_a comp_b FF_aci (Or_aci yd) = Lt;
comparator_form_list_aci comp_a comp_b FF_aci (And_aci yc) = Lt;
comparator_form_list_aci comp_a comp_b FF_aci (Pred_aci y ya yb) = Lt;
comparator_form_list_aci comp_a comp_b FF_aci FF_aci = Eqa;
comparator_form_list_aci comp_a comp_b FF_aci TT_aci = Gt;
comparator_form_list_aci comp_a comp_b TT_aci (Exists_aci yf) = Lt;
comparator_form_list_aci comp_a comp_b TT_aci (Forall_aci ye) = Lt;
comparator_form_list_aci comp_a comp_b TT_aci (Or_aci yd) = Lt;
comparator_form_list_aci comp_a comp_b TT_aci (And_aci yc) = Lt;
comparator_form_list_aci comp_a comp_b TT_aci (Pred_aci y ya yb) = Lt;
comparator_form_list_aci comp_a comp_b TT_aci FF_aci = Lt;
comparator_form_list_aci comp_a comp_b TT_aci TT_aci = Eqa;

less_eq_form_list_aci ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Linorder b) => Form_list_aci a b -> Form_list_aci a b -> Bool;
less_eq_form_list_aci =
  le_of_comp (comparator_form_list_aci comparator_of comparator_of);

less_form_list_aci ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Linorder b) => Form_list_aci a b -> Form_list_aci a b -> Bool;
less_form_list_aci =
  lt_of_comp (comparator_form_list_aci comparator_of comparator_of);

instance (Eq a, Linorder a, Eq b, Linorder b) => Ord (Form_list_aci a b) where {
  less_eq = less_eq_form_list_aci;
  less = less_form_list_aci;
};

instance (Eq a, Linorder a, Eq b,
           Linorder b) => Preorder (Form_list_aci a b) where {
};

instance (Eq a, Linorder a, Eq b,
           Linorder b) => Order (Form_list_aci a b) where {
};

instance (Eq a, Linorder a, Eq b,
           Linorder b) => Linorder (Form_list_aci a b) where {
};

data Pos_step = PRoot | PNonRoot | PAny;

equal_pos_step :: Pos_step -> Pos_step -> Bool;
equal_pos_step PNonRoot PAny = False;
equal_pos_step PAny PNonRoot = False;
equal_pos_step PRoot PAny = False;
equal_pos_step PAny PRoot = False;
equal_pos_step PRoot PNonRoot = False;
equal_pos_step PNonRoot PRoot = False;
equal_pos_step PAny PAny = True;
equal_pos_step PNonRoot PNonRoot = True;
equal_pos_step PRoot PRoot = True;

data Ext_step = ESingle | EParallel | EStrictParallel;

equal_ext_step :: Ext_step -> Ext_step -> Bool;
equal_ext_step EParallel EStrictParallel = False;
equal_ext_step EStrictParallel EParallel = False;
equal_ext_step ESingle EStrictParallel = False;
equal_ext_step EStrictParallel ESingle = False;
equal_ext_step ESingle EParallel = False;
equal_ext_step EParallel ESingle = False;
equal_ext_step EStrictParallel EStrictParallel = True;
equal_ext_step EParallel EParallel = True;
equal_ext_step ESingle ESingle = True;

data Gtt_rel a = ARoot [a] | GInv (Gtt_rel a) | AUnion (Gtt_rel a) (Gtt_rel a)
  | ATrancl (Gtt_rel a) | GTrancl (Gtt_rel a) | AComp (Gtt_rel a) (Gtt_rel a)
  | GComp (Gtt_rel a) (Gtt_rel a);

data Rr1_rel a = R1Terms | R1NF [a] | R1Inf (Rr2_rel a) | R1Proj Nat (Rr2_rel a)
  | R1Union (Rr1_rel a) (Rr1_rel a) | R1Inter (Rr1_rel a) (Rr1_rel a)
  | R1Diff (Rr1_rel a) (Rr1_rel a);

data Rr2_rel a = R2GTT_Rel (Gtt_rel a) Pos_step Ext_step | R2Diag (Rr1_rel a)
  | R2Prod (Rr1_rel a) (Rr1_rel a) | R2Inv (Rr2_rel a)
  | R2Union (Rr2_rel a) (Rr2_rel a) | R2Inter (Rr2_rel a) (Rr2_rel a)
  | R2Diff (Rr2_rel a) (Rr2_rel a) | R2Comp (Rr2_rel a) (Rr2_rel a);

equal_gtt_rel :: forall a. (Eq a) => Gtt_rel a -> Gtt_rel a -> Bool;
equal_gtt_rel (AComp x61 x62) (GComp x71 x72) = False;
equal_gtt_rel (GComp x71 x72) (AComp x61 x62) = False;
equal_gtt_rel (GTrancl x5) (GComp x71 x72) = False;
equal_gtt_rel (GComp x71 x72) (GTrancl x5) = False;
equal_gtt_rel (GTrancl x5) (AComp x61 x62) = False;
equal_gtt_rel (AComp x61 x62) (GTrancl x5) = False;
equal_gtt_rel (ATrancl x4) (GComp x71 x72) = False;
equal_gtt_rel (GComp x71 x72) (ATrancl x4) = False;
equal_gtt_rel (ATrancl x4) (AComp x61 x62) = False;
equal_gtt_rel (AComp x61 x62) (ATrancl x4) = False;
equal_gtt_rel (ATrancl x4) (GTrancl x5) = False;
equal_gtt_rel (GTrancl x5) (ATrancl x4) = False;
equal_gtt_rel (AUnion x31 x32) (GComp x71 x72) = False;
equal_gtt_rel (GComp x71 x72) (AUnion x31 x32) = False;
equal_gtt_rel (AUnion x31 x32) (AComp x61 x62) = False;
equal_gtt_rel (AComp x61 x62) (AUnion x31 x32) = False;
equal_gtt_rel (AUnion x31 x32) (GTrancl x5) = False;
equal_gtt_rel (GTrancl x5) (AUnion x31 x32) = False;
equal_gtt_rel (AUnion x31 x32) (ATrancl x4) = False;
equal_gtt_rel (ATrancl x4) (AUnion x31 x32) = False;
equal_gtt_rel (GInv x2) (GComp x71 x72) = False;
equal_gtt_rel (GComp x71 x72) (GInv x2) = False;
equal_gtt_rel (GInv x2) (AComp x61 x62) = False;
equal_gtt_rel (AComp x61 x62) (GInv x2) = False;
equal_gtt_rel (GInv x2) (GTrancl x5) = False;
equal_gtt_rel (GTrancl x5) (GInv x2) = False;
equal_gtt_rel (GInv x2) (ATrancl x4) = False;
equal_gtt_rel (ATrancl x4) (GInv x2) = False;
equal_gtt_rel (GInv x2) (AUnion x31 x32) = False;
equal_gtt_rel (AUnion x31 x32) (GInv x2) = False;
equal_gtt_rel (ARoot x1) (GComp x71 x72) = False;
equal_gtt_rel (GComp x71 x72) (ARoot x1) = False;
equal_gtt_rel (ARoot x1) (AComp x61 x62) = False;
equal_gtt_rel (AComp x61 x62) (ARoot x1) = False;
equal_gtt_rel (ARoot x1) (GTrancl x5) = False;
equal_gtt_rel (GTrancl x5) (ARoot x1) = False;
equal_gtt_rel (ARoot x1) (ATrancl x4) = False;
equal_gtt_rel (ATrancl x4) (ARoot x1) = False;
equal_gtt_rel (ARoot x1) (AUnion x31 x32) = False;
equal_gtt_rel (AUnion x31 x32) (ARoot x1) = False;
equal_gtt_rel (ARoot x1) (GInv x2) = False;
equal_gtt_rel (GInv x2) (ARoot x1) = False;
equal_gtt_rel (GComp x71 x72) (GComp y71 y72) =
  equal_gtt_rel x71 y71 && equal_gtt_rel x72 y72;
equal_gtt_rel (AComp x61 x62) (AComp y61 y62) =
  equal_gtt_rel x61 y61 && equal_gtt_rel x62 y62;
equal_gtt_rel (GTrancl x5) (GTrancl y5) = equal_gtt_rel x5 y5;
equal_gtt_rel (ATrancl x4) (ATrancl y4) = equal_gtt_rel x4 y4;
equal_gtt_rel (AUnion x31 x32) (AUnion y31 y32) =
  equal_gtt_rel x31 y31 && equal_gtt_rel x32 y32;
equal_gtt_rel (GInv x2) (GInv y2) = equal_gtt_rel x2 y2;
equal_gtt_rel (ARoot x1) (ARoot y1) = x1 == y1;

equal_rr2_rel :: forall a. (Eq a) => Rr2_rel a -> Rr2_rel a -> Bool;
equal_rr2_rel (R2Diff x71 x72) (R2Comp x81 x82) = False;
equal_rr2_rel (R2Comp x81 x82) (R2Diff x71 x72) = False;
equal_rr2_rel (R2Inter x61 x62) (R2Comp x81 x82) = False;
equal_rr2_rel (R2Comp x81 x82) (R2Inter x61 x62) = False;
equal_rr2_rel (R2Inter x61 x62) (R2Diff x71 x72) = False;
equal_rr2_rel (R2Diff x71 x72) (R2Inter x61 x62) = False;
equal_rr2_rel (R2Union x51 x52) (R2Comp x81 x82) = False;
equal_rr2_rel (R2Comp x81 x82) (R2Union x51 x52) = False;
equal_rr2_rel (R2Union x51 x52) (R2Diff x71 x72) = False;
equal_rr2_rel (R2Diff x71 x72) (R2Union x51 x52) = False;
equal_rr2_rel (R2Union x51 x52) (R2Inter x61 x62) = False;
equal_rr2_rel (R2Inter x61 x62) (R2Union x51 x52) = False;
equal_rr2_rel (R2Inv x4) (R2Comp x81 x82) = False;
equal_rr2_rel (R2Comp x81 x82) (R2Inv x4) = False;
equal_rr2_rel (R2Inv x4) (R2Diff x71 x72) = False;
equal_rr2_rel (R2Diff x71 x72) (R2Inv x4) = False;
equal_rr2_rel (R2Inv x4) (R2Inter x61 x62) = False;
equal_rr2_rel (R2Inter x61 x62) (R2Inv x4) = False;
equal_rr2_rel (R2Inv x4) (R2Union x51 x52) = False;
equal_rr2_rel (R2Union x51 x52) (R2Inv x4) = False;
equal_rr2_rel (R2Prod x31 x32) (R2Comp x81 x82) = False;
equal_rr2_rel (R2Comp x81 x82) (R2Prod x31 x32) = False;
equal_rr2_rel (R2Prod x31 x32) (R2Diff x71 x72) = False;
equal_rr2_rel (R2Diff x71 x72) (R2Prod x31 x32) = False;
equal_rr2_rel (R2Prod x31 x32) (R2Inter x61 x62) = False;
equal_rr2_rel (R2Inter x61 x62) (R2Prod x31 x32) = False;
equal_rr2_rel (R2Prod x31 x32) (R2Union x51 x52) = False;
equal_rr2_rel (R2Union x51 x52) (R2Prod x31 x32) = False;
equal_rr2_rel (R2Prod x31 x32) (R2Inv x4) = False;
equal_rr2_rel (R2Inv x4) (R2Prod x31 x32) = False;
equal_rr2_rel (R2Diag x2) (R2Comp x81 x82) = False;
equal_rr2_rel (R2Comp x81 x82) (R2Diag x2) = False;
equal_rr2_rel (R2Diag x2) (R2Diff x71 x72) = False;
equal_rr2_rel (R2Diff x71 x72) (R2Diag x2) = False;
equal_rr2_rel (R2Diag x2) (R2Inter x61 x62) = False;
equal_rr2_rel (R2Inter x61 x62) (R2Diag x2) = False;
equal_rr2_rel (R2Diag x2) (R2Union x51 x52) = False;
equal_rr2_rel (R2Union x51 x52) (R2Diag x2) = False;
equal_rr2_rel (R2Diag x2) (R2Inv x4) = False;
equal_rr2_rel (R2Inv x4) (R2Diag x2) = False;
equal_rr2_rel (R2Diag x2) (R2Prod x31 x32) = False;
equal_rr2_rel (R2Prod x31 x32) (R2Diag x2) = False;
equal_rr2_rel (R2GTT_Rel x11 x12 x13) (R2Comp x81 x82) = False;
equal_rr2_rel (R2Comp x81 x82) (R2GTT_Rel x11 x12 x13) = False;
equal_rr2_rel (R2GTT_Rel x11 x12 x13) (R2Diff x71 x72) = False;
equal_rr2_rel (R2Diff x71 x72) (R2GTT_Rel x11 x12 x13) = False;
equal_rr2_rel (R2GTT_Rel x11 x12 x13) (R2Inter x61 x62) = False;
equal_rr2_rel (R2Inter x61 x62) (R2GTT_Rel x11 x12 x13) = False;
equal_rr2_rel (R2GTT_Rel x11 x12 x13) (R2Union x51 x52) = False;
equal_rr2_rel (R2Union x51 x52) (R2GTT_Rel x11 x12 x13) = False;
equal_rr2_rel (R2GTT_Rel x11 x12 x13) (R2Inv x4) = False;
equal_rr2_rel (R2Inv x4) (R2GTT_Rel x11 x12 x13) = False;
equal_rr2_rel (R2GTT_Rel x11 x12 x13) (R2Prod x31 x32) = False;
equal_rr2_rel (R2Prod x31 x32) (R2GTT_Rel x11 x12 x13) = False;
equal_rr2_rel (R2GTT_Rel x11 x12 x13) (R2Diag x2) = False;
equal_rr2_rel (R2Diag x2) (R2GTT_Rel x11 x12 x13) = False;
equal_rr2_rel (R2Comp x81 x82) (R2Comp y81 y82) =
  equal_rr2_rel x81 y81 && equal_rr2_rel x82 y82;
equal_rr2_rel (R2Diff x71 x72) (R2Diff y71 y72) =
  equal_rr2_rel x71 y71 && equal_rr2_rel x72 y72;
equal_rr2_rel (R2Inter x61 x62) (R2Inter y61 y62) =
  equal_rr2_rel x61 y61 && equal_rr2_rel x62 y62;
equal_rr2_rel (R2Union x51 x52) (R2Union y51 y52) =
  equal_rr2_rel x51 y51 && equal_rr2_rel x52 y52;
equal_rr2_rel (R2Inv x4) (R2Inv y4) = equal_rr2_rel x4 y4;
equal_rr2_rel (R2Prod x31 x32) (R2Prod y31 y32) =
  equal_rr1_rel x31 y31 && equal_rr1_rel x32 y32;
equal_rr2_rel (R2Diag x2) (R2Diag y2) = equal_rr1_rel x2 y2;
equal_rr2_rel (R2GTT_Rel x11 x12 x13) (R2GTT_Rel y11 y12 y13) =
  equal_gtt_rel x11 y11 && equal_pos_step x12 y12 && equal_ext_step x13 y13;

equal_rr1_rel :: forall a. (Eq a) => Rr1_rel a -> Rr1_rel a -> Bool;
equal_rr1_rel (R1Inter x61 x62) (R1Diff x71 x72) = False;
equal_rr1_rel (R1Diff x71 x72) (R1Inter x61 x62) = False;
equal_rr1_rel (R1Union x51 x52) (R1Diff x71 x72) = False;
equal_rr1_rel (R1Diff x71 x72) (R1Union x51 x52) = False;
equal_rr1_rel (R1Union x51 x52) (R1Inter x61 x62) = False;
equal_rr1_rel (R1Inter x61 x62) (R1Union x51 x52) = False;
equal_rr1_rel (R1Proj x41 x42) (R1Diff x71 x72) = False;
equal_rr1_rel (R1Diff x71 x72) (R1Proj x41 x42) = False;
equal_rr1_rel (R1Proj x41 x42) (R1Inter x61 x62) = False;
equal_rr1_rel (R1Inter x61 x62) (R1Proj x41 x42) = False;
equal_rr1_rel (R1Proj x41 x42) (R1Union x51 x52) = False;
equal_rr1_rel (R1Union x51 x52) (R1Proj x41 x42) = False;
equal_rr1_rel (R1Inf x3) (R1Diff x71 x72) = False;
equal_rr1_rel (R1Diff x71 x72) (R1Inf x3) = False;
equal_rr1_rel (R1Inf x3) (R1Inter x61 x62) = False;
equal_rr1_rel (R1Inter x61 x62) (R1Inf x3) = False;
equal_rr1_rel (R1Inf x3) (R1Union x51 x52) = False;
equal_rr1_rel (R1Union x51 x52) (R1Inf x3) = False;
equal_rr1_rel (R1Inf x3) (R1Proj x41 x42) = False;
equal_rr1_rel (R1Proj x41 x42) (R1Inf x3) = False;
equal_rr1_rel (R1NF x2) (R1Diff x71 x72) = False;
equal_rr1_rel (R1Diff x71 x72) (R1NF x2) = False;
equal_rr1_rel (R1NF x2) (R1Inter x61 x62) = False;
equal_rr1_rel (R1Inter x61 x62) (R1NF x2) = False;
equal_rr1_rel (R1NF x2) (R1Union x51 x52) = False;
equal_rr1_rel (R1Union x51 x52) (R1NF x2) = False;
equal_rr1_rel (R1NF x2) (R1Proj x41 x42) = False;
equal_rr1_rel (R1Proj x41 x42) (R1NF x2) = False;
equal_rr1_rel (R1NF x2) (R1Inf x3) = False;
equal_rr1_rel (R1Inf x3) (R1NF x2) = False;
equal_rr1_rel R1Terms (R1Diff x71 x72) = False;
equal_rr1_rel (R1Diff x71 x72) R1Terms = False;
equal_rr1_rel R1Terms (R1Inter x61 x62) = False;
equal_rr1_rel (R1Inter x61 x62) R1Terms = False;
equal_rr1_rel R1Terms (R1Union x51 x52) = False;
equal_rr1_rel (R1Union x51 x52) R1Terms = False;
equal_rr1_rel R1Terms (R1Proj x41 x42) = False;
equal_rr1_rel (R1Proj x41 x42) R1Terms = False;
equal_rr1_rel R1Terms (R1Inf x3) = False;
equal_rr1_rel (R1Inf x3) R1Terms = False;
equal_rr1_rel R1Terms (R1NF x2) = False;
equal_rr1_rel (R1NF x2) R1Terms = False;
equal_rr1_rel (R1Diff x71 x72) (R1Diff y71 y72) =
  equal_rr1_rel x71 y71 && equal_rr1_rel x72 y72;
equal_rr1_rel (R1Inter x61 x62) (R1Inter y61 y62) =
  equal_rr1_rel x61 y61 && equal_rr1_rel x62 y62;
equal_rr1_rel (R1Union x51 x52) (R1Union y51 y52) =
  equal_rr1_rel x51 y51 && equal_rr1_rel x52 y52;
equal_rr1_rel (R1Proj x41 x42) (R1Proj y41 y42) =
  equal_nat x41 y41 && equal_rr2_rel x42 y42;
equal_rr1_rel (R1Inf x3) (R1Inf y3) = equal_rr2_rel x3 y3;
equal_rr1_rel (R1NF x2) (R1NF y2) = x2 == y2;
equal_rr1_rel R1Terms R1Terms = True;

data Formula a = FRR1 (Rr1_rel a) Nat | FRR2 (Rr2_rel a) Nat Nat
  | FAnd [Formula a] | FOr [Formula a] | FNot (Formula a) | FExists (Formula a)
  | FForall (Formula a);

instance (Eq a) => Eq (Formula a) where {
  a == b = equal_formula a b;
};

equal_formula :: forall a. (Eq a) => Formula a -> Formula a -> Bool;
equal_formula (FExists x6) (FForall x7) = False;
equal_formula (FForall x7) (FExists x6) = False;
equal_formula (FNot x5) (FForall x7) = False;
equal_formula (FForall x7) (FNot x5) = False;
equal_formula (FNot x5) (FExists x6) = False;
equal_formula (FExists x6) (FNot x5) = False;
equal_formula (FOr x4) (FForall x7) = False;
equal_formula (FForall x7) (FOr x4) = False;
equal_formula (FOr x4) (FExists x6) = False;
equal_formula (FExists x6) (FOr x4) = False;
equal_formula (FOr x4) (FNot x5) = False;
equal_formula (FNot x5) (FOr x4) = False;
equal_formula (FAnd x3) (FForall x7) = False;
equal_formula (FForall x7) (FAnd x3) = False;
equal_formula (FAnd x3) (FExists x6) = False;
equal_formula (FExists x6) (FAnd x3) = False;
equal_formula (FAnd x3) (FNot x5) = False;
equal_formula (FNot x5) (FAnd x3) = False;
equal_formula (FAnd x3) (FOr x4) = False;
equal_formula (FOr x4) (FAnd x3) = False;
equal_formula (FRR2 x21 x22 x23) (FForall x7) = False;
equal_formula (FForall x7) (FRR2 x21 x22 x23) = False;
equal_formula (FRR2 x21 x22 x23) (FExists x6) = False;
equal_formula (FExists x6) (FRR2 x21 x22 x23) = False;
equal_formula (FRR2 x21 x22 x23) (FNot x5) = False;
equal_formula (FNot x5) (FRR2 x21 x22 x23) = False;
equal_formula (FRR2 x21 x22 x23) (FOr x4) = False;
equal_formula (FOr x4) (FRR2 x21 x22 x23) = False;
equal_formula (FRR2 x21 x22 x23) (FAnd x3) = False;
equal_formula (FAnd x3) (FRR2 x21 x22 x23) = False;
equal_formula (FRR1 x11 x12) (FForall x7) = False;
equal_formula (FForall x7) (FRR1 x11 x12) = False;
equal_formula (FRR1 x11 x12) (FExists x6) = False;
equal_formula (FExists x6) (FRR1 x11 x12) = False;
equal_formula (FRR1 x11 x12) (FNot x5) = False;
equal_formula (FNot x5) (FRR1 x11 x12) = False;
equal_formula (FRR1 x11 x12) (FOr x4) = False;
equal_formula (FOr x4) (FRR1 x11 x12) = False;
equal_formula (FRR1 x11 x12) (FAnd x3) = False;
equal_formula (FAnd x3) (FRR1 x11 x12) = False;
equal_formula (FRR1 x11 x12) (FRR2 x21 x22 x23) = False;
equal_formula (FRR2 x21 x22 x23) (FRR1 x11 x12) = False;
equal_formula (FForall x7) (FForall y7) = equal_formula x7 y7;
equal_formula (FExists x6) (FExists y6) = equal_formula x6 y6;
equal_formula (FNot x5) (FNot y5) = equal_formula x5 y5;
equal_formula (FOr x4) (FOr y4) = x4 == y4;
equal_formula (FAnd x3) (FAnd y3) = x3 == y3;
equal_formula (FRR2 x21 x22 x23) (FRR2 y21 y22 y23) =
  equal_rr2_rel x21 y21 && equal_nat x22 y22 && equal_nat x23 y23;
equal_formula (FRR1 x11 x12) (FRR1 y11 y12) =
  equal_rr1_rel x11 y11 && equal_nat x12 y12;

instance (Eq a) => Eq (Rr1_rel a) where {
  a == b = equal_rr1_rel a b;
};

comparator_pos_step :: Pos_step -> Pos_step -> Ordera;
comparator_pos_step PAny PAny = Eqa;
comparator_pos_step PAny PNonRoot = Gt;
comparator_pos_step PAny PRoot = Gt;
comparator_pos_step PNonRoot PAny = Lt;
comparator_pos_step PNonRoot PNonRoot = Eqa;
comparator_pos_step PNonRoot PRoot = Gt;
comparator_pos_step PRoot PAny = Lt;
comparator_pos_step PRoot PNonRoot = Lt;
comparator_pos_step PRoot PRoot = Eqa;

comparator_ext_step :: Ext_step -> Ext_step -> Ordera;
comparator_ext_step EStrictParallel EStrictParallel = Eqa;
comparator_ext_step EStrictParallel EParallel = Gt;
comparator_ext_step EStrictParallel ESingle = Gt;
comparator_ext_step EParallel EStrictParallel = Lt;
comparator_ext_step EParallel EParallel = Eqa;
comparator_ext_step EParallel ESingle = Gt;
comparator_ext_step ESingle EStrictParallel = Lt;
comparator_ext_step ESingle EParallel = Lt;
comparator_ext_step ESingle ESingle = Eqa;

comparator_gtt_rel ::
  forall a. (a -> a -> Ordera) -> Gtt_rel a -> Gtt_rel a -> Ordera;
comparator_gtt_rel comp_t_r_s (GComp x xa) (GComp yh yi) =
  (case comparator_gtt_rel comp_t_r_s x yh of {
    Eqa -> comparator_gtt_rel comp_t_r_s xa yi;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_gtt_rel comp_t_r_s (GComp x xa) (AComp yf yg) = Gt;
comparator_gtt_rel comp_t_r_s (GComp x xa) (GTrancl ye) = Gt;
comparator_gtt_rel comp_t_r_s (GComp x xa) (ATrancl yd) = Gt;
comparator_gtt_rel comp_t_r_s (GComp x xa) (AUnion yb yc) = Gt;
comparator_gtt_rel comp_t_r_s (GComp x xa) (GInv ya) = Gt;
comparator_gtt_rel comp_t_r_s (GComp x xa) (ARoot y) = Gt;
comparator_gtt_rel comp_t_r_s (AComp x xa) (GComp yh yi) = Lt;
comparator_gtt_rel comp_t_r_s (AComp x xa) (AComp yf yg) =
  (case comparator_gtt_rel comp_t_r_s x yf of {
    Eqa -> comparator_gtt_rel comp_t_r_s xa yg;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_gtt_rel comp_t_r_s (AComp x xa) (GTrancl ye) = Gt;
comparator_gtt_rel comp_t_r_s (AComp x xa) (ATrancl yd) = Gt;
comparator_gtt_rel comp_t_r_s (AComp x xa) (AUnion yb yc) = Gt;
comparator_gtt_rel comp_t_r_s (AComp x xa) (GInv ya) = Gt;
comparator_gtt_rel comp_t_r_s (AComp x xa) (ARoot y) = Gt;
comparator_gtt_rel comp_t_r_s (GTrancl x) (GComp yh yi) = Lt;
comparator_gtt_rel comp_t_r_s (GTrancl x) (AComp yf yg) = Lt;
comparator_gtt_rel comp_t_r_s (GTrancl x) (GTrancl ye) =
  comparator_gtt_rel comp_t_r_s x ye;
comparator_gtt_rel comp_t_r_s (GTrancl x) (ATrancl yd) = Gt;
comparator_gtt_rel comp_t_r_s (GTrancl x) (AUnion yb yc) = Gt;
comparator_gtt_rel comp_t_r_s (GTrancl x) (GInv ya) = Gt;
comparator_gtt_rel comp_t_r_s (GTrancl x) (ARoot y) = Gt;
comparator_gtt_rel comp_t_r_s (ATrancl x) (GComp yh yi) = Lt;
comparator_gtt_rel comp_t_r_s (ATrancl x) (AComp yf yg) = Lt;
comparator_gtt_rel comp_t_r_s (ATrancl x) (GTrancl ye) = Lt;
comparator_gtt_rel comp_t_r_s (ATrancl x) (ATrancl yd) =
  comparator_gtt_rel comp_t_r_s x yd;
comparator_gtt_rel comp_t_r_s (ATrancl x) (AUnion yb yc) = Gt;
comparator_gtt_rel comp_t_r_s (ATrancl x) (GInv ya) = Gt;
comparator_gtt_rel comp_t_r_s (ATrancl x) (ARoot y) = Gt;
comparator_gtt_rel comp_t_r_s (AUnion x xa) (GComp yh yi) = Lt;
comparator_gtt_rel comp_t_r_s (AUnion x xa) (AComp yf yg) = Lt;
comparator_gtt_rel comp_t_r_s (AUnion x xa) (GTrancl ye) = Lt;
comparator_gtt_rel comp_t_r_s (AUnion x xa) (ATrancl yd) = Lt;
comparator_gtt_rel comp_t_r_s (AUnion x xa) (AUnion yb yc) =
  (case comparator_gtt_rel comp_t_r_s x yb of {
    Eqa -> comparator_gtt_rel comp_t_r_s xa yc;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_gtt_rel comp_t_r_s (AUnion x xa) (GInv ya) = Gt;
comparator_gtt_rel comp_t_r_s (AUnion x xa) (ARoot y) = Gt;
comparator_gtt_rel comp_t_r_s (GInv x) (GComp yh yi) = Lt;
comparator_gtt_rel comp_t_r_s (GInv x) (AComp yf yg) = Lt;
comparator_gtt_rel comp_t_r_s (GInv x) (GTrancl ye) = Lt;
comparator_gtt_rel comp_t_r_s (GInv x) (ATrancl yd) = Lt;
comparator_gtt_rel comp_t_r_s (GInv x) (AUnion yb yc) = Lt;
comparator_gtt_rel comp_t_r_s (GInv x) (GInv ya) =
  comparator_gtt_rel comp_t_r_s x ya;
comparator_gtt_rel comp_t_r_s (GInv x) (ARoot y) = Gt;
comparator_gtt_rel comp_t_r_s (ARoot x) (GComp yh yi) = Lt;
comparator_gtt_rel comp_t_r_s (ARoot x) (AComp yf yg) = Lt;
comparator_gtt_rel comp_t_r_s (ARoot x) (GTrancl ye) = Lt;
comparator_gtt_rel comp_t_r_s (ARoot x) (ATrancl yd) = Lt;
comparator_gtt_rel comp_t_r_s (ARoot x) (AUnion yb yc) = Lt;
comparator_gtt_rel comp_t_r_s (ARoot x) (GInv ya) = Lt;
comparator_gtt_rel comp_t_r_s (ARoot x) (ARoot y) =
  comparator_list comp_t_r_s x y;

comparator_rr1_rel ::
  forall a. (a -> a -> Ordera) -> Rr1_rel a -> Rr1_rel a -> Ordera;
comparator_rr1_rel comp_t_r_s (R1Diff x xa) (R1Diff yh yi) =
  (case comparator_rr1_rel comp_t_r_s x yh of {
    Eqa -> comparator_rr1_rel comp_t_r_s xa yi;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_rr1_rel comp_t_r_s (R1Diff x xa) (R1Inter yf yg) = Gt;
comparator_rr1_rel comp_t_r_s (R1Diff x xa) (R1Union yd ye) = Gt;
comparator_rr1_rel comp_t_r_s (R1Diff x xa) (R1Proj yb yc) = Gt;
comparator_rr1_rel comp_t_r_s (R1Diff x xa) (R1Inf ya) = Gt;
comparator_rr1_rel comp_t_r_s (R1Diff x xa) (R1NF y) = Gt;
comparator_rr1_rel comp_t_r_s (R1Diff x xa) R1Terms = Gt;
comparator_rr1_rel comp_t_r_s (R1Inter x xa) (R1Diff yh yi) = Lt;
comparator_rr1_rel comp_t_r_s (R1Inter x xa) (R1Inter yf yg) =
  (case comparator_rr1_rel comp_t_r_s x yf of {
    Eqa -> comparator_rr1_rel comp_t_r_s xa yg;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_rr1_rel comp_t_r_s (R1Inter x xa) (R1Union yd ye) = Gt;
comparator_rr1_rel comp_t_r_s (R1Inter x xa) (R1Proj yb yc) = Gt;
comparator_rr1_rel comp_t_r_s (R1Inter x xa) (R1Inf ya) = Gt;
comparator_rr1_rel comp_t_r_s (R1Inter x xa) (R1NF y) = Gt;
comparator_rr1_rel comp_t_r_s (R1Inter x xa) R1Terms = Gt;
comparator_rr1_rel comp_t_r_s (R1Union x xa) (R1Diff yh yi) = Lt;
comparator_rr1_rel comp_t_r_s (R1Union x xa) (R1Inter yf yg) = Lt;
comparator_rr1_rel comp_t_r_s (R1Union x xa) (R1Union yd ye) =
  (case comparator_rr1_rel comp_t_r_s x yd of {
    Eqa -> comparator_rr1_rel comp_t_r_s xa ye;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_rr1_rel comp_t_r_s (R1Union x xa) (R1Proj yb yc) = Gt;
comparator_rr1_rel comp_t_r_s (R1Union x xa) (R1Inf ya) = Gt;
comparator_rr1_rel comp_t_r_s (R1Union x xa) (R1NF y) = Gt;
comparator_rr1_rel comp_t_r_s (R1Union x xa) R1Terms = Gt;
comparator_rr1_rel comp_t_r_s (R1Proj x xa) (R1Diff yh yi) = Lt;
comparator_rr1_rel comp_t_r_s (R1Proj x xa) (R1Inter yf yg) = Lt;
comparator_rr1_rel comp_t_r_s (R1Proj x xa) (R1Union yd ye) = Lt;
comparator_rr1_rel comp_t_r_s (R1Proj x xa) (R1Proj yb yc) =
  (case comparator_of x yb of {
    Eqa -> comparator_rr2_rel comp_t_r_s xa yc;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_rr1_rel comp_t_r_s (R1Proj x xa) (R1Inf ya) = Gt;
comparator_rr1_rel comp_t_r_s (R1Proj x xa) (R1NF y) = Gt;
comparator_rr1_rel comp_t_r_s (R1Proj x xa) R1Terms = Gt;
comparator_rr1_rel comp_t_r_s (R1Inf x) (R1Diff yh yi) = Lt;
comparator_rr1_rel comp_t_r_s (R1Inf x) (R1Inter yf yg) = Lt;
comparator_rr1_rel comp_t_r_s (R1Inf x) (R1Union yd ye) = Lt;
comparator_rr1_rel comp_t_r_s (R1Inf x) (R1Proj yb yc) = Lt;
comparator_rr1_rel comp_t_r_s (R1Inf x) (R1Inf ya) =
  comparator_rr2_rel comp_t_r_s x ya;
comparator_rr1_rel comp_t_r_s (R1Inf x) (R1NF y) = Gt;
comparator_rr1_rel comp_t_r_s (R1Inf x) R1Terms = Gt;
comparator_rr1_rel comp_t_r_s (R1NF x) (R1Diff yh yi) = Lt;
comparator_rr1_rel comp_t_r_s (R1NF x) (R1Inter yf yg) = Lt;
comparator_rr1_rel comp_t_r_s (R1NF x) (R1Union yd ye) = Lt;
comparator_rr1_rel comp_t_r_s (R1NF x) (R1Proj yb yc) = Lt;
comparator_rr1_rel comp_t_r_s (R1NF x) (R1Inf ya) = Lt;
comparator_rr1_rel comp_t_r_s (R1NF x) (R1NF y) =
  comparator_list comp_t_r_s x y;
comparator_rr1_rel comp_t_r_s (R1NF x) R1Terms = Gt;
comparator_rr1_rel comp_t_r_s R1Terms (R1Diff yh yi) = Lt;
comparator_rr1_rel comp_t_r_s R1Terms (R1Inter yf yg) = Lt;
comparator_rr1_rel comp_t_r_s R1Terms (R1Union yd ye) = Lt;
comparator_rr1_rel comp_t_r_s R1Terms (R1Proj yb yc) = Lt;
comparator_rr1_rel comp_t_r_s R1Terms (R1Inf ya) = Lt;
comparator_rr1_rel comp_t_r_s R1Terms (R1NF y) = Lt;
comparator_rr1_rel comp_t_r_s R1Terms R1Terms = Eqa;

comparator_rr2_rel ::
  forall a. (a -> a -> Ordera) -> Rr2_rel a -> Rr2_rel a -> Ordera;
comparator_rr2_rel comp_t_r_s (R2Comp x xa) (R2Comp ym yn) =
  (case comparator_rr2_rel comp_t_r_s x ym of {
    Eqa -> comparator_rr2_rel comp_t_r_s xa yn;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_rr2_rel comp_t_r_s (R2Comp x xa) (R2Diff yk yl) = Gt;
comparator_rr2_rel comp_t_r_s (R2Comp x xa) (R2Inter yi yj) = Gt;
comparator_rr2_rel comp_t_r_s (R2Comp x xa) (R2Union yg yh) = Gt;
comparator_rr2_rel comp_t_r_s (R2Comp x xa) (R2Inv yf) = Gt;
comparator_rr2_rel comp_t_r_s (R2Comp x xa) (R2Prod yd ye) = Gt;
comparator_rr2_rel comp_t_r_s (R2Comp x xa) (R2Diag yc) = Gt;
comparator_rr2_rel comp_t_r_s (R2Comp x xa) (R2GTT_Rel y ya yb) = Gt;
comparator_rr2_rel comp_t_r_s (R2Diff x xa) (R2Comp ym yn) = Lt;
comparator_rr2_rel comp_t_r_s (R2Diff x xa) (R2Diff yk yl) =
  (case comparator_rr2_rel comp_t_r_s x yk of {
    Eqa -> comparator_rr2_rel comp_t_r_s xa yl;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_rr2_rel comp_t_r_s (R2Diff x xa) (R2Inter yi yj) = Gt;
comparator_rr2_rel comp_t_r_s (R2Diff x xa) (R2Union yg yh) = Gt;
comparator_rr2_rel comp_t_r_s (R2Diff x xa) (R2Inv yf) = Gt;
comparator_rr2_rel comp_t_r_s (R2Diff x xa) (R2Prod yd ye) = Gt;
comparator_rr2_rel comp_t_r_s (R2Diff x xa) (R2Diag yc) = Gt;
comparator_rr2_rel comp_t_r_s (R2Diff x xa) (R2GTT_Rel y ya yb) = Gt;
comparator_rr2_rel comp_t_r_s (R2Inter x xa) (R2Comp ym yn) = Lt;
comparator_rr2_rel comp_t_r_s (R2Inter x xa) (R2Diff yk yl) = Lt;
comparator_rr2_rel comp_t_r_s (R2Inter x xa) (R2Inter yi yj) =
  (case comparator_rr2_rel comp_t_r_s x yi of {
    Eqa -> comparator_rr2_rel comp_t_r_s xa yj;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_rr2_rel comp_t_r_s (R2Inter x xa) (R2Union yg yh) = Gt;
comparator_rr2_rel comp_t_r_s (R2Inter x xa) (R2Inv yf) = Gt;
comparator_rr2_rel comp_t_r_s (R2Inter x xa) (R2Prod yd ye) = Gt;
comparator_rr2_rel comp_t_r_s (R2Inter x xa) (R2Diag yc) = Gt;
comparator_rr2_rel comp_t_r_s (R2Inter x xa) (R2GTT_Rel y ya yb) = Gt;
comparator_rr2_rel comp_t_r_s (R2Union x xa) (R2Comp ym yn) = Lt;
comparator_rr2_rel comp_t_r_s (R2Union x xa) (R2Diff yk yl) = Lt;
comparator_rr2_rel comp_t_r_s (R2Union x xa) (R2Inter yi yj) = Lt;
comparator_rr2_rel comp_t_r_s (R2Union x xa) (R2Union yg yh) =
  (case comparator_rr2_rel comp_t_r_s x yg of {
    Eqa -> comparator_rr2_rel comp_t_r_s xa yh;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_rr2_rel comp_t_r_s (R2Union x xa) (R2Inv yf) = Gt;
comparator_rr2_rel comp_t_r_s (R2Union x xa) (R2Prod yd ye) = Gt;
comparator_rr2_rel comp_t_r_s (R2Union x xa) (R2Diag yc) = Gt;
comparator_rr2_rel comp_t_r_s (R2Union x xa) (R2GTT_Rel y ya yb) = Gt;
comparator_rr2_rel comp_t_r_s (R2Inv x) (R2Comp ym yn) = Lt;
comparator_rr2_rel comp_t_r_s (R2Inv x) (R2Diff yk yl) = Lt;
comparator_rr2_rel comp_t_r_s (R2Inv x) (R2Inter yi yj) = Lt;
comparator_rr2_rel comp_t_r_s (R2Inv x) (R2Union yg yh) = Lt;
comparator_rr2_rel comp_t_r_s (R2Inv x) (R2Inv yf) =
  comparator_rr2_rel comp_t_r_s x yf;
comparator_rr2_rel comp_t_r_s (R2Inv x) (R2Prod yd ye) = Gt;
comparator_rr2_rel comp_t_r_s (R2Inv x) (R2Diag yc) = Gt;
comparator_rr2_rel comp_t_r_s (R2Inv x) (R2GTT_Rel y ya yb) = Gt;
comparator_rr2_rel comp_t_r_s (R2Prod x xa) (R2Comp ym yn) = Lt;
comparator_rr2_rel comp_t_r_s (R2Prod x xa) (R2Diff yk yl) = Lt;
comparator_rr2_rel comp_t_r_s (R2Prod x xa) (R2Inter yi yj) = Lt;
comparator_rr2_rel comp_t_r_s (R2Prod x xa) (R2Union yg yh) = Lt;
comparator_rr2_rel comp_t_r_s (R2Prod x xa) (R2Inv yf) = Lt;
comparator_rr2_rel comp_t_r_s (R2Prod x xa) (R2Prod yd ye) =
  (case comparator_rr1_rel comp_t_r_s x yd of {
    Eqa -> comparator_rr1_rel comp_t_r_s xa ye;
    Lt -> Lt;
    Gt -> Gt;
  });
comparator_rr2_rel comp_t_r_s (R2Prod x xa) (R2Diag yc) = Gt;
comparator_rr2_rel comp_t_r_s (R2Prod x xa) (R2GTT_Rel y ya yb) = Gt;
comparator_rr2_rel comp_t_r_s (R2Diag x) (R2Comp ym yn) = Lt;
comparator_rr2_rel comp_t_r_s (R2Diag x) (R2Diff yk yl) = Lt;
comparator_rr2_rel comp_t_r_s (R2Diag x) (R2Inter yi yj) = Lt;
comparator_rr2_rel comp_t_r_s (R2Diag x) (R2Union yg yh) = Lt;
comparator_rr2_rel comp_t_r_s (R2Diag x) (R2Inv yf) = Lt;
comparator_rr2_rel comp_t_r_s (R2Diag x) (R2Prod yd ye) = Lt;
comparator_rr2_rel comp_t_r_s (R2Diag x) (R2Diag yc) =
  comparator_rr1_rel comp_t_r_s x yc;
comparator_rr2_rel comp_t_r_s (R2Diag x) (R2GTT_Rel y ya yb) = Gt;
comparator_rr2_rel comp_t_r_s (R2GTT_Rel x xa xb) (R2Comp ym yn) = Lt;
comparator_rr2_rel comp_t_r_s (R2GTT_Rel x xa xb) (R2Diff yk yl) = Lt;
comparator_rr2_rel comp_t_r_s (R2GTT_Rel x xa xb) (R2Inter yi yj) = Lt;
comparator_rr2_rel comp_t_r_s (R2GTT_Rel x xa xb) (R2Union yg yh) = Lt;
comparator_rr2_rel comp_t_r_s (R2GTT_Rel x xa xb) (R2Inv yf) = Lt;
comparator_rr2_rel comp_t_r_s (R2GTT_Rel x xa xb) (R2Prod yd ye) = Lt;
comparator_rr2_rel comp_t_r_s (R2GTT_Rel x xa xb) (R2Diag yc) = Lt;
comparator_rr2_rel comp_t_r_s (R2GTT_Rel x xa xb) (R2GTT_Rel y ya yb) =
  (case comparator_gtt_rel comp_t_r_s x y of {
    Eqa -> (case comparator_pos_step xa ya of {
             Eqa -> comparator_ext_step xb yb;
             Lt -> Lt;
             Gt -> Gt;
           });
    Lt -> Lt;
    Gt -> Gt;
  });

compare_rr1_rel :: forall a. (Compare a) => Rr1_rel a -> Rr1_rel a -> Ordera;
compare_rr1_rel = comparator_rr1_rel compare;

instance (Compare a) => Compare (Rr1_rel a) where {
  compare = compare_rr1_rel;
};

instance (Eq a) => Eq (Rr2_rel a) where {
  a == b = equal_rr2_rel a b;
};

compare_rr2_rel :: forall a. (Compare a) => Rr2_rel a -> Rr2_rel a -> Ordera;
compare_rr2_rel = comparator_rr2_rel compare;

instance (Compare a) => Compare (Rr2_rel a) where {
  compare = compare_rr2_rel;
};

newtype FSet_Lex_Wrapper a = Wrapp (Fset a);

equal_FSet_Lex_Wrapper ::
  forall a.
    (Cenum a, Ceq a, Ccompare a,
      Eq a) => FSet_Lex_Wrapper a -> FSet_Lex_Wrapper a -> Bool;
equal_FSet_Lex_Wrapper (Wrapp x) (Wrapp ya) = x == ya;

instance (Cenum a, Ceq a, Ccompare a, Eq a) => Eq (FSet_Lex_Wrapper a) where {
  a == b = equal_FSet_Lex_Wrapper a b;
};

exa :: forall a. FSet_Lex_Wrapper a -> Fset a;
exa (Wrapp x) = x;

less_eq_FSet_Lex_Wrapper ::
  forall a.
    (Ceq a, Ccompare a, Eq a,
      Linorder a) => FSet_Lex_Wrapper a -> FSet_Lex_Wrapper a -> Bool;
less_eq_FSet_Lex_Wrapper s t = let {
                                 sa = sorted_list_of_fset (exa s);
                                 a = sorted_list_of_fset (exa t);
                               } in less_eq_list sa a;

less_FSet_Lex_Wrapper ::
  forall a.
    (Ceq a, Ccompare a, Eq a,
      Linorder a) => FSet_Lex_Wrapper a -> FSet_Lex_Wrapper a -> Bool;
less_FSet_Lex_Wrapper s t = let {
                              sa = sorted_list_of_fset (exa s);
                              a = sorted_list_of_fset (exa t);
                            } in less_list sa a;

instance (Ceq a, Ccompare a, Eq a,
           Linorder a) => Ord (FSet_Lex_Wrapper a) where {
  less_eq = less_eq_FSet_Lex_Wrapper;
  less = less_FSet_Lex_Wrapper;
};

instance (Ceq a, Ccompare a, Eq a,
           Linorder a) => Preorder (FSet_Lex_Wrapper a) where {
};

instance (Ceq a, Ccompare a, Eq a,
           Linorder a) => Order (FSet_Lex_Wrapper a) where {
};

ceq_FSet_Lex_Wrapper ::
  forall a.
    (Cenum a, Ceq a, Ccompare a,
      Eq a) => Maybe (FSet_Lex_Wrapper a -> FSet_Lex_Wrapper a -> Bool);
ceq_FSet_Lex_Wrapper = Just equal_FSet_Lex_Wrapper;

instance (Cenum a, Ceq a, Ccompare a, Eq a) => Ceq (FSet_Lex_Wrapper a) where {
  ceq = ceq_FSet_Lex_Wrapper;
};

set_impl_FSet_Lex_Wrapper :: forall a. Phantom (FSet_Lex_Wrapper a) Set_impla;
set_impl_FSet_Lex_Wrapper = Phantom Set_RBT;

instance Set_impl (FSet_Lex_Wrapper a) where {
  set_impl = set_impl_FSet_Lex_Wrapper;
};

instance (Ceq a, Ccompare a, Eq a,
           Linorder a) => Linorder (FSet_Lex_Wrapper a) where {
};

cEnum_FSet_Lex_Wrapper ::
  forall a.
    Maybe ([FSet_Lex_Wrapper a],
            ((FSet_Lex_Wrapper a -> Bool) -> Bool,
              (FSet_Lex_Wrapper a -> Bool) -> Bool));
cEnum_FSet_Lex_Wrapper = Nothing;

instance Cenum (FSet_Lex_Wrapper a) where {
  cEnum = cEnum_FSet_Lex_Wrapper;
};

finite_UNIV_FSet_Lex_Wrapper ::
  forall a. (Finite_UNIV a) => Phantom (FSet_Lex_Wrapper a) Bool;
finite_UNIV_FSet_Lex_Wrapper =
  Phantom (of_phantom (finite_UNIV :: Phantom a Bool));

instance (Finite_UNIV a) => Finite_UNIV (FSet_Lex_Wrapper a) where {
  finite_UNIV = finite_UNIV_FSet_Lex_Wrapper;
};

ccompare_FSet_Lex_Wrapper ::
  forall a.
    (Ceq a, Ccompare a, Eq a,
      Linorder a) => Maybe (FSet_Lex_Wrapper a -> FSet_Lex_Wrapper a -> Ordera);
ccompare_FSet_Lex_Wrapper =
  Just (\ a b ->
         let {
           aa = sorted_list_of_fset (exa a);
           ba = sorted_list_of_fset (exa b);
         } in (if less_list aa ba then Lt
                else (if less_list ba aa then Gt else Eqa)));

instance (Ceq a, Ccompare a, Eq a,
           Linorder a) => Ccompare (FSet_Lex_Wrapper a) where {
  ccompare = ccompare_FSet_Lex_Wrapper;
};

cproper_interval_FSet_Lex_Wrapper ::
  forall a. Maybe (FSet_Lex_Wrapper a) -> Maybe (FSet_Lex_Wrapper a) -> Bool;
cproper_interval_FSet_Lex_Wrapper _ _ = error
  "Tree_Automata_Container_Setup.cproper_interval_FSet_Lex_Wrapper_inst.cproper_interval_FSet_Lex_Wrapper";

instance (Ceq a, Ccompare a, Eq a,
           Linorder a) => Cproper_interval (FSet_Lex_Wrapper a) where {
  cproper_interval = cproper_interval_FSet_Lex_Wrapper;
};

data Cl_states = Cl_state | Tr_state | Fin_state | Fin_clstate;

equal_cl_states :: Cl_states -> Cl_states -> Bool;
equal_cl_states Fin_state Fin_clstate = False;
equal_cl_states Fin_clstate Fin_state = False;
equal_cl_states Tr_state Fin_clstate = False;
equal_cl_states Fin_clstate Tr_state = False;
equal_cl_states Tr_state Fin_state = False;
equal_cl_states Fin_state Tr_state = False;
equal_cl_states Cl_state Fin_clstate = False;
equal_cl_states Fin_clstate Cl_state = False;
equal_cl_states Cl_state Fin_state = False;
equal_cl_states Fin_state Cl_state = False;
equal_cl_states Cl_state Tr_state = False;
equal_cl_states Tr_state Cl_state = False;
equal_cl_states Fin_clstate Fin_clstate = True;
equal_cl_states Fin_state Fin_state = True;
equal_cl_states Tr_state Tr_state = True;
equal_cl_states Cl_state Cl_state = True;

instance Eq Cl_states where {
  a == b = equal_cl_states a b;
};

comparator_cl_states :: Cl_states -> Cl_states -> Ordera;
comparator_cl_states Fin_clstate Fin_clstate = Eqa;
comparator_cl_states Fin_clstate Fin_state = Gt;
comparator_cl_states Fin_clstate Tr_state = Gt;
comparator_cl_states Fin_clstate Cl_state = Gt;
comparator_cl_states Fin_state Fin_clstate = Lt;
comparator_cl_states Fin_state Fin_state = Eqa;
comparator_cl_states Fin_state Tr_state = Gt;
comparator_cl_states Fin_state Cl_state = Gt;
comparator_cl_states Tr_state Fin_clstate = Lt;
comparator_cl_states Tr_state Fin_state = Lt;
comparator_cl_states Tr_state Tr_state = Eqa;
comparator_cl_states Tr_state Cl_state = Gt;
comparator_cl_states Cl_state Fin_clstate = Lt;
comparator_cl_states Cl_state Fin_state = Lt;
comparator_cl_states Cl_state Tr_state = Lt;
comparator_cl_states Cl_state Cl_state = Eqa;

compare_cl_states :: Cl_states -> Cl_states -> Ordera;
compare_cl_states = comparator_cl_states;

less_eq_cl_states :: Cl_states -> Cl_states -> Bool;
less_eq_cl_states = le_of_comp compare_cl_states;

less_cl_states :: Cl_states -> Cl_states -> Bool;
less_cl_states = lt_of_comp compare_cl_states;

instance Ord Cl_states where {
  less_eq = less_eq_cl_states;
  less = less_cl_states;
};

instance Compare Cl_states where {
  compare = compare_cl_states;
};

instance Preorder Cl_states where {
};

instance Order Cl_states where {
};

ceq_cl_states :: Maybe (Cl_states -> Cl_states -> Bool);
ceq_cl_states = Just equal_cl_states;

instance Ceq Cl_states where {
  ceq = ceq_cl_states;
};

set_impl_cl_states :: Phantom Cl_states Set_impla;
set_impl_cl_states = Phantom Set_RBT;

instance Set_impl Cl_states where {
  set_impl = set_impl_cl_states;
};

instance Linorder Cl_states where {
};

finite_UNIV_cl_states :: Phantom Cl_states Bool;
finite_UNIV_cl_states = Phantom True;

card_UNIV_cl_states :: Phantom Cl_states Nat;
card_UNIV_cl_states = Phantom (nat_of_integer (4 :: Integer));

instance Finite_UNIV Cl_states where {
  finite_UNIV = finite_UNIV_cl_states;
};

instance Card_UNIV Cl_states where {
  card_UNIV = card_UNIV_cl_states;
};

cEnum_cl_states ::
  Maybe ([Cl_states],
          ((Cl_states -> Bool) -> Bool, (Cl_states -> Bool) -> Bool));
cEnum_cl_states =
  Just ([Cl_state, Tr_state, Fin_state, Fin_clstate],
         ((\ p -> all p [Cl_state, Tr_state, Fin_state, Fin_clstate]),
           (\ p -> any p [Cl_state, Tr_state, Fin_state, Fin_clstate])));

instance Cenum Cl_states where {
  cEnum = cEnum_cl_states;
};

ccompare_cl_states :: Maybe (Cl_states -> Cl_states -> Ordera);
ccompare_cl_states = Just compare_cl_states;

instance Ccompare Cl_states where {
  ccompare = ccompare_cl_states;
};

cproper_interval_cl_states :: Maybe Cl_states -> Maybe Cl_states -> Bool;
cproper_interval_cl_states x y =
  (case ccompare_cl_states of {
    Just f ->
      (case x of {
        Nothing ->
          (case y of {
            Nothing -> True;
            Just c ->
              any (\ xa -> lt_of_comp f xa c)
                [Cl_state, Tr_state, Fin_state, Fin_clstate];
          });
        Just c ->
          (case y of {
            Nothing ->
              any (lt_of_comp f c) [Cl_state, Tr_state, Fin_state, Fin_clstate];
            Just d ->
              not (null (filter (\ xa -> lt_of_comp f xa d && lt_of_comp f c xa)
                          [Cl_state, Tr_state, Fin_state, Fin_clstate]));
          });
      });
  });

instance Cproper_interval Cl_states where {
  cproper_interval = cproper_interval_cl_states;
};

data Form a b = FF | TT | Pred b [Terma a] | And (Form a b) (Form a b)
  | Or (Form a b) (Form a b) | Impl (Form a b) (Form a b) | Neg (Form a b)
  | Forall (Form a b) | Exists (Form a b);

data Ta a b = TA (Fset (Ta_rule a b)) (Fset (a, a));

data Reg a b = Reg (Fset a) (Ta a b);

data Info = Size Nat Nat Nat;

data Claim = Emptya | Nonempty;

newtype Comp_fun_idem b a = Abs_comp_fun_idem (b -> a -> a);

data Equivalence = EDistribAndOr | EDistribOrAnd;

data Inference a = IRR1 (Rr1_rel a) Nat | IRR2 (Rr2_rel a) Nat Nat | IAnd [Nat]
  | IOr [Nat] | INot Nat | IExists Nat | IRename Nat [Nat] | INNFPlus Nat
  | IRepl Equivalence [Nat] Nat;

data Certificate a =
  Certificate [(Nat, (Inference a, (Formula a, [Info])))] Claim Nat;

dlist_ex :: forall a. (Ceq a) => (a -> Bool) -> Set_dlist a -> Bool;
dlist_ex x xc = any x (list_of_dlist xc);

rBT_Impl_rbt_ex :: forall a b. (a -> b -> Bool) -> Rbt a b -> Bool;
rBT_Impl_rbt_ex p (Branch c l k v r) =
  p k v || (rBT_Impl_rbt_ex p l || rBT_Impl_rbt_ex p r);
rBT_Impl_rbt_ex p Empty = False;

ex :: forall a b. (Ccompare a) => (a -> b -> Bool) -> Mapping_rbt a b -> Bool;
ex xb xc = rBT_Impl_rbt_ex xb (impl_of xc);

bex :: forall a. (Ceq a, Ccompare a) => Set a -> (a -> Bool) -> Bool;
bex (RBT_set rbt) p =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "Bex RBT_set: ccompare = None" (\ _ -> bex (RBT_set rbt) p);
    Just _ -> ex (\ k _ -> p k) rbt;
  });
bex (DList_set dxs) p =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a) "Bex DList_set: ceq = None"
        (\ _ -> bex (DList_set dxs) p);
    Just _ -> dlist_ex p dxs;
  });
bex (Set_Monad xs) p = any p xs;

upt :: Nat -> Nat -> [Nat];
upt i j = (if less_nat i j then i : upt (suc i) j else []);

bot_fset :: forall a. (Ceq a, Ccompare a, Set_impl a) => Fset a;
bot_fset = Abs_fset bot_set;

term_to_bot_term :: forall a b. Term a b -> Bot_term a;
term_to_bot_term (Var uu) = Bot;
term_to_bot_term (Fun f ts) = BFun f (map term_to_bot_term ts);

supteq_list :: forall a b. Term a b -> [Term a b];
supteq_list (Var x) = [Var x];
supteq_list (Fun f ts) = Fun f ts : concatMap supteq_list ts;

supt_list :: forall a b. Term a b -> [Term a b];
supt_list (Var x) = [];
supt_list (Fun f ts) = concatMap supteq_list ts;

psubt_bot_impl :: forall a b. (Eq a) => [Term a b] -> [Bot_term a];
psubt_bot_impl r = remdups (map term_to_bot_term (concatMap supt_list r));

list_of_permutation_n :: forall a. [a] -> Nat -> [[a]];
list_of_permutation_n s n =
  (if equal_nat n zero_nat then [[]]
    else let {
           pre = list_of_permutation_n s (minus_nat n one_nat);
         } in concatMap (\ x -> map (\ a -> x : a) pre) s);

bless_eq_impl :: forall a. (Eq a) => Bot_term a -> Bot_term a -> Bool;
bless_eq_impl Bot t = True;
bless_eq_impl (BFun f ss) (BFun g ts) =
  (if f == g && equal_nat (size_list ss) (size_list ts)
    then all (\ (a, b) -> bless_eq_impl a b) (zip ss ts) else False);
bless_eq_impl (BFun v va) Bot = False;

merge_terms :: forall a. (Eq a) => Bot_term a -> Bot_term a -> Bot_term a;
merge_terms Bot s = s;
merge_terms (BFun v va) Bot = BFun v va;
merge_terms (BFun f ss) (BFun g ts) =
  (if f == g && equal_nat (size_list ss) (size_list ts)
    then BFun f (map (\ (a, b) -> merge_terms a b) (zip ss ts))
    else error "undefined");

foldr :: forall a b. (a -> b -> b) -> [a] -> b -> b;
foldr f [] = id;
foldr f (x : xs) = f x . foldr f xs;

min_elem :: forall a. (Eq a) => Bot_term a -> [Bot_term a] -> Bot_term a;
min_elem s ss = let {
                  ts = filter (\ x -> bless_eq_impl x s) ss;
                } in foldr merge_terms ts Bot;

nf_rule_impl ::
  forall a.
    (Eq a) => [Bot_term a] ->
                [Bot_term a] ->
                  [Bot_term a] -> (a, Nat) -> [Ta_rule (Bot_term a) a];
nf_rule_impl s r sr h =
  (case h of {
    (f, n) ->
      let {
        states = list_of_permutation_n s n;
        a = filter (\ qs -> all (\ u -> not (bless_eq_impl u (BFun f qs))) r)
              states;
      } in map (\ qs -> TA_rule f qs (min_elem (BFun f qs) sr)) a;
  });

lift_f_total ::
  forall a b c.
    (a -> b -> Bool) -> (a -> b -> c) -> Maybe a -> Maybe b -> Maybe c;
lift_f_total p f Nothing uu = Nothing;
lift_f_total p f (Just v) Nothing = Nothing;
lift_f_total p f (Just s) (Just t) = (if p s t then Just (f s t) else Nothing);

closure_impl :: forall a. (Eq a) => (a -> a -> a) -> [a] -> [a];
closure_impl f [] = [];
closure_impl f (x : s) = let {
                           cS = closure_impl f s;
                         } in remdups (x : cS ++ map (f x) cS);

mergeP_impl :: forall a. (Eq a) => Bot_term a -> Bot_term a -> Bool;
mergeP_impl Bot t = True;
mergeP_impl (BFun v va) Bot = True;
mergeP_impl (BFun f ss) (BFun g ts) =
  (if f == g && equal_nat (size_list ss) (size_list ts)
    then all (\ (a, b) -> mergeP_impl a b) (zip ss ts) else False);

removeAll :: forall a. (Eq a) => a -> [a] -> [a];
removeAll x [] = [];
removeAll x (y : xs) = (if x == y then removeAll x xs else y : removeAll x xs);

inserta :: forall a. (Eq a) => a -> [a] -> [a];
inserta x xs = (if membera xs x then xs else x : xs);

states_impl :: forall a b. (Eq a) => [Term a b] -> [Bot_term a];
states_impl r =
  inserta Bot
    (map the
      (removeAll Nothing
        (closure_impl (lift_f_total mergeP_impl merge_terms)
          (map Just (psubt_bot_impl r)))));

fun_upd :: forall a b. (a -> a -> Bool) -> (a -> b) -> a -> b -> a -> b;
fun_upd equal f aa b a = (if equal aa a then b else f a);

balance_right :: forall a b. Rbt a b -> a -> b -> Rbt a b -> Rbt a b;
balance_right a k x (Branch R b s y c) = Branch R a k x (Branch B b s y c);
balance_right (Branch B a k x b) s y Empty =
  balance (Branch R a k x b) s y Empty;
balance_right (Branch B a k x b) s y (Branch B va vb vc vd) =
  balance (Branch R a k x b) s y (Branch B va vb vc vd);
balance_right (Branch R a k x (Branch B b s y c)) t z Empty =
  Branch R (balance (paint R a) k x b) s y (Branch B c t z Empty);
balance_right (Branch R a k x (Branch B b s y c)) t z (Branch B va vb vc vd) =
  Branch R (balance (paint R a) k x b) s y
    (Branch B c t z (Branch B va vb vc vd));
balance_right Empty k x Empty = Empty;
balance_right (Branch R va vb vc Empty) k x Empty = Empty;
balance_right (Branch R va vb vc (Branch R ve vf vg vh)) k x Empty = Empty;
balance_right Empty k x (Branch B va vb vc vd) = Empty;
balance_right (Branch R ve vf vg Empty) k x (Branch B va vb vc vd) = Empty;
balance_right (Branch R ve vf vg (Branch R vi vj vk vl)) k x
  (Branch B va vb vc vd) = Empty;

balance_left :: forall a b. Rbt a b -> a -> b -> Rbt a b -> Rbt a b;
balance_left (Branch R a k x b) s y c = Branch R (Branch B a k x b) s y c;
balance_left Empty k x (Branch B a s y b) =
  balance Empty k x (Branch R a s y b);
balance_left (Branch B va vb vc vd) k x (Branch B a s y b) =
  balance (Branch B va vb vc vd) k x (Branch R a s y b);
balance_left Empty k x (Branch R (Branch B a s y b) t z c) =
  Branch R (Branch B Empty k x a) s y (balance b t z (paint R c));
balance_left (Branch B va vb vc vd) k x (Branch R (Branch B a s y b) t z c) =
  Branch R (Branch B (Branch B va vb vc vd) k x a) s y
    (balance b t z (paint R c));
balance_left Empty k x Empty = Empty;
balance_left Empty k x (Branch R Empty vb vc vd) = Empty;
balance_left Empty k x (Branch R (Branch R ve vf vg vh) vb vc vd) = Empty;
balance_left (Branch B va vb vc vd) k x Empty = Empty;
balance_left (Branch B va vb vc vd) k x (Branch R Empty vf vg vh) = Empty;
balance_left (Branch B va vb vc vd) k x
  (Branch R (Branch R vi vj vk vl) vf vg vh) = Empty;

combine :: forall a b. Rbt a b -> Rbt a b -> Rbt a b;
combine Empty x = x;
combine (Branch v va vb vc vd) Empty = Branch v va vb vc vd;
combine (Branch R a k x b) (Branch R c s y d) =
  (case combine b c of {
    Empty -> Branch R a k x (Branch R Empty s y d);
    Branch R b2 t z c2 -> Branch R (Branch R a k x b2) t z (Branch R c2 s y d);
    Branch B b2 t z c2 -> Branch R a k x (Branch R (Branch B b2 t z c2) s y d);
  });
combine (Branch B a k x b) (Branch B c s y d) =
  (case combine b c of {
    Empty -> balance_left a k x (Branch B Empty s y d);
    Branch R b2 t z c2 -> Branch R (Branch B a k x b2) t z (Branch B c2 s y d);
    Branch B b2 t z c2 ->
      balance_left a k x (Branch B (Branch B b2 t z c2) s y d);
  });
combine (Branch B va vb vc vd) (Branch R b k x c) =
  Branch R (combine (Branch B va vb vc vd) b) k x c;
combine (Branch R a k x b) (Branch B va vb vc vd) =
  Branch R a k x (combine b (Branch B va vb vc vd));

rbt_comp_del :: forall a b. (a -> a -> Ordera) -> a -> Rbt a b -> Rbt a b;
rbt_comp_del c x Empty = Empty;
rbt_comp_del c x (Branch uu a y s b) =
  (case c x y of {
    Eqa -> combine a b;
    Lt -> rbt_comp_del_from_left c x a y s b;
    Gt -> rbt_comp_del_from_right c x a y s b;
  });

rbt_comp_del_from_left ::
  forall a b.
    (a -> a -> Ordera) -> a -> Rbt a b -> a -> b -> Rbt a b -> Rbt a b;
rbt_comp_del_from_left c x (Branch B lt z v rt) y s b =
  balance_left (rbt_comp_del c x (Branch B lt z v rt)) y s b;
rbt_comp_del_from_left c x Empty y s b =
  Branch R (rbt_comp_del c x Empty) y s b;
rbt_comp_del_from_left c x (Branch R va vb vc vd) y s b =
  Branch R (rbt_comp_del c x (Branch R va vb vc vd)) y s b;

rbt_comp_del_from_right ::
  forall a b.
    (a -> a -> Ordera) -> a -> Rbt a b -> a -> b -> Rbt a b -> Rbt a b;
rbt_comp_del_from_right c x a y s (Branch B lt z v rt) =
  balance_right a y s (rbt_comp_del c x (Branch B lt z v rt));
rbt_comp_del_from_right c x a y s Empty =
  Branch R a y s (rbt_comp_del c x Empty);
rbt_comp_del_from_right c x a y s (Branch R va vb vc vd) =
  Branch R a y s (rbt_comp_del c x (Branch R va vb vc vd));

rbt_comp_delete :: forall a b. (a -> a -> Ordera) -> a -> Rbt a b -> Rbt a b;
rbt_comp_delete c k t = paint B (rbt_comp_del c k t);

delete :: forall a b. (Ccompare a) => a -> Mapping_rbt a b -> Mapping_rbt a b;
delete xb xc = Mapping_RBT (rbt_comp_delete (the ccompare) xb (impl_of xc));

list_remove1 :: forall a. (a -> a -> Bool) -> a -> [a] -> [a];
list_remove1 equal x (y : xs) =
  (if equal x y then xs else y : list_remove1 equal x xs);
list_remove1 equal x [] = [];

removea :: forall a. (Ceq a) => a -> Set_dlist a -> Set_dlist a;
removea xb xc = Abs_dlist (list_remove1 (the ceq) xb (list_of_dlist xc));

insert :: forall a. (Ceq a, Ccompare a) => a -> Set a -> Set a;
insert xa (Complement x) = Complement (remove xa x);
insert x (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "insert RBT_set: ccompare = None" (\ _ -> insert x (RBT_set rbt));
    Just _ -> RBT_set (insertc x () rbt);
  });
insert x (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "insert DList_set: ceq = None" (\ _ -> insert x (DList_set dxs));
    Just _ -> DList_set (insertb x dxs);
  });
insert x (Set_Monad xs) = Set_Monad (x : xs);
insert x (Collect_set a) =
  (case ceq of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "insert Collect_set: ceq = None" (\ _ -> insert x (Collect_set a));
    Just eq -> Collect_set (fun_upd eq a x True);
  });

remove :: forall a. (Ceq a, Ccompare a) => a -> Set a -> Set a;
remove x (Complement a) = Complement (insert x a);
remove x (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "remove RBT_set: ccompare = None" (\ _ -> remove x (RBT_set rbt));
    Just _ -> RBT_set (delete x rbt);
  });
remove x (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "remove DList_set: ceq = None" (\ _ -> remove x (DList_set dxs));
    Just _ -> DList_set (removea x dxs);
  });
remove x (Collect_set a) =
  (case ceq of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a) "remove Collect: ceq = None"
        (\ _ -> remove x (Collect_set a));
    Just eq -> Collect_set (fun_upd eq a x False);
  });

foldl :: forall a b. (a -> b -> a) -> a -> [b] -> a;
foldl f a [] = a;
foldl f a (x : xs) = foldl f (f a x) xs;

set_aux :: forall a. (Ceq a, Ccompare a) => Set_impla -> [a] -> Set a;
set_aux Set_Monada = Set_Monad;
set_aux Set_Choose =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing -> (case (ceq :: Maybe (a -> a -> Bool)) of {
                 Nothing -> Set_Monad;
                 Just _ -> foldl (\ s x -> insert x s) (DList_set empty);
               });
    Just _ -> foldl (\ s x -> insert x s) (RBT_set emptya);
  });
set_aux impl = foldl (\ s x -> insert x s) (set_empty impl);

set :: forall a. (Ceq a, Ccompare a, Set_impl a) => [a] -> Set a;
set xs = set_aux (of_phantom (set_impl :: Phantom a Set_impla)) xs;

fset_of_list :: forall a. (Ceq a, Ccompare a, Set_impl a) => [a] -> Fset a;
fset_of_list xa = Abs_fset (set xa);

nf_ta ::
  forall a b.
    (Ceq a, Ccompare a, Compare a, Eq a, Linorder a, Compare b,
      Eq b) => Fset (Term a b) -> Fset (a, Nat) -> Ta (Bot_term a) a;
nf_ta r f =
  TA (fset_of_list
       (concatMap
         (nf_rule_impl (states_impl (sorted_list_of_fset r))
           (map term_to_bot_term (sorted_list_of_fset r))
           (psubt_bot_impl (sorted_list_of_fset r)))
         (sorted_list_of_fset f)))
    bot_fset;

rBT_Impl_rbt_all :: forall a b. (a -> b -> Bool) -> Rbt a b -> Bool;
rBT_Impl_rbt_all p (Branch c l k v r) =
  p k v && rBT_Impl_rbt_all p l && rBT_Impl_rbt_all p r;
rBT_Impl_rbt_all p Empty = True;

alla :: forall a b. (Ccompare a) => (a -> b -> Bool) -> Mapping_rbt a b -> Bool;
alla xb xc = rBT_Impl_rbt_all xb (impl_of xc);

ball :: forall a. (Ceq a, Ccompare a) => Set a -> (a -> Bool) -> Bool;
ball (RBT_set rbt) p =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "Ball RBT_set: ccompare = None" (\ _ -> ball (RBT_set rbt) p);
    Just _ -> alla (\ k _ -> p k) rbt;
  });
ball (DList_set dxs) p =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a) "Ball DList_set: ceq = None"
        (\ _ -> ball (DList_set dxs) p);
    Just _ -> dlist_all p dxs;
  });
ball (Set_Monad xs) p = all p xs;

fBex :: forall a. (Ceq a, Ccompare a) => Fset a -> (a -> Bool) -> Bool;
fBex xa = bex (fset xa);

drop :: forall a. Nat -> [a] -> [a];
drop n [] = [];
drop n (x : xs) =
  (if equal_nat n zero_nat then x : xs else drop (minus_nat n one_nat) xs);

last :: forall a. [a] -> a;
last (x : xs) = (if null xs then x else last xs);

take :: forall a. Nat -> [a] -> [a];
take n [] = [];
take n (x : xs) =
  (if equal_nat n zero_nat then [] else x : take (minus_nat n one_nat) xs);

fstates ::
  forall a b.
    (Compare a, Eq a, Compare b, Eq b) => Fset (Term a b) -> Fset (Bot_term a);
fstates r = fset_of_list (states_impl (sorted_list_of_fset r));

nf_reg ::
  forall a b.
    (Ceq a, Ccompare a, Compare a, Eq a, Linorder a, Compare b,
      Eq b) => Fset (Term a b) -> Fset (a, Nat) -> Reg (Bot_term a) a;
nf_reg r f = Reg (fstates r) (nf_ta r f);

foldb ::
  forall a b. (Ccompare a) => (a -> b -> b) -> Mapping_rbt a () -> b -> b;
foldb x xc = folda (\ a _ -> x a) (impl_of xc);

image ::
  forall a b.
    (Ceq a, Ccompare a, Ceq b, Ccompare b,
      Set_impl b) => (a -> b) -> Set a -> Set b;
image h (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "image RBT_set: ccompare = None" (\ _ -> image h (RBT_set rbt));
    Just _ -> foldb (insert . h) rbt bot_set;
  });
image g (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "image DList_set: ceq = None" (\ _ -> image g (DList_set dxs));
    Just _ -> foldc (insert . g) dxs bot_set;
  });
image f (Complement (Complement b)) = image f b;
image f (Collect_set a) =
  (error :: forall a. String -> (() -> a) -> a) "image Collect_set"
    (\ _ -> image f (Collect_set a));
image f (Set_Monad xs) = Set_Monad (map f xs);

filtera :: forall a. (Ceq a, Ccompare a) => (a -> Bool) -> Set a -> Set a;
filtera p a = inf_set a (Collect_set p);

fimage ::
  forall b a.
    (Ceq b, Ccompare b, Ceq a, Ccompare a,
      Set_impl a) => (b -> a) -> Fset b -> Fset a;
fimage xb xc = Abs_fset (image xb (fset xc));

bind :: forall a b. Maybe a -> (a -> Maybe b) -> Maybe b;
bind Nothing f = Nothing;
bind (Just x) f = f x;

comp_fun_idem_apply :: forall b a. Comp_fun_idem b a -> b -> a -> a;
comp_fun_idem_apply (Abs_comp_fun_idem x) = x;

set_fold_cfi ::
  forall a b. (Ceq a, Ccompare a) => Comp_fun_idem a b -> b -> Set a -> b;
set_fold_cfi f b (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "set_fold_cfi RBT_set: ccompare = None"
        (\ _ -> set_fold_cfi f b (RBT_set rbt));
    Just _ -> foldb (comp_fun_idem_apply f) rbt b;
  });
set_fold_cfi f b (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "set_fold_cfi DList_set: ceq = None"
        (\ _ -> set_fold_cfi f b (DList_set dxs));
    Just _ -> foldc (comp_fun_idem_apply f) dxs b;
  });
set_fold_cfi f b (Set_Monad xs) = fold (comp_fun_idem_apply f) xs b;
set_fold_cfi f b (Collect_set p) =
  (error :: forall a. String -> (() -> a) -> a)
    "set_fold_cfi not supported on Collect_set"
    (\ _ -> set_fold_cfi f b (Collect_set p));
set_fold_cfi f b (Complement a) =
  (error :: forall a. String -> (() -> a) -> a)
    "set_fold_cfi not supported on Complement"
    (\ _ -> set_fold_cfi f b (Complement a));

sup_cfi :: forall a. (Lattice a) => Comp_fun_idem a a;
sup_cfi = Abs_comp_fun_idem sup;

sup_seta ::
  forall a.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a,
      Set_impl a) => Set (Set a) -> Set a;
sup_seta a =
  (if finite a then set_fold_cfi sup_cfi bot_set a
    else (error :: forall a. String -> (() -> a) -> a) "Sup: infinite"
           (\ _ -> sup_seta a));

ffUnion ::
  forall a.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a) => Fset (Fset a) -> Fset a;
ffUnion xa = Abs_fset (sup_seta (image fset (fset xa)));

ffilter :: forall a. (Ceq a, Ccompare a) => (a -> Bool) -> Fset a -> Fset a;
ffilter xb xc = Abs_fset (filtera xb (fset xc));

finsert :: forall a. (Ceq a, Ccompare a) => a -> Fset a -> Fset a;
finsert xb xc = Abs_fset (insert xb (fset xc));

fmember :: forall a. (Ceq a, Ccompare a) => a -> Fset a -> Bool;
fmember x xc = member x (fset xc);

tl :: forall a. [a] -> [a];
tl [] = [];
tl (x21 : x22) = x22;

is_emptya :: forall a b. (Ccompare a) => Mapping_rbt a b -> Bool;
is_emptya xa = (case impl_of xa of {
                 Empty -> True;
                 Branch _ _ _ _ _ -> False;
               });

exhaustive_above_fusion ::
  forall a b. (Maybe a -> Maybe a -> Bool) -> Generator a b -> a -> b -> Bool;
exhaustive_above_fusion proper_interval g y s =
  (if has_next g s
    then (case next g s of {
           (x, sa) ->
             not (proper_interval (Just y) (Just x)) &&
               exhaustive_above_fusion proper_interval g x sa;
         })
    else not (proper_interval (Just y) Nothing));

exhaustive_fusion ::
  forall a b. (Maybe a -> Maybe a -> Bool) -> Generator a b -> b -> Bool;
exhaustive_fusion proper_interval g s =
  has_next g s &&
    (case next g s of {
      (x, sa) ->
        not (proper_interval Nothing (Just x)) &&
          exhaustive_above_fusion proper_interval g x sa;
    });

carda :: forall a. (Card_UNIV a) => Set a -> Nat;
carda = carda;

is_UNIV ::
  forall a.
    (Card_UNIV a, Ceq a, Cproper_interval a, Set_impl a) => Set a -> Bool;
is_UNIV (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "is_UNIV RBT_set: ccompare = None" (\ _ -> is_UNIV (RBT_set rbt));
    Just _ ->
      of_phantom (finite_UNIV :: Phantom a Bool) &&
        exhaustive_fusion cproper_interval rbt_keys_generator (init rbt);
  });
is_UNIV a =
  let {
    aa = (carda :: Set a -> Nat) (top_set :: Set a);
    b = carda a;
  } in (if less_nat zero_nat aa then equal_nat aa b
         else (if less_nat zero_nat b then False
                else (error :: forall a. String -> (() -> a) -> a)
                       "is_UNIV called on infinite type and set"
                       (\ _ -> is_UNIV a)));

nulla :: forall a. (Ceq a) => Set_dlist a -> Bool;
nulla xa = null (list_of_dlist xa);

is_empty ::
  forall a.
    (Card_UNIV a, Ceq a, Cproper_interval a, Set_impl a) => Set a -> Bool;
is_empty (Complement a) = is_UNIV a;
is_empty (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "is_empty RBT_set: ccompare = None" (\ _ -> is_empty (RBT_set rbt));
    Just _ -> is_emptya rbt;
  });
is_empty (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "is_empty DList_set: ceq = None" (\ _ -> is_empty (DList_set dxs));
    Just _ -> nulla dxs;
  });
is_empty (Set_Monad xs) = null xs;

funas_term ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a,
      Set_impl a) => Term a b -> Set (a, Nat);
funas_term (Var uu) = bot_set;
funas_term (Fun f ts) =
  sup_set (insert (f, size_list ts) bot_set)
    (sup_seta (set (map funas_term ts)));

funas_rule ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a,
      Set_impl a) => (Term a b, Term a b) -> Set (a, Nat);
funas_rule r = sup_set (funas_term (fst r)) (funas_term (snd r));

funas_trs ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Compare a, Eq a,
      Set_impl a, Compare b, Eq b) => Set (Term a b, Term a b) -> Set (a, Nat);
funas_trs r = sup_seta (image funas_rule r);

r_rhs :: forall a b. Ta_rule a b -> a;
r_rhs (TA_rule x1 x2 x3) = x3;

sup_fset :: forall a. (Ceq a, Ccompare a) => Fset a -> Fset a -> Fset a;
sup_fset xb xc = Abs_fset (sup_set (fset xb) (fset xc));

sigma ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Set_impl a,
      Finite_UNIV b, Cenum b, Ceq b, Cproper_interval b,
      Set_impl b) => Set a -> (a -> Set b) -> Set (a, b);
sigma a b =
  sup_seta
    (image (\ x -> sup_seta (image (\ y -> insert (x, y) bot_set) (b x))) a);

fSigma ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Set_impl a,
      Finite_UNIV b, Cenum b, Ceq b, Cproper_interval b,
      Set_impl b) => Fset a -> (a -> Fset b) -> Fset (a, b);
fSigma xb xc = Abs_fset (sigma (fset xb) ((fset . xc) . id));

delta_epsilon_infer1_cont ::
  forall a b c.
    (Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b, Eq b, Cenum c, Ceq c, Ccompare c, Eq c, Linorder c,
      Set_impl c) => Fset (Ta_rule a b) ->
                       Fset (a, a) ->
                         Fset (Ta_rule c b) ->
                           Fset (c, c) -> (a, c) -> Fset (a, c) -> [(a, c)];
delta_epsilon_infer1_cont delta_A delta_A_epsilon delta_B delta_B_epsilon pq bs
  = sorted_list_of_fset
      (sup_fset
        (sup_fset
          (fimage (map_prod r_rhs r_rhs)
            (ffilter
              (\ (ra, rb) ->
                (case (ra, rb) of {
                  (TA_rule f ps _, TA_rule g qs _) ->
                    f == g &&
                      equal_nat (size_list ps) (size_list qs) &&
                        membera (zip ps qs) (fst pq, snd pq) &&
                          less_eq_set (set (zip ps qs))
                            (insert (fst pq, snd pq) (fset bs));
                }))
              (fSigma delta_A (\ _ -> delta_B))))
          (fimage (\ (_, p) -> (p, snd pq))
            (ffilter (\ (p, _) -> p == fst pq) delta_A_epsilon)))
        (fimage (\ (_, a) -> (fst pq, a))
          (ffilter (\ (q, _) -> q == snd pq) delta_B_epsilon)));

delta_epsilon_infer0_cont ::
  forall a b c.
    (Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b, Ccompare b, Eq b,
      Ceq c, Ccompare c, Eq c, Linorder c,
      Set_impl c) => Fset (Ta_rule a b) -> Fset (Ta_rule c b) -> [(a, c)];
delta_epsilon_infer0_cont delta_A delta_B =
  sorted_list_of_fset
    (fimage (map_prod r_rhs r_rhs)
      (ffilter
        (\ (ra, rb) ->
          (case (ra, rb) of {
            (TA_rule f ps _, TA_rule g qs _) -> f == g && null ps && null qs;
          }))
        (fSigma delta_A (\ _ -> delta_B))));

saturate_rec ::
  forall a.
    (Ceq a,
      Ccompare a) => (a -> Fset a -> [a]) -> a -> Fset a -> Maybe (Fset a);
saturate_rec infer1_impl x bs =
  (if fmember x bs then Just bs
    else fold (\ xa a -> (case a of {
                           Nothing -> Nothing;
                           Just aa -> saturate_rec infer1_impl xa aa;
                         }))
           (infer1_impl x bs) (Just (finsert x bs)));

saturate_impl ::
  forall a.
    (Ceq a, Ccompare a,
      Set_impl a) => [a] -> (a -> Fset a -> [a]) -> Maybe (Fset a);
saturate_impl infer0_impl infer1_impl =
  fold (\ x a -> (case a of {
                   Nothing -> Nothing;
                   Just aa -> saturate_rec infer1_impl x aa;
                 }))
    infer0_impl (Just bot_fset);

delta_epsilon_impl ::
  forall a b c.
    (Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b, Eq b, Cenum c, Ceq c, Ccompare c, Eq c, Linorder c,
      Set_impl c) => Fset (Ta_rule a b) ->
                       Fset (a, a) ->
                         Fset (Ta_rule c b) ->
                           Fset (c, c) -> Maybe (Fset (a, c));
delta_epsilon_impl delta_A delta_A_epsilon delta_B delta_B_epsilon =
  saturate_impl (delta_epsilon_infer0_cont delta_A delta_B)
    (delta_epsilon_infer1_cont delta_A delta_A_epsilon delta_B delta_B_epsilon);

delta_epsilon ::
  forall a b.
    (Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b, Eq b) => Ta a b -> Ta a b -> Fset (a, a);
delta_epsilon (TA delta_A delta_A_epsilon) (TA delta_B delta_B_epsilon) =
  the (delta_epsilon_impl delta_A delta_A_epsilon delta_B delta_B_epsilon);

inf_fset :: forall a. (Ceq a, Ccompare a) => Fset a -> Fset a -> Fset a;
inf_fset xb xc = Abs_fset (inf_set (fset xb) (fset xc));

rules :: forall a b. Ta a b -> Fset (Ta_rule a b);
rules (TA x1 x2) = x1;

eps :: forall a b. Ta a b -> Fset (a, a);
eps (TA x1 x2) = x2;

r_lhs_states :: forall a b. Ta_rule a b -> [a];
r_lhs_states (TA_rule x1 x2 x3) = x2;

rule_states ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b) => Fset (Ta_rule a b) -> Fset a;
rule_states delta =
  ffUnion
    (fimage (\ r -> finsert (r_rhs r) (fset_of_list (r_lhs_states r))) delta);

eps_states ::
  forall a.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a) => Fset (a, a) -> Fset a;
eps_states delta_epsilon =
  ffUnion (fimage (\ (q, qa) -> finsert q (finsert qa bot_fset)) delta_epsilon);

q :: forall a b.
       (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
         Set_impl a, Ceq b, Ccompare b) => Ta a b -> Fset a;
q a = sup_fset (rule_states (rules a)) (eps_states (eps a));

gtt_interface ::
  forall a b c.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b, Ceq c,
      Ccompare c) => (Ta a b, Ta a c) -> Fset a;
gtt_interface g = inf_fset (q (fst g)) (q (snd g));

aGTT_comp ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b,
      Eq b) => (Ta a b, Ta a b) -> (Ta a b, Ta a b) -> (Ta a b, Ta a b);
aGTT_comp g_1 g_2 =
  let {
    a = (fst g_1, snd g_2);
  } in (case a of {
         (aa, b) ->
           (TA (rules aa)
              (sup_fset (eps aa)
                (inf_fset (delta_epsilon (snd g_1) (fst g_2))
                  (fSigma (gtt_interface g_1) (\ _ -> gtt_interface g_2)))),
             TA (rules b) (eps b));
       });

nnf :: forall a b. Bool -> Form a b -> Form a b;
nnf b TT = (if b then TT else FF);
nnf b FF = (if b then FF else TT);
nnf b (Pred p ts) = (if b then id else Neg) (Pred p ts);
nnf b (And p q) = (if b then And else Or) (nnf b p) (nnf b q);
nnf b (Or p q) = (if b then Or else And) (nnf b p) (nnf b q);
nnf b (Impl p q) = (if b then Or else And) (nnf (not b) p) (nnf b q);
nnf b (Neg p) = nnf (not b) p;
nnf b (Forall p) = (if b then Forall else Exists) (nnf b p);
nnf b (Exists p) = (if b then Exists else Forall) (nnf b p);

gtt_states ::
  forall a b c.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b, Ceq c,
      Ccompare c) => (Ta a b, Ta a c) -> Fset a;
gtt_states g = sup_fset (q (fst g)) (q (snd g));

replicate :: forall a. Nat -> a -> [a];
replicate n x =
  (if equal_nat n zero_nat then [] else x : replicate (minus_nat n one_nat) x);

rBT_Impl_diag :: forall a b. Rbt a b -> Rbt (a, a) b;
rBT_Impl_diag Empty = Empty;
rBT_Impl_diag (Branch c l k v r) =
  Branch c (rBT_Impl_diag l) (k, k) v (rBT_Impl_diag r);

diag :: forall a b. (Ccompare a) => Mapping_rbt a b -> Mapping_rbt (a, a) b;
diag xa = Mapping_RBT (rBT_Impl_diag (impl_of xa));

id_ona :: forall a. (Ceq a) => Set_dlist a -> Set_dlist (a, a);
id_ona xa = Abs_dlist (map (\ x -> (x, x)) (list_of_dlist xa));

id_on :: forall a. (Ceq a, Ccompare a, Set_impl a) => Set a -> Set (a, a);
id_on (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "Id_on RBT_set: ccompare = None" (\ _ -> id_on (RBT_set rbt));
    Just _ -> RBT_set (diag rbt);
  });
id_on (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "Id_on DList_set: ceq = None" (\ _ -> id_on (DList_set dxs));
    Just _ -> DList_set (id_ona dxs);
  });
id_on (Collect_set p) =
  (case ceq of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "Id_on Collect_set: ceq = None" (\ _ -> id_on (Collect_set p));
    Just eq -> Collect_set (\ (x, y) -> eq x y && p x);
  });
id_on (Complement a) =
  (case ceq of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "Id_on Complement: ceq = None" (\ _ -> id_on (Complement a));
    Just eq -> Collect_set (\ (x, y) -> eq x y && not (member x a));
  });
id_on b = image (\ x -> (x, x)) b;

imagea ::
  forall a b.
    (Ceq a, Ccompare a, Ceq b, Ccompare b,
      Set_impl b) => Set (a, b) -> Set a -> Set b;
imagea (RBT_set rbt) c =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "Image RBT_set: ccompare1 = None" (\ _ -> imagea (RBT_set rbt) c);
    Just _ ->
      (case (ccompare :: Maybe (b -> b -> Ordera)) of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "Image RBT_set: ccompare2 = None" (\ _ -> imagea (RBT_set rbt) c);
        Just _ ->
          foldb (\ (x, y) acc -> (if member x c then insert y acc else acc)) rbt
            bot_set;
      });
  });
imagea (DList_set dxs) b =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "Image DList_set: ceq1 = None" (\ _ -> imagea (DList_set dxs) b);
    Just _ ->
      (case (ceq :: Maybe (b -> b -> Bool)) of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "Image DList_set: ceq2 = None" (\ _ -> imagea (DList_set dxs) b);
        Just _ ->
          foldc (\ (x, y) acc -> (if member x b then insert y acc else acc)) dxs
            bot_set;
      });
  });
imagea (Set_Monad rxs) a =
  Set_Monad
    (fold (\ (x, y) rest -> (if member x a then y : rest else rest)) rxs []);
imagea x y = image snd (filtera (\ (xa, _) -> member xa y) x);

ta_union ::
  forall a b.
    (Ceq a, Ccompare a, Ceq b, Ccompare b) => Ta a b -> Ta a b -> Ta a b;
ta_union a b = TA (sup_fset (rules a) (rules b)) (sup_fset (eps a) (eps b));

aGTT_union ::
  forall a b c d.
    (Ceq a, Ccompare a, Ceq b, Ccompare b, Ceq c, Ccompare c, Ceq d,
      Ccompare d) => (Ta a b, Ta c d) -> (Ta a b, Ta c d) -> (Ta a b, Ta c d);
aGTT_union g_1 g_2 =
  (ta_union (fst g_1) (fst g_2), ta_union (snd g_1) (snd g_2));

list_remdups :: forall a. (a -> a -> Bool) -> [a] -> [a];
list_remdups equal (x : xs) =
  (if list_member equal xs x then list_remdups equal xs
    else x : list_remdups equal xs);
list_remdups equal [] = [];

length :: forall a. (Ceq a) => Set_dlist a -> Nat;
length xa = size_list (list_of_dlist xa);

card :: forall a. (Card_UNIV a, Ceq a, Ccompare a, Set_impl a) => Set a -> Nat;
card (Complement a) =
  let {
    aa = carda a;
    s = (carda :: Set a -> Nat) (top_set :: Set a);
  } in (if less_nat zero_nat s then minus_nat s aa
         else (if finitea a then zero_nat
                else (error :: forall a. String -> (() -> a) -> a)
                       "card Complement: infinite"
                       (\ _ -> carda (Complement a))));
card (Set_Monad xs) =
  (case ceq of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a) "card Set_Monad: ceq = None"
        (\ _ -> card (Set_Monad xs));
    Just eq -> size_list (list_remdups eq xs);
  });
card (RBT_set rbt) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "card RBT_set: ccompare = None" (\ _ -> card (RBT_set rbt));
    Just _ -> size_list (keysa rbt);
  });
card (DList_set dxs) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a) "card DList_set: ceq = None"
        (\ _ -> card (DList_set dxs));
    Just _ -> length dxs;
  });

mem_idx :: forall a. (Eq a) => a -> [a] -> Maybe Nat;
mem_idx uu [] = Nothing;
mem_idx x (a : asa) =
  (if x == a then Just zero_nat else map_option suc (mem_idx x asa));

map_fset_to_nat ::
  forall a. (Ceq a, Ccompare a, Eq a, Linorder a) => Fset a -> a -> Nat;
map_fset_to_nat x = (\ xa -> the (mem_idx xa (sorted_list_of_fset x)));

map_ta_rule ::
  forall a b c d. (a -> b) -> (c -> d) -> Ta_rule a c -> Ta_rule b d;
map_ta_rule f1 f2 (TA_rule x1 x2 x3) = TA_rule (f2 x1) (map f1 x2) (f1 x3);

fmap_states_ta ::
  forall a b c.
    (Ceq a, Ccompare a, Ceq b, Ccompare b, Set_impl b, Ceq c,
      Ccompare c) => (a -> b) -> Ta a c -> Ta b c;
fmap_states_ta f a =
  TA (fimage (map_ta_rule f id) (rules a)) (fimage (map_prod f f) (eps a));

fmap_states_gtt ::
  forall a b c.
    (Ceq a, Ccompare a, Ceq b, Ccompare b, Set_impl b, Ceq c,
      Ccompare c) => (a -> b) -> (Ta a c, Ta a c) -> (Ta b c, Ta b c);
fmap_states_gtt f = map_prod (fmap_states_ta f) (fmap_states_ta f);

relabel_gtt ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b,
      Ccompare b) => (Ta a b, Ta a b) -> (Ta Nat b, Ta Nat b);
relabel_gtt g = fmap_states_gtt (map_fset_to_nat (gtt_states g)) g;

r_root :: forall a b. Ta_rule a b -> b;
r_root (TA_rule x1 x2 x3) = x1;

relcomp ::
  forall a b c.
    (Ceq a, Ccompare a, Set_impl a, Ceq b, Ccompare b, Ceq c, Ccompare c,
      Set_impl c) => Set (a, b) -> Set (b, c) -> Set (a, c);
relcomp (Set_Monad xs6) (DList_set dxs4) =
  (case ceq of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "relcomp Set_Monad DList_set: ceq1 = None"
        (\ _ -> relcomp (Set_Monad xs6) (DList_set dxs4));
    Just eq ->
      (case (ceq :: Maybe (c -> c -> Bool)) of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "relcomp Set_Monad DList_set: ceq2 = None"
            (\ _ -> relcomp (Set_Monad xs6) (DList_set dxs4));
        Just _ ->
          fold (\ (x, y) ->
                 foldc (\ (ya, z) a -> (if eq y ya then insert (x, z) a else a))
                   dxs4)
            xs6 bot_set;
      });
  });
relcomp (DList_set dxs3) (Set_Monad xs5) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "relcomp DList_set Set_Monad: ceq1 = None"
        (\ _ -> relcomp (DList_set dxs3) (Set_Monad xs5));
    Just _ ->
      (case ceq of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "relcomp DList_set Set_Monad: ceq2 = None"
            (\ _ -> relcomp (DList_set dxs3) (Set_Monad xs5));
        Just eq ->
          foldc (\ (x, y) ->
                  fold (\ (ya, z) a -> (if eq y ya then insert (x, z) a else a))
                    xs5)
            dxs3 bot_set;
      });
  });
relcomp (Set_Monad xs4) (RBT_set rbt5) =
  (case (ccompare :: Maybe (c -> c -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "relcomp Set_Monad RBT_set: ccompare1 = None"
        (\ _ -> relcomp (Set_Monad xs4) (RBT_set rbt5));
    Just _ ->
      (case ccompare of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "relcomp Set_Monad RBT_set: ccompare2 = None"
            (\ _ -> relcomp (Set_Monad xs4) (RBT_set rbt5));
        Just c_b ->
          fold (\ (x, y) ->
                 foldb (\ (ya, z) a ->
                         (if not (equal_order (c_b y ya) Eqa) then a
                           else insert (x, z) a))
                   rbt5)
            xs4 bot_set;
      });
  });
relcomp (RBT_set rbt1) (Set_Monad xs3) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "relcomp RBT_set Set_Monad: ccompare1 = None"
        (\ _ -> relcomp (RBT_set rbt1) (Set_Monad xs3));
    Just _ ->
      (case ccompare of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "relcomp RBT_set Set_Monad: ccompare2 = None"
            (\ _ -> relcomp (RBT_set rbt1) (Set_Monad xs3));
        Just c_b ->
          foldb (\ (x, y) ->
                  fold (\ (ya, z) a ->
                         (if not (equal_order (c_b y ya) Eqa) then a
                           else insert (x, z) a))
                    xs3)
            rbt1 bot_set;
      });
  });
relcomp (Set_Monad xs1) (Set_Monad xs2) =
  (case ceq of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "relcomp Set_Monad Set_Monad: ceq = None"
        (\ _ -> relcomp (Set_Monad xs1) (Set_Monad xs2));
    Just eq ->
      fold (\ (x, y) ->
             fold (\ (ya, z) a -> (if eq y ya then insert (x, z) a else a)) xs2)
        xs1 bot_set;
  });
relcomp (DList_set dxs3) (DList_set dxs4) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "relcomp DList_set DList_set: ceq1 = None"
        (\ _ -> relcomp (DList_set dxs3) (DList_set dxs4));
    Just _ ->
      (case ceq of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "relcomp DList_set DList_set: ceq2 = None"
            (\ _ -> relcomp (DList_set dxs3) (DList_set dxs4));
        Just eq ->
          (case (ceq :: Maybe (c -> c -> Bool)) of {
            Nothing ->
              (error :: forall a. String -> (() -> a) -> a)
                "relcomp DList_set DList_set: ceq3 = None"
                (\ _ -> relcomp (DList_set dxs3) (DList_set dxs4));
            Just _ ->
              foldc (\ (x, y) ->
                      foldc (\ (ya, z) a ->
                              (if eq y ya then insert (x, z) a else a))
                        dxs4)
                dxs3 bot_set;
          });
      });
  });
relcomp (DList_set dxs2) (RBT_set rbt4) =
  (case (ceq :: Maybe (a -> a -> Bool)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "relcomp DList_set RBT_set: ceq1 = None"
        (\ _ -> relcomp (DList_set dxs2) (RBT_set rbt4));
    Just _ ->
      (case (ccompare :: Maybe (b -> b -> Ordera)) of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "relcomp DList_set RBT_set: ceq2 = None"
            (\ _ -> relcomp (DList_set dxs2) (RBT_set rbt4));
        Just _ ->
          (case ceq of {
            Nothing ->
              (error :: forall a. String -> (() -> a) -> a)
                "relcomp DList_set RBT_set: ccompare2 = None"
                (\ _ -> relcomp (DList_set dxs2) (RBT_set rbt4));
            Just eq ->
              (case (ccompare :: Maybe (c -> c -> Ordera)) of {
                Nothing ->
                  (error :: forall a. String -> (() -> a) -> a)
                    "relcomp DList_set RBT_set: ccompare3 = None"
                    (\ _ -> relcomp (DList_set dxs2) (RBT_set rbt4));
                Just _ ->
                  foldc (\ (x, y) ->
                          foldb (\ (ya, z) a ->
                                  (if eq y ya then insert (x, z) a else a))
                            rbt4)
                    dxs2 bot_set;
              });
          });
      });
  });
relcomp (RBT_set rbt3) (DList_set dxs1) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "relcomp RBT_set DList_set: ccompare1 = None"
        (\ _ -> relcomp (RBT_set rbt3) (DList_set dxs1));
    Just _ ->
      (case (ccompare :: Maybe (b -> b -> Ordera)) of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "relcomp RBT_set DList_set: ccompare2 = None"
            (\ _ -> relcomp (RBT_set rbt3) (DList_set dxs1));
        Just _ ->
          (case ceq of {
            Nothing ->
              (error :: forall a. String -> (() -> a) -> a)
                "relcomp RBT_set DList_set: ceq2 = None"
                (\ _ -> relcomp (RBT_set rbt3) (DList_set dxs1));
            Just eq ->
              (case (ceq :: Maybe (c -> c -> Bool)) of {
                Nothing ->
                  (error :: forall a. String -> (() -> a) -> a)
                    "relcomp RBT_set DList_set: ceq3 = None"
                    (\ _ -> relcomp (RBT_set rbt3) (DList_set dxs1));
                Just _ ->
                  foldb (\ (x, y) ->
                          foldc (\ (ya, z) a ->
                                  (if eq y ya then insert (x, z) a else a))
                            dxs1)
                    rbt3 bot_set;
              });
          });
      });
  });
relcomp (RBT_set rbt1) (RBT_set rbt2) =
  (case (ccompare :: Maybe (a -> a -> Ordera)) of {
    Nothing ->
      (error :: forall a. String -> (() -> a) -> a)
        "relcomp RBT_set RBT_set: ccompare1 = None"
        (\ _ -> relcomp (RBT_set rbt1) (RBT_set rbt2));
    Just _ ->
      (case ccompare of {
        Nothing ->
          (error :: forall a. String -> (() -> a) -> a)
            "relcomp RBT_set RBT_set: ccompare2 = None"
            (\ _ -> relcomp (RBT_set rbt1) (RBT_set rbt2));
        Just c_b ->
          (case (ccompare :: Maybe (c -> c -> Ordera)) of {
            Nothing ->
              (error :: forall a. String -> (() -> a) -> a)
                "relcomp RBT_set RBT_set: ccompare3 = None"
                (\ _ -> relcomp (RBT_set rbt1) (RBT_set rbt2));
            Just _ ->
              foldb (\ (x, y) ->
                      foldb (\ (ya, z) a ->
                              (if not (equal_order (c_b y ya) Eqa) then a
                                else insert (x, z) a))
                        rbt2)
                rbt1 bot_set;
          });
      });
  });

ntrancl ::
  forall a. (Ceq a, Ccompare a, Set_impl a) => Nat -> Set (a, a) -> Set (a, a);
ntrancl n r =
  (if equal_nat n zero_nat then r else let {
 ra = ntrancl (minus_nat n one_nat) r;
                                       } in sup_set ra (relcomp ra r));

trancl ::
  forall a.
    (Card_UNIV a, Ceq a, Ccompare a, Set_impl a) => Set (a, a) -> Set (a, a);
trancl a =
  (if finite a then ntrancl (minus_nat (card a) one_nat) a
    else (error :: forall a. String -> (() -> a) -> a) "trancl: infinite set"
           (\ _ -> trancl a));

ftrancl ::
  forall a.
    (Card_UNIV a, Ceq a, Ccompare a, Set_impl a) => Fset (a, a) -> Fset (a, a);
ftrancl xa = Abs_fset (trancl (fset xa));

fImage ::
  forall b a.
    (Ceq b, Ccompare b, Ceq a, Ccompare a,
      Set_impl a) => Fset (b, a) -> Fset b -> Fset a;
fImage xb xc = Abs_fset (imagea (fset xb) (fset xc));

qn :: forall a b.
        (Card_UNIV a, Ceq a, Ccompare a, Set_impl a, Ceq b,
          Ccompare b) => Ta a (Maybe b) -> Fset a;
qn a = let {
         s = fimage r_rhs (ffilter (\ r -> is_none (r_root r)) (rules a));
       } in sup_fset (fImage (ftrancl (eps a)) s) s;

qs :: forall a b.
        (Card_UNIV a, Ceq a, Ccompare a, Set_impl a, Ceq b,
          Ccompare b) => Ta a (Maybe b) -> Fset a;
qs a =
  let {
    s = fimage r_rhs (ffilter (\ r -> not (is_none (r_root r))) (rules a));
  } in sup_fset (fImage (ftrancl (eps a)) s) s;

delta_Atr_infer1_cont ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b,
      Eq b) => Fset (a, a) ->
                 Fset (Ta_rule a b) ->
                   Fset (a, a) ->
                     Fset (Ta_rule a b) ->
                       Fset (a, a) -> (a, a) -> Fset (a, a) -> [(a, a)];
delta_Atr_infer1_cont q delta_A delta_A_epsilon delta_B delta_B_epsilon pq bs =
  let {
    g = the (delta_epsilon_impl delta_B delta_B_epsilon delta_A
              delta_A_epsilon);
  } in sorted_list_of_fset
         (sup_fset
           (sup_fset
             (fimage (\ (p, _) -> (fst p, snd pq))
               (ffilter (\ (p, qa) -> snd p == fst qa && snd qa == fst pq)
                 (fSigma bs (\ _ -> g))))
             (fimage (\ (_, qa) -> (fst pq, snd qa))
               (ffilter (\ (p, qa) -> snd p == fst qa && fst p == snd pq)
                 (fSigma g (\ _ -> bs)))))
           (fimage (\ (_, _) -> (fst pq, snd pq))
             (ffilter (\ (p, qa) -> snd pq == p && fst pq == qa) g)));

delta_Atr_impl ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b,
      Eq b) => Fset (a, a) ->
                 Fset (Ta_rule a b) ->
                   Fset (a, a) ->
                     Fset (Ta_rule a b) -> Fset (a, a) -> Maybe (Fset (a, a));
delta_Atr_impl q delta_A delta_A_epsilon delta_B delta_B_epsilon =
  saturate_impl (sorted_list_of_fset q)
    (delta_Atr_infer1_cont q delta_A delta_A_epsilon delta_B delta_B_epsilon);

delta_Atrans ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b,
      Eq b) => Fset (a, a) -> Ta a b -> Ta a b -> Fset (a, a);
delta_Atrans q (TA delta_A delta_A_epsilon) (TA delta_B delta_B_epsilon) =
  the (delta_Atr_impl q delta_A delta_A_epsilon delta_B delta_B_epsilon);

fId_on :: forall a. (Ceq a, Ccompare a, Set_impl a) => Fset a -> Fset (a, a);
fId_on xa = Abs_fset (id_on (fset xa));

aGTT_trancl ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b,
      Eq b) => (Ta a b, Ta a b) -> (Ta (Sum a a) b, Ta (Sum a a) b);
aGTT_trancl g =
  let {
    a = fmap_states_ta Inl (fst g);
  } in (TA (rules a)
          (sup_fset (eps a)
            (fimage (map_prod Inl Inr)
              (delta_Atrans (fId_on (gtt_interface g)) (fst g) (snd g)))),
         TA (fimage (map_ta_rule Inr id) (rules (snd g)))
           (fimage (map_prod Inr Inr) (eps (snd g))));

liftO1 :: forall a b. (a -> b) -> Maybe a -> Maybe b;
liftO1 = map_option;

liftO2 :: forall a b c. (a -> b -> c) -> Maybe a -> Maybe b -> Maybe c;
liftO2 f a b = (case a of {
                 Nothing -> Nothing;
                 Just aa -> liftO1 (f aa) b;
               });

linear_term_impl ::
  forall a b. (Ceq a, Ccompare a) => Set a -> Term b a -> Maybe (Set a);
linear_term_impl xs (Var x) =
  (if member x xs then Nothing else Just (insert x xs));
linear_term_impl xs (Fun uu []) = Just xs;
linear_term_impl xs (Fun f (t : ts)) =
  (case linear_term_impl xs t of {
    Nothing -> Nothing;
    Just ys -> linear_term_impl ys (Fun f ts);
  });

linear_term :: forall a b. (Ceq b, Ccompare b, Set_impl b) => Term a b -> Bool;
linear_term t = not (is_none (linear_term_impl bot_set t));

vars_term ::
  forall a b.
    (Compare a, Eq a, Finite_UNIV b, Cenum b, Ceq b, Cproper_interval b,
      Compare b, Eq b, Set_impl b) => Term a b -> Set b;
vars_term (Var x1) = insert x1 bot_set;
vars_term (Fun x21 x22) = sup_seta (image vars_term (set x22));

lv_trs ::
  forall a b.
    (Compare a, Eq a, Card_UNIV b, Cenum b, Ceq b, Cproper_interval b,
      Compare b, Eq b, Set_impl b) => Set (Term a b, Term a b) -> Bool;
lv_trs r =
  ball r
    (\ (l, ra) ->
      linear_term l &&
        linear_term ra && is_empty (inf_set (vars_term l) (vars_term ra)));

subtract_list_sorted :: forall a. (Eq a, Linorder a) => [a] -> [a] -> [a];
subtract_list_sorted (x : xs) (y : ys) =
  (if x == y then subtract_list_sorted xs (y : ys)
    else (if less x y then x : subtract_list_sorted xs (y : ys)
           else subtract_list_sorted (x : xs) ys));
subtract_list_sorted [] ys = [];
subtract_list_sorted (v : va) [] = v : va;

swap :: forall a b. (a, b) -> (b, a);
swap p = (snd p, fst p);

zip_fill :: forall a b. [a] -> [b] -> [(Maybe a, Maybe b)];
zip_fill (x : xs) (y : ys) = (Just x, Just y) : zip_fill xs ys;
zip_fill [] ys = map (\ y -> (Nothing, Just y)) ys;
zip_fill xs [] = map (\ x -> (Just x, Nothing)) xs;

pair_automaton ::
  forall a b c d.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b, Finite_UNIV c, Cenum c, Ceq c,
      Cproper_interval c, Eq c, Linorder c, Set_impl c, Ceq d,
      Ccompare d) => Ta a b ->
                       Ta c d -> Ta (Maybe a, Maybe c) (Maybe b, Maybe d);
pair_automaton a b =
  TA (sup_fset
       (sup_fset
         (fimage
           (map_ta_rule (\ s -> (Just s, Nothing)) (\ s -> (Just s, Nothing)))
           (rules a))
         (fimage
           (map_ta_rule (\ s -> (Nothing, Just s)) (\ s -> (Nothing, Just s)))
           (rules b)))
       (fimage
         (\ (ra, rb) ->
           TA_rule (Just (r_root ra), Just (r_root rb))
             (zip_fill (r_lhs_states ra) (r_lhs_states rb))
             (Just (r_rhs ra), Just (r_rhs rb)))
         (fSigma (rules a) (\ _ -> rules b))))
    (sup_fset
      (fimage (\ (p, qa) -> ((Just (fst p), qa), (Just (snd p), qa)))
        (fSigma (eps a) (\ _ -> finsert Nothing (fimage Just (q b)))))
      (fimage (map_prod swap swap)
        (fimage (\ (p, qa) -> ((Just (fst p), qa), (Just (snd p), qa)))
          (fSigma (eps b) (\ _ -> finsert Nothing (fimage Just (q a)))))));

fin :: forall a b. Reg a b -> Fset a;
fin (Reg x1 x2) = x1;

ta :: forall a b. Reg a b -> Ta a b;
ta (Reg x1 x2) = x2;

pair_automaton_reg ::
  forall a b c d.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b, Finite_UNIV c, Cenum c, Ceq c,
      Cproper_interval c, Eq c, Linorder c, Set_impl c, Ceq d,
      Ccompare d) => Reg a b ->
                       Reg c d -> Reg (Maybe a, Maybe c) (Maybe b, Maybe d);
pair_automaton_reg r l =
  Reg (fSigma (fimage Just (fin r)) (\ _ -> fimage Just (fin l)))
    (pair_automaton (ta r) (ta l));

fmap_funs_ta ::
  forall a b c.
    (Ceq a, Ccompare a, Ceq b, Ccompare b, Ceq c,
      Ccompare c) => (a -> b) -> Ta c a -> Ta c b;
fmap_funs_ta f a = TA (fimage (map_ta_rule id f) (rules a)) (eps a);

fmap_funs_reg ::
  forall a b c.
    (Ceq a, Ccompare a, Ceq b, Ccompare b, Ceq c,
      Ccompare c) => (a -> b) -> Reg c a -> Reg c b;
fmap_funs_reg f r = Reg (fin r) (fmap_funs_ta f (ta r));

pad_with_Nones ::
  forall a. Nat -> Nat -> (Maybe [Maybe a], Maybe [Maybe a]) -> [Maybe a];
pad_with_Nones n m =
  (\ (f, g) ->
    (case f of {
      Nothing -> replicate n Nothing;
      Just a -> id a;
    }) ++
      (case g of {
        Nothing -> replicate m Nothing;
        Just a -> id a;
      }));

relabel_Q_f ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b) => Fset a -> Ta a b -> Fset Nat;
relabel_Q_f qa a = fimage (map_fset_to_nat (q a)) (inf_fset qa (q a));

relabel_ta ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b) => Ta a b -> Ta Nat b;
relabel_ta a = fmap_states_ta (map_fset_to_nat (q a)) a;

relabel_reg ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b) => Reg a b -> Reg Nat b;
relabel_reg r = Reg (relabel_Q_f (fin r) (ta r)) (relabel_ta (ta r));

productive_infer1_cont ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b,
      Ccompare b) => Fset (Ta_rule a b) -> Fset (a, a) -> a -> Fset a -> [a];
productive_infer1_cont delta delta_epsilon p bs =
  sorted_list_of_fset
    (sup_fset
      (fimage (\ (q, _) -> q) (ffilter (\ (_, r) -> r == p) delta_epsilon))
      (ffUnion
        (fimage (fset_of_list . r_lhs_states)
          (ffilter (\ (TA_rule _ _ q) -> q == p) delta))));

productive_cont_impl ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b,
      Ccompare b) => Fset a ->
                       Fset (Ta_rule a b) -> Fset (a, a) -> Maybe (Fset a);
productive_cont_impl p delta delta_epsilon =
  saturate_impl (sorted_list_of_fset p)
    (productive_infer1_cont delta delta_epsilon);

ta_productive ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b) => Fset a -> Ta a b -> Fset a;
ta_productive p (TA delta delta_epsilon) =
  the (productive_cont_impl p delta delta_epsilon);

reach_infer1_cont ::
  forall a b.
    (Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b) => Fset (Ta_rule a b) -> Fset (a, a) -> a -> Fset a -> [a];
reach_infer1_cont delta delta_epsilon p bs =
  sorted_list_of_fset
    (sup_fset
      (fimage r_rhs
        (ffilter
          (\ (TA_rule _ qs _) ->
            fmember p (fset_of_list qs) &&
              less_eq_fset (fset_of_list qs) (finsert p bs))
          delta))
      (fimage (\ (_, r) -> r) (ffilter (\ (q, _) -> q == p) delta_epsilon)));

reach_infer0_cont ::
  forall a b.
    (Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b) => Fset (Ta_rule a b) -> [a];
reach_infer0_cont delta =
  sorted_list_of_fset
    (fimage r_rhs (ffilter (\ (TA_rule _ ps _) -> null ps) delta));

reach_cont_impl ::
  forall a b.
    (Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b) => Fset (Ta_rule a b) -> Fset (a, a) -> Maybe (Fset a);
reach_cont_impl delta delta_epsilon =
  saturate_impl (reach_infer0_cont delta)
    (reach_infer1_cont delta delta_epsilon);

ta_reachable ::
  forall a b.
    (Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b) => Ta a b -> Fset a;
ta_reachable (TA delta delta_epsilon) =
  the (reach_cont_impl delta delta_epsilon);

ta_restrict ::
  forall a b.
    (Cenum a, Ceq a, Ccompare a, Set_impl a, Ceq b,
      Ccompare b) => Ta a b -> Fset a -> Ta a b;
ta_restrict a q =
  let {
    rulesa =
      ffilter
        (\ (TA_rule _ ps p) -> less_eq_fset (fset_of_list ps) q && fmember p q)
        (rules a);
    aa = ffilter (\ (p, qa) -> fmember p q && fmember qa q) (eps a);
  } in TA rulesa aa;

trim_ta ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b) => Fset a -> Ta a b -> Ta a b;
trim_ta p a =
  ta_restrict (ta_restrict a (ta_reachable a))
    (ta_productive p (ta_restrict a (ta_reachable a)));

trim_reg ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b) => Reg a b -> Reg a b;
trim_reg r = Reg (fin r) (trim_ta (fin r) (ta r));

term_automaton :: forall a. (Ceq a, Ccompare a) => Fset (a, Nat) -> Ta () a;
term_automaton f =
  TA (fimage (\ (fa, n) -> TA_rule fa (replicate n ()) ()) f) bot_fset;

term_reg :: forall a. (Ceq a, Ccompare a) => Fset (a, Nat) -> Reg () a;
term_reg f = Reg (finsert () bot_fset) (term_automaton f);

true_RRn ::
  forall a. (Ceq a, Ccompare a) => Fset (a, Nat) -> Nat -> Reg Nat [Maybe a];
true_RRn f v =
  (if equal_nat v zero_nat
    then Reg (finsert zero_nat bot_fset)
           (TA (finsert (TA_rule [] [] zero_nat) bot_fset) bot_fset)
    else (if equal_nat (minus_nat v one_nat) zero_nat
           then relabel_reg (fmap_funs_reg (\ fa -> [Just fa]) (term_reg f))
           else relabel_reg
                  (trim_reg
                    (fmap_funs_reg
                      (pad_with_Nones one_nat
                        (suc (minus_nat (minus_nat v one_nat) one_nat)))
                      (pair_automaton_reg (true_RRn f one_nat)
                        (true_RRn f
                          (suc (minus_nat (minus_nat v one_nat) one_nat))))))));

fit_permute :: [Nat] -> [Nat] -> [Nat] -> [Nat];
fit_permute vsb vsa vs =
  map (\ v ->
        (if membera vsb v then the (mem_idx v vsb)
          else plus_nat (size_list vsb) (the (mem_idx v vs))))
    vsa;

fit_rrn ::
  forall a.
    (Ceq a,
      Ccompare a) => Fset (a, Nat) ->
                       [Nat] ->
                         [Nat] ->
                           Reg Nat [Maybe a] ->
                             Reg (Maybe Nat, Maybe Nat) [Maybe a];
fit_rrn f vsa vs a =
  let {
    vsb = subtract_list_sorted vs vsa;
  } in fmap_funs_reg (\ fs -> map (nth fs) (fit_permute vsa vs vsb))
         (fmap_funs_reg (pad_with_Nones (size_list vsa) (size_list vsb))
           (pair_automaton_reg a (true_RRn f (size_list vsb))));

reg_union ::
  forall a b c.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b, Finite_UNIV c, Cenum c, Ceq c,
      Cproper_interval c, Eq c, Linorder c,
      Set_impl c) => Reg a b -> Reg c b -> Reg (Sum a c) b;
reg_union r l =
  Reg (sup_fset (fimage Inl (inf_fset (fin r) (q (ta r))))
        (fimage Inr (inf_fset (fin l) (q (ta l)))))
    (ta_union (fmap_states_ta Inl (ta r)) (fmap_states_ta Inr (ta l)));

for_rrn ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Compare a, Eq a,
      Linorder a, Set_impl a, Ceq b, Ccompare b) => [Reg a b] -> Reg Nat b;
for_rrn tas =
  fold (\ a b -> relabel_reg (reg_union a b)) tas
    (Reg bot_fset (TA bot_fset bot_fset));

fsubterms ::
  forall a b. (Compare a, Eq a, Compare b, Eq b) => Term a b -> Fset (Term a b);
fsubterms (Fun f ts) =
  sup_fset (finsert (Fun f ts) bot_fset)
    (ffUnion (fimage fsubterms (fset_of_list ts)));
fsubterms (Var x) = finsert (Var x) bot_fset;

fstatesa ::
  forall a b.
    (Compare a, Eq a, Compare b, Eq b) => Fset (Term a b) -> Fset (Bot_term a);
fstatesa r = fimage term_to_bot_term (ffUnion (fimage fsubterms r));

prod_ta_rules ::
  forall a b c.
    (Ceq a, Ccompare a, Ceq b, Ccompare b, Eq b, Ceq c,
      Ccompare c) => Ta a b -> Ta c b -> Fset (Ta_rule (a, c) b);
prod_ta_rules a bb =
  fimage (\ (TA_rule _ ps p, TA_rule f qs q) -> TA_rule f (zip ps qs) (p, q))
    (ffilter
      (\ (TA_rule f ps _, TA_rule g qs _) ->
        f == g && equal_nat (size_list ps) (size_list qs))
      (fSigma (rules a) (\ _ -> rules bb)));

prod_ta ::
  forall a b c.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b, Eq b, Finite_UNIV c, Cenum c, Ceq c,
      Cproper_interval c, Eq c, Linorder c,
      Set_impl c) => Ta a b -> Ta c b -> Ta (a, c) b;
prod_ta a b =
  TA (prod_ta_rules a b)
    (sup_fset
      (fimage (\ (aa, ba) -> (case aa of {
                               (p, qa) -> (\ r -> ((p, r), (qa, r)));
                             })
                               ba)
        (fSigma (eps a) (\ _ -> q b)))
      (fimage (\ (aa, ba) -> (case aa of {
                               (p, qa) -> (\ r -> ((r, p), (r, qa)));
                             })
                               ba)
        (fSigma (eps b) (\ _ -> q a))));

reg_intersect ::
  forall a b c.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b, Eq b, Finite_UNIV c, Cenum c, Ceq c,
      Cproper_interval c, Eq c, Linorder c,
      Set_impl c) => Reg a b -> Reg c b -> Reg (a, c) b;
reg_intersect r l = Reg (fSigma (fin r) (\ _ -> fin l)) (prod_ta (ta r) (ta l));

simplify_reg ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b) => Reg a b -> Reg Nat b;
simplify_reg a = relabel_reg (trim_reg a);

fand_rrn ::
  forall a.
    (Ceq a, Ccompare a,
      Eq a) => Fset (a, Nat) -> Nat -> [Reg Nat [Maybe a]] -> Reg Nat [Maybe a];
fand_rrn f n [] = true_RRn f n;
fand_rrn f n (a : tas) =
  fold (\ aa b -> simplify_reg (reg_intersect aa b)) tas a;

union_list_sorted :: forall a. (Eq a, Ord a) => [a] -> [a] -> [a];
union_list_sorted (x : xs) (y : ys) =
  (if x == y then x : union_list_sorted xs ys
    else (if less x y then x : union_list_sorted xs (y : ys)
           else y : union_list_sorted (x : xs) ys));
union_list_sorted [] ys = ys;
union_list_sorted (v : va) [] = v : va;

fit_rrns ::
  forall a.
    (Ceq a,
      Ccompare a) => Fset (a, Nat) ->
                       [(Formula Ftrs, ([Nat], Reg Nat [Maybe a]))] ->
                         ([Nat], [Reg Nat [Maybe a]]);
fit_rrns f rrns =
  let {
    vs = fold (union_list_sorted . fst . snd) rrns [];
  } in (vs, map (\ (_, (vsa, ta)) ->
                  relabel_reg (trim_reg (fit_rrn f vsa vs ta)))
              rrns);

frelcomp ::
  forall a c b.
    (Ceq a, Ccompare a, Set_impl a, Ceq c, Ccompare c, Ceq b, Ccompare b,
      Set_impl b) => Fset (a, c) -> Fset (c, b) -> Fset (a, b);
frelcomp xb xc = Abs_fset (relcomp (fset xb) (fset xc));

guard :: Bool -> Maybe ();
guard b = (if b then Just () else Nothing);

list_all2 :: forall a b. (a -> b -> Bool) -> [a] -> [b] -> Bool;
list_all2 p (x : xs) (y : ys) = p x y && list_all2 p xs ys;
list_all2 p xs [] = null xs;
list_all2 p [] ys = null ys;

r2Eq :: forall a. Rr2_rel a;
r2Eq = R2Diag R1Terms;

is_to_fin_trs ::
  forall a b.
    (Compare a, Eq a, Compare b,
      Eq b) => [Fset (Term a b, Term a b)] ->
                 [Ftrs] -> Fset (Term a b, Term a b);
is_to_fin_trs rs is =
  ffUnion
    (fset_of_list (map (\ a -> (case a of {
                                 Fwd aa -> nth rs aa;
                                 Bwd aa -> (fimage swap . nth rs) aa;
                               }))
                    is));

is_to_trs ::
  forall a b.
    (Compare a, Eq a, Compare b,
      Eq b) => [Fset (Term a b, Term a b)] ->
                 [Ftrs] -> Maybe (Fset (Term a b, Term a b));
is_to_trs rs is =
  bind (guard (all (\ i -> less_nat (case i of {
                                      Fwd a -> id a;
                                      Bwd a -> id a;
                                    })
                             (size_list rs))
                is))
    (\ _ -> Just (is_to_fin_trs rs is));

upd_bruijn :: [Nat] -> [Nat];
upd_bruijn vs = tl (map (\ x -> minus_nat x one_nat) vs);

gTT_comp ::
  forall a b.
    (Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b,
      Eq b) => (Ta a b, Ta a b) -> (Ta a b, Ta a b) -> (Ta a b, Ta a b);
gTT_comp g_1 g_2 =
  (TA (sup_fset (rules (fst (fst g_1, fst g_2)))
        (rules (snd (fst g_1, fst g_2))))
     (sup_fset (sup_fset (eps (fst g_1)) (eps (fst g_2)))
       (delta_epsilon (snd g_1) (fst g_2))),
    TA (sup_fset (rules (fst (snd g_1, snd g_2)))
         (rules (snd (snd g_1, snd g_2))))
      (sup_fset (sup_fset (eps (snd g_1)) (eps (snd g_2)))
        (delta_epsilon (fst g_2) (snd g_1))));

inf_automata ::
  forall a b.
    (Ceq a, Ccompare a, Compare a, Eq a, Set_impl a, Ceq b, Ccompare b, Eq b,
      Linorder b) => Ta a (Maybe b, Maybe b) ->
                       Fset a -> Ta (Sum a a) (Maybe b, Maybe b);
inf_automata a q =
  TA (sup_fset
       (sup_fset
         (ffUnion
           (fimage
             (\ r ->
               (if fmember (r_rhs r) q && is_none (fst (r_root r))
                 then finsert
                        (TA_rule (r_root r) (map Inl (r_lhs_states r))
                          (Inr (r_rhs r)))
                        bot_fset
                 else bot_fset))
             (rules a)))
         (ffUnion
           (fimage
             (fset_of_list .
               (\ r ->
                 (case (r_root r, (r_lhs_states r, r_rhs r)) of {
                   (f, (qs, qa)) ->
                     map (\ i ->
                           TA_rule f
                             (map Inl (take i qs) ++
                               Inr (nth qs i) : map Inl (drop (suc i) qs))
                             (Inr qa))
                       (upt zero_nat (size_list qs));
                 })))
             (rules a))))
       (fimage (map_ta_rule Inl id) (rules a)))
    (sup_fset (fimage (map_prod Inl Inl) (eps a))
      (fimage (map_prod Inr Inr) (eps a)));

inf_reg ::
  forall a b.
    (Ceq a, Ccompare a, Compare a, Eq a, Set_impl a, Ceq b, Ccompare b, Eq b,
      Linorder b) => Reg a (Maybe b, Maybe b) ->
                       Fset a -> Reg (Sum a a) (Maybe b, Maybe b);
inf_reg a q = Reg (fimage Inr (fin a)) (inf_automata (ta a) q);

ta_sig ::
  forall a b.
    (Ceq a, Ccompare a, Ceq b, Ccompare b,
      Set_impl b) => Ta a b -> Fset (b, Nat);
ta_sig a = fimage (\ r -> (r_root r, size_list (r_lhs_states r))) (rules a);

or_list_aci ::
  forall a b.
    (Eq a, Eq b) => Form_list_aci a b -> Form_list_aci a b -> Form_list_aci a b;
or_list_aci TT_aci uu = TT_aci;
or_list_aci FF_aci TT_aci = TT_aci;
or_list_aci (Pred_aci v va vb) TT_aci = TT_aci;
or_list_aci (And_aci v) TT_aci = TT_aci;
or_list_aci (Or_aci v) TT_aci = TT_aci;
or_list_aci (Forall_aci v) TT_aci = TT_aci;
or_list_aci (Exists_aci v) TT_aci = TT_aci;
or_list_aci FF_aci FF_aci = FF_aci;
or_list_aci FF_aci (Pred_aci v va vb) = Pred_aci v va vb;
or_list_aci FF_aci (And_aci v) = And_aci v;
or_list_aci FF_aci (Or_aci v) = Or_aci v;
or_list_aci FF_aci (Forall_aci v) = Forall_aci v;
or_list_aci FF_aci (Exists_aci v) = Exists_aci v;
or_list_aci (Pred_aci v va vb) FF_aci = Pred_aci v va vb;
or_list_aci (And_aci v) FF_aci = And_aci v;
or_list_aci (Or_aci v) FF_aci = Or_aci v;
or_list_aci (Forall_aci v) FF_aci = Forall_aci v;
or_list_aci (Exists_aci v) FF_aci = Exists_aci v;
or_list_aci (Or_aci ps) (Or_aci qs) = Or_aci (remdups (ps ++ qs));
or_list_aci (Or_aci ps) (Pred_aci v va vb) =
  Or_aci (inserta (Pred_aci v va vb) ps);
or_list_aci (Or_aci ps) (And_aci v) = Or_aci (inserta (And_aci v) ps);
or_list_aci (Or_aci ps) (Forall_aci v) = Or_aci (inserta (Forall_aci v) ps);
or_list_aci (Or_aci ps) (Exists_aci v) = Or_aci (inserta (Exists_aci v) ps);
or_list_aci (Pred_aci v va vb) (Or_aci qs) =
  Or_aci (inserta (Pred_aci v va vb) qs);
or_list_aci (And_aci v) (Or_aci qs) = Or_aci (inserta (And_aci v) qs);
or_list_aci (Forall_aci v) (Or_aci qs) = Or_aci (inserta (Forall_aci v) qs);
or_list_aci (Exists_aci v) (Or_aci qs) = Or_aci (inserta (Exists_aci v) qs);
or_list_aci (Pred_aci v va vb) (Pred_aci vc vd ve) =
  (if equal_form_list_aci (Pred_aci v va vb) (Pred_aci vc vd ve)
    then Pred_aci v va vb else Or_aci [Pred_aci v va vb, Pred_aci vc vd ve]);
or_list_aci (Pred_aci v va vb) (And_aci vc) =
  (if equal_form_list_aci (Pred_aci v va vb) (And_aci vc) then Pred_aci v va vb
    else Or_aci [Pred_aci v va vb, And_aci vc]);
or_list_aci (Pred_aci v va vb) (Forall_aci vc) =
  (if equal_form_list_aci (Pred_aci v va vb) (Forall_aci vc)
    then Pred_aci v va vb else Or_aci [Pred_aci v va vb, Forall_aci vc]);
or_list_aci (Pred_aci v va vb) (Exists_aci vc) =
  (if equal_form_list_aci (Pred_aci v va vb) (Exists_aci vc)
    then Pred_aci v va vb else Or_aci [Pred_aci v va vb, Exists_aci vc]);
or_list_aci (And_aci v) (Pred_aci va vb vc) =
  (if equal_form_list_aci (And_aci v) (Pred_aci va vb vc) then And_aci v
    else Or_aci [And_aci v, Pred_aci va vb vc]);
or_list_aci (And_aci v) (And_aci va) =
  (if equal_form_list_aci (And_aci v) (And_aci va) then And_aci v
    else Or_aci [And_aci v, And_aci va]);
or_list_aci (And_aci v) (Forall_aci va) =
  (if equal_form_list_aci (And_aci v) (Forall_aci va) then And_aci v
    else Or_aci [And_aci v, Forall_aci va]);
or_list_aci (And_aci v) (Exists_aci va) =
  (if equal_form_list_aci (And_aci v) (Exists_aci va) then And_aci v
    else Or_aci [And_aci v, Exists_aci va]);
or_list_aci (Forall_aci v) (Pred_aci va vb vc) =
  (if equal_form_list_aci (Forall_aci v) (Pred_aci va vb vc) then Forall_aci v
    else Or_aci [Forall_aci v, Pred_aci va vb vc]);
or_list_aci (Forall_aci v) (And_aci va) =
  (if equal_form_list_aci (Forall_aci v) (And_aci va) then Forall_aci v
    else Or_aci [Forall_aci v, And_aci va]);
or_list_aci (Forall_aci v) (Forall_aci va) =
  (if equal_form_list_aci (Forall_aci v) (Forall_aci va) then Forall_aci v
    else Or_aci [Forall_aci v, Forall_aci va]);
or_list_aci (Forall_aci v) (Exists_aci va) =
  (if equal_form_list_aci (Forall_aci v) (Exists_aci va) then Forall_aci v
    else Or_aci [Forall_aci v, Exists_aci va]);
or_list_aci (Exists_aci v) (Pred_aci va vb vc) =
  (if equal_form_list_aci (Exists_aci v) (Pred_aci va vb vc) then Exists_aci v
    else Or_aci [Exists_aci v, Pred_aci va vb vc]);
or_list_aci (Exists_aci v) (And_aci va) =
  (if equal_form_list_aci (Exists_aci v) (And_aci va) then Exists_aci v
    else Or_aci [Exists_aci v, And_aci va]);
or_list_aci (Exists_aci v) (Forall_aci va) =
  (if equal_form_list_aci (Exists_aci v) (Forall_aci va) then Exists_aci v
    else Or_aci [Exists_aci v, Forall_aci va]);
or_list_aci (Exists_aci v) (Exists_aci va) =
  (if equal_form_list_aci (Exists_aci v) (Exists_aci va) then Exists_aci v
    else Or_aci [Exists_aci v, Exists_aci va]);

fTrue :: forall a. Formula a;
fTrue = FAnd [];

r1Fin :: forall a. Rr2_rel a -> Rr1_rel a;
r1Fin r = R1Diff R1Terms (R1Inf r);

rel_f ::
  forall a b.
    (Compare a, Eq a, Compare b,
      Eq b) => Fset (Term a b, Term a b) -> Fset (Bot_term a, Bot_term a);
rel_f r = fimage (map_prod term_to_bot_term term_to_bot_term) r;

all_interval_nat :: (Nat -> Bool) -> Nat -> Nat -> Bool;
all_interval_nat p i j = less_eq_nat j i || p i && all_interval_nat p (suc i) j;

and_list_aci ::
  forall a b.
    (Eq a, Eq b) => Form_list_aci a b -> Form_list_aci a b -> Form_list_aci a b;
and_list_aci FF_aci uu = FF_aci;
and_list_aci TT_aci FF_aci = FF_aci;
and_list_aci (Pred_aci v va vb) FF_aci = FF_aci;
and_list_aci (And_aci v) FF_aci = FF_aci;
and_list_aci (Or_aci v) FF_aci = FF_aci;
and_list_aci (Forall_aci v) FF_aci = FF_aci;
and_list_aci (Exists_aci v) FF_aci = FF_aci;
and_list_aci TT_aci TT_aci = TT_aci;
and_list_aci TT_aci (Pred_aci v va vb) = Pred_aci v va vb;
and_list_aci TT_aci (And_aci v) = And_aci v;
and_list_aci TT_aci (Or_aci v) = Or_aci v;
and_list_aci TT_aci (Forall_aci v) = Forall_aci v;
and_list_aci TT_aci (Exists_aci v) = Exists_aci v;
and_list_aci (Pred_aci v va vb) TT_aci = Pred_aci v va vb;
and_list_aci (And_aci v) TT_aci = And_aci v;
and_list_aci (Or_aci v) TT_aci = Or_aci v;
and_list_aci (Forall_aci v) TT_aci = Forall_aci v;
and_list_aci (Exists_aci v) TT_aci = Exists_aci v;
and_list_aci (And_aci ps) (And_aci qs) = And_aci (remdups (ps ++ qs));
and_list_aci (And_aci ps) (Pred_aci v va vb) =
  And_aci (inserta (Pred_aci v va vb) ps);
and_list_aci (And_aci ps) (Or_aci v) = And_aci (inserta (Or_aci v) ps);
and_list_aci (And_aci ps) (Forall_aci v) = And_aci (inserta (Forall_aci v) ps);
and_list_aci (And_aci ps) (Exists_aci v) = And_aci (inserta (Exists_aci v) ps);
and_list_aci (Pred_aci v va vb) (And_aci qs) =
  And_aci (inserta (Pred_aci v va vb) qs);
and_list_aci (Or_aci v) (And_aci qs) = And_aci (inserta (Or_aci v) qs);
and_list_aci (Forall_aci v) (And_aci qs) = And_aci (inserta (Forall_aci v) qs);
and_list_aci (Exists_aci v) (And_aci qs) = And_aci (inserta (Exists_aci v) qs);
and_list_aci (Pred_aci v va vb) (Pred_aci vc vd ve) =
  (if equal_form_list_aci (Pred_aci v va vb) (Pred_aci vc vd ve)
    then Pred_aci v va vb else And_aci [Pred_aci v va vb, Pred_aci vc vd ve]);
and_list_aci (Pred_aci v va vb) (Or_aci vc) =
  (if equal_form_list_aci (Pred_aci v va vb) (Or_aci vc) then Pred_aci v va vb
    else And_aci [Pred_aci v va vb, Or_aci vc]);
and_list_aci (Pred_aci v va vb) (Forall_aci vc) =
  (if equal_form_list_aci (Pred_aci v va vb) (Forall_aci vc)
    then Pred_aci v va vb else And_aci [Pred_aci v va vb, Forall_aci vc]);
and_list_aci (Pred_aci v va vb) (Exists_aci vc) =
  (if equal_form_list_aci (Pred_aci v va vb) (Exists_aci vc)
    then Pred_aci v va vb else And_aci [Pred_aci v va vb, Exists_aci vc]);
and_list_aci (Or_aci v) (Pred_aci va vb vc) =
  (if equal_form_list_aci (Or_aci v) (Pred_aci va vb vc) then Or_aci v
    else And_aci [Or_aci v, Pred_aci va vb vc]);
and_list_aci (Or_aci v) (Or_aci va) =
  (if equal_form_list_aci (Or_aci v) (Or_aci va) then Or_aci v
    else And_aci [Or_aci v, Or_aci va]);
and_list_aci (Or_aci v) (Forall_aci va) =
  (if equal_form_list_aci (Or_aci v) (Forall_aci va) then Or_aci v
    else And_aci [Or_aci v, Forall_aci va]);
and_list_aci (Or_aci v) (Exists_aci va) =
  (if equal_form_list_aci (Or_aci v) (Exists_aci va) then Or_aci v
    else And_aci [Or_aci v, Exists_aci va]);
and_list_aci (Forall_aci v) (Pred_aci va vb vc) =
  (if equal_form_list_aci (Forall_aci v) (Pred_aci va vb vc) then Forall_aci v
    else And_aci [Forall_aci v, Pred_aci va vb vc]);
and_list_aci (Forall_aci v) (Or_aci va) =
  (if equal_form_list_aci (Forall_aci v) (Or_aci va) then Forall_aci v
    else And_aci [Forall_aci v, Or_aci va]);
and_list_aci (Forall_aci v) (Forall_aci va) =
  (if equal_form_list_aci (Forall_aci v) (Forall_aci va) then Forall_aci v
    else And_aci [Forall_aci v, Forall_aci va]);
and_list_aci (Forall_aci v) (Exists_aci va) =
  (if equal_form_list_aci (Forall_aci v) (Exists_aci va) then Forall_aci v
    else And_aci [Forall_aci v, Exists_aci va]);
and_list_aci (Exists_aci v) (Pred_aci va vb vc) =
  (if equal_form_list_aci (Exists_aci v) (Pred_aci va vb vc) then Exists_aci v
    else And_aci [Exists_aci v, Pred_aci va vb vc]);
and_list_aci (Exists_aci v) (Or_aci va) =
  (if equal_form_list_aci (Exists_aci v) (Or_aci va) then Exists_aci v
    else And_aci [Exists_aci v, Or_aci va]);
and_list_aci (Exists_aci v) (Forall_aci va) =
  (if equal_form_list_aci (Exists_aci v) (Forall_aci va) then Exists_aci v
    else And_aci [Exists_aci v, Forall_aci va]);
and_list_aci (Exists_aci v) (Exists_aci va) =
  (if equal_form_list_aci (Exists_aci v) (Exists_aci va) then Exists_aci v
    else And_aci [Exists_aci v, Exists_aci va]);

fFalse :: forall a. Formula a;
fFalse = FOr [];

gSteps :: forall a. [a] -> Gtt_rel a;
gSteps trss = GTrancl (ARoot trss);

r2Join :: forall a. [a] -> Rr2_rel a;
r2Join trss =
  R2GTT_Rel (GComp (gSteps trss) (GInv (gSteps trss))) PAny EParallel;

r2Meet :: forall a. [a] -> Rr2_rel a;
r2Meet trss =
  R2GTT_Rel (GComp (GInv (gSteps trss)) (gSteps trss)) PAny EParallel;

r2Step :: forall a. [a] -> Rr2_rel a;
r2Step trss = R2GTT_Rel (ARoot trss) PAny ESingle;

collapse_state_list ::
  forall a. (Ceq a, Ccompare a) => Fset a -> Fset a -> [a] -> [[Maybe a]];
collapse_state_list qn qs [] = [[]];
collapse_state_list qn qsa (q : qs) =
  let {
    rec = collapse_state_list qn qsa qs;
  } in (if fmember q qn && fmember q qsa
         then map (\ a -> Nothing : a) rec ++ map (\ a -> Just q : a) rec
         else (if fmember q qn then map (\ a -> Nothing : a) rec
                else (if fmember q qsa then map (\ a -> Just q : a) rec
                       else [[]])));

collapse_rule ::
  forall a b.
    (Ceq a, Ccompare a, Eq a, Linorder a, Ceq b, Ccompare b, Eq b,
      Linorder b) => Ta a (Maybe b) ->
                       Fset a -> Fset a -> Fset (Ta_rule (Maybe a) (Maybe b));
collapse_rule a qn qs =
  ffUnion
    (fimage
      (\ r ->
        fset_of_list
          (map (\ qsa -> TA_rule (r_root r) qsa (Just (r_rhs r)))
            (collapse_state_list qn qs (r_lhs_states r))))
      (ffilter
        (\ r ->
          all_interval_nat
            (\ i ->
              fmember (nth (r_lhs_states r) i) qn ||
                fmember (nth (r_lhs_states r) i) qs)
            zero_nat (size_list (r_lhs_states r)))
        (ffilter (\ r -> not (is_none (r_root r))) (rules a))));

collapse_rule_fset ::
  forall a b.
    (Ceq a, Ccompare a, Eq a, Linorder a, Ceq b, Ccompare b, Eq b,
      Linorder b) => Ta a (Maybe b) -> Fset a -> Fset a -> Fset (Ta_rule a b);
collapse_rule_fset a qn qs =
  fimage
    (\ r ->
      TA_rule (the (r_root r))
        (map_filter (\ x -> (if not (is_none x) then Just (the x) else Nothing))
          (r_lhs_states r))
        (the (r_rhs r)))
    (collapse_rule a qn qs);

collapse_automaton ::
  forall a b.
    (Card_UNIV a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b, Eq b, Linorder b) => Ta a (Maybe b) -> Ta a b;
collapse_automaton a = TA (collapse_rule_fset a (qn a) (qs a)) (eps a);

collapse_automaton_reg ::
  forall a b.
    (Card_UNIV a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b, Eq b, Linorder b) => Reg a (Maybe b) -> Reg a b;
collapse_automaton_reg r = Reg (fin r) (collapse_automaton (ta r));

rrn_drop_fst ::
  forall a b.
    (Card_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b, Eq b,
      Linorder b) => Reg a [Maybe b] -> Reg Nat [Maybe b];
rrn_drop_fst a =
  relabel_reg
    (trim_reg
      (collapse_automaton_reg
        (fmap_funs_reg
          (\ fs ->
            (if all is_none (drop one_nat fs) then Nothing
              else Just (drop one_nat fs)))
          (trim_reg a))));

pair_at_to_agtt ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b,
      Ccompare b) => (Ta a b, Ta a b) -> Fset (a, a) -> (Ta a b, Ta a b);
pair_at_to_agtt g qa =
  (TA (rules (fst g))
     (sup_fset (eps (fst g)) (frelcomp (fId_on (q (fst g))) qa)),
    TA (rules (snd g)) (eps (snd g)));

pair_at_to_agtta ::
  forall a b c.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Compare a, Eq a,
      Linorder a, Set_impl a, Ceq b, Ccompare b, Finite_UNIV c, Cenum c, Ceq c,
      Cproper_interval c, Compare c, Eq c, Linorder c,
      Set_impl c) => (Ta a b, Ta c b) ->
                       Fset (a, c) -> (Ta (Sum a c) b, Ta (Sum a c) b);
pair_at_to_agtta g qa =
  let {
    a = fmap_states_ta Inl (fst g);
    b = fmap_states_ta Inr (snd g);
    qb = inf_fset qa (fSigma (q (fst g)) (\ _ -> q (snd g)));
  } in pair_at_to_agtt (a, b) (fimage (map_prod Inl Inr) qb);

minus_set :: forall a. (Ceq a, Ccompare a) => Set a -> Set a -> Set a;
minus_set a b = inf_set a (uminus_set b);

minus_fset :: forall a. (Ceq a, Ccompare a) => Fset a -> Fset a -> Fset a;
minus_fset xb xc = Abs_fset (minus_set (fset xb) (fset xc));

term_to_ta_rule :: forall a. Bot_term a -> Ta_rule (Bot_term a) a;
term_to_ta_rule (BFun f ts) = TA_rule f ts (BFun f ts);

pattern_automaton_rules ::
  forall a b.
    (Ceq a, Ccompare a, Compare a, Eq a, Compare b,
      Eq b) => Fset (a, Nat) ->
                 Fset (Term a b) -> Fset (Ta_rule (Bot_term a) a);
pattern_automaton_rules f r =
  let {
    states = minus_fset (fstatesa r) (finsert Bot bot_fset);
  } in sup_fset (fimage term_to_ta_rule states)
         (fimage (\ (fa, n) -> TA_rule fa (replicate n Bot) Bot) f);

pattern_automaton ::
  forall a b.
    (Ceq a, Ccompare a, Compare a, Eq a, Compare b,
      Eq b) => Fset (a, Nat) -> Fset (Term a b) -> Ta (Bot_term a) a;
pattern_automaton f r = TA (pattern_automaton_rules f r) bot_fset;

root_pair_automaton ::
  forall a b c.
    (Ceq a, Ccompare a, Compare a, Eq a, Compare b, Eq b, Compare c,
      Eq c) => Fset (a, Nat) ->
                 Fset (Term a b, Term a c) ->
                   (Ta (Bot_term a) a, Ta (Bot_term a) a);
root_pair_automaton f r =
  (pattern_automaton f (fimage fst r), pattern_automaton f (fimage snd r));

agtt_grrstep ::
  forall a b.
    (Ceq a, Ccompare a, Compare a, Eq a, Compare b,
      Eq b) => Fset (Term a b, Term a b) ->
                 Fset (a, Nat) ->
                   (Ta (Sum (Bot_term a) (Bot_term a)) a,
                     Ta (Sum (Bot_term a) (Bot_term a)) a);
agtt_grrstep r f = pair_at_to_agtta (root_pair_automaton f r) (rel_f r);

eps_free_automata ::
  forall a b.
    (Card_UNIV a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b, Eq b, Linorder b) => Ta a b -> Ta a b;
eps_free_automata a =
  let {
    epscl = ftrancl (eps a);
    ruleps =
      (\ r -> finsert (r_rhs r) (fImage epscl (finsert (r_rhs r) bot_fset)));
    rulesa =
      fimage (\ r -> fimage (TA_rule (r_root r) (r_lhs_states r)) (ruleps r))
        (rules a);
  } in TA (ffUnion rulesa) bot_fset;

eps_free ::
  forall a b.
    (Card_UNIV a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b, Eq b, Linorder b) => Ta a b -> Ta a b;
eps_free a = eps_free_automata a;

ta_empty ::
  forall a b.
    (Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b) => Fset a -> Ta a b -> Bool;
ta_empty q a = less_eq_fset (inf_fset (ta_reachable a) q) bot_fset;

r2Reflc :: forall a. Rr2_rel a -> Rr2_rel a;
r2Reflc r = R2Union r r2Eq;

r2Steps :: forall a. [a] -> Rr2_rel a;
r2Steps trss = R2GTT_Rel (gSteps trss) PAny EStrictParallel;

fset_concat_n ::
  forall a. (Ceq a, Ccompare a, Eq a, Linorder a) => Fset a -> Nat -> Fset [a];
fset_concat_n s n =
  (if equal_nat n zero_nat then finsert [] bot_fset
    else ffUnion
           (fimage (\ r -> fimage (\ e -> e : r) s)
             (fset_concat_n s (minus_nat n one_nat))));

gTT_to_RR2_root ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b,
      Ccompare b) => (Ta a b, Ta a b) ->
                       Ta (Maybe a, Maybe a) (Maybe b, Maybe b);
gTT_to_RR2_root g = pair_automaton (fst g) (snd g);

proj_1_reg ::
  forall a b c.
    (Card_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b, Eq b, Linorder b, Ceq c,
      Ccompare c) => Reg a (Maybe b, c) -> Reg a b;
proj_1_reg a = collapse_automaton_reg (fmap_funs_reg fst (trim_reg a));

proj_2_reg ::
  forall a b c.
    (Card_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b, Ceq c, Ccompare c, Eq c,
      Linorder c) => Reg a (b, Maybe c) -> Reg a c;
proj_2_reg a = collapse_automaton_reg (fmap_funs_reg snd (trim_reg a));

reg_empty ::
  forall a b.
    (Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b) => Reg a b -> Bool;
reg_empty r = ta_empty (fin r) (ta r);

r2StepEq :: forall a. [a] -> Rr2_rel a;
r2StepEq trss = r2Reflc (r2Step trss);

map_ftrs :: (Nat -> Nat) -> Ftrs -> Ftrs;
map_ftrs f = (\ a -> (case a of {
                       Fwd aa -> (Fwd . f) aa;
                       Bwd aa -> (Bwd . f) aa;
                     }));

delta_trancl_infer1 ::
  forall a b.
    (Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b,
      Eq b) => Fset (Ta_rule a b) ->
                 Fset (a, a) ->
                   Fset (Ta_rule a b) ->
                     Fset (a, a) -> (a, a) -> Fset (a, a) -> [(a, a)];
delta_trancl_infer1 delta_A delta_A_epsilon delta_B delta_B_epsilon pq bs =
  delta_epsilon_infer1_cont delta_A delta_A_epsilon delta_B delta_B_epsilon pq
    bs ++
    sorted_list_of_fset
      (sup_fset
        (fimage (\ (r, _) -> (r, snd pq))
          (ffilter (\ (_, p) -> p == fst pq) bs))
        (fimage (\ (_, a) -> (fst pq, a))
          (ffilter (\ (q, _) -> q == snd pq) (finsert pq bs))));

delta_trancl_infer0 ::
  forall a b c.
    (Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b, Ccompare b, Eq b,
      Ceq c, Ccompare c, Eq c, Linorder c,
      Set_impl c) => Fset (Ta_rule a b) -> Fset (Ta_rule c b) -> [(a, c)];
delta_trancl_infer0 delta_A delta_B = delta_epsilon_infer0_cont delta_A delta_B;

delta_trancl_impl ::
  forall a b.
    (Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b,
      Eq b) => Fset (Ta_rule a b) ->
                 Fset (a, a) ->
                   Fset (Ta_rule a b) -> Fset (a, a) -> Maybe (Fset (a, a));
delta_trancl_impl delta_A delta_A_epsilon delta_B delta_B_epsilon =
  saturate_impl (delta_trancl_infer0 delta_A delta_B)
    (delta_trancl_infer1 delta_A delta_A_epsilon delta_B delta_B_epsilon);

delta_trancl ::
  forall a b.
    (Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b, Eq b) => Ta a b -> Ta a b -> Fset (a, a);
delta_trancl (TA delta_A delta_A_epsilon) (TA delta_B delta_B_epsilon) =
  the (delta_trancl_impl delta_A delta_A_epsilon delta_B delta_B_epsilon);

gTT_trancl ::
  forall a b.
    (Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b, Eq b) => (Ta a b, Ta a b) -> (Ta a b, Ta a b);
gTT_trancl g =
  (TA (rules (fst g)) (sup_fset (eps (fst g)) (delta_trancl (snd g) (fst g))),
    TA (rules (snd g)) (sup_fset (eps (snd g)) (delta_trancl (fst g) (snd g))));

gtt_of_gtt_rel ::
  forall a b.
    (Ceq a, Ccompare a, Compare a, Eq a, Compare b,
      Eq b) => Fset (a, Nat) ->
                 [Fset (Term a b, Term a b)] ->
                   Gtt_rel Ftrs -> Maybe (Ta Nat a, Ta Nat a);
gtt_of_gtt_rel f rs (ARoot is) =
  liftO1 (\ r -> relabel_gtt (agtt_grrstep r f)) (is_to_trs rs is);
gtt_of_gtt_rel f rs (GInv g) = liftO1 swap (gtt_of_gtt_rel f rs g);
gtt_of_gtt_rel f rs (AUnion g1 g2) =
  liftO2
    (\ g1a g2a ->
      relabel_gtt
        (aGTT_union (fmap_states_gtt Inl g1a) (fmap_states_gtt Inr g2a)))
    (gtt_of_gtt_rel f rs g1) (gtt_of_gtt_rel f rs g2);
gtt_of_gtt_rel f rs (ATrancl g) =
  liftO1 (relabel_gtt . aGTT_trancl) (gtt_of_gtt_rel f rs g);
gtt_of_gtt_rel f rs (GTrancl g) = liftO1 gTT_trancl (gtt_of_gtt_rel f rs g);
gtt_of_gtt_rel f rs (AComp g1 g2) =
  liftO2
    (\ g1a g2a ->
      relabel_gtt
        (aGTT_comp (fmap_states_gtt Inl g1a) (fmap_states_gtt Inr g2a)))
    (gtt_of_gtt_rel f rs g1) (gtt_of_gtt_rel f rs g2);
gtt_of_gtt_rel f rs (GComp g1 g2) =
  liftO2
    (\ g1a g2a ->
      relabel_gtt
        (gTT_comp (fmap_states_gtt Inl g1a) (fmap_states_gtt Inr g2a)))
    (gtt_of_gtt_rel f rs g1) (gtt_of_gtt_rel f rs g2);

sig_ta :: forall a. (Ceq a, Ccompare a) => Fset (a, Nat) -> Ta () a;
sig_ta f = TA (fimage (\ (fa, n) -> TA_rule fa (replicate n ()) ()) f) bot_fset;

sig_ta_reg :: forall a. (Ceq a, Ccompare a) => Fset (a, Nat) -> Reg () a;
sig_ta_reg f = Reg bot_fset (sig_ta f);

ps_reachable_states_cont ::
  forall a b.
    (Card_UNIV a, Ceq a, Ccompare a, Set_impl a, Ceq b, Ccompare b,
      Eq b) => Fset (Ta_rule a b) -> Fset (a, a) -> b -> [Fset a] -> Fset a;
ps_reachable_states_cont delta delta_epsilon f ps =
  let {
    r = ffilter (\ (TA_rule g qs _) -> f == g && list_all2 fmember qs ps) delta;
    s = fimage r_rhs r;
  } in sup_fset s (fImage (ftrancl delta_epsilon) s);

ps_reachable_states ::
  forall a b.
    (Card_UNIV a, Ceq a, Ccompare a, Set_impl a, Ceq b, Ccompare b,
      Eq b) => Ta a b -> b -> [Fset a] -> Fset a;
ps_reachable_states (TA delta delta_epsilon) f ps =
  ps_reachable_states_cont delta delta_epsilon f ps;

add_elem_list_fset :: forall a. (Ceq a, Ccompare a) => a -> [a] -> Fset [a];
add_elem_list_fset x [] = finsert [x] bot_fset;
add_elem_list_fset x (y : ys) =
  finsert (x : y : ys) (fimage (\ a -> y : a) (add_elem_list_fset x ys));

fset_concat_elem_n ::
  forall a.
    (Ceq a, Ccompare a, Eq a, Linorder a) => a -> Fset a -> Nat -> Fset [a];
fset_concat_elem_n x s n =
  (if equal_nat n zero_nat then error "undefined"
    else ffUnion
           (fimage (add_elem_list_fset x)
             (fset_concat_n s (minus_nat n one_nat))));

ps_states_infer1_cont ::
  forall a b.
    (Card_UNIV a, Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a,
      Ceq b, Ccompare b, Eq b, Linorder b,
      Set_impl b) => Fset (Ta_rule a b) ->
                       Fset (a, a) ->
                         FSet_Lex_Wrapper a ->
                           Fset (FSet_Lex_Wrapper a) -> [FSet_Lex_Wrapper a];
ps_states_infer1_cont delta delta_epsilon p bs =
  let {
    ntR = ffilter (\ r -> not (null (r_lhs_states r))) delta;
    qss = fimage
            (\ r ->
              (case (r_root r, size_list (r_lhs_states r)) of {
                (f, n) ->
                  (f, (n, Wrapp (fset_concat_elem_n p (finsert p bs) n)));
              }))
            ntR;
    res = map (\ (f, (_, qssa)) ->
                map (\ qs ->
                      Wrapp (ps_reachable_states (TA delta delta_epsilon) f
                              (map exa qs)))
                  (sorted_list_of_fset (exa qssa)))
            (sorted_list_of_fset qss);
  } in filter (\ pa -> not (exa pa == bot_fset)) (concat res);

ps_states_infer0_cont ::
  forall a b.
    (Card_UNIV a, Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a,
      Ceq b, Ccompare b, Eq b,
      Linorder b) => Fset (Ta_rule a b) -> Fset (a, a) -> [FSet_Lex_Wrapper a];
ps_states_infer0_cont delta delta_epsilon =
  sorted_list_of_fset
    (let {
       sig = ffilter (\ r -> null (r_lhs_states r)) delta;
     } in ffilter (\ p -> not (exa p == bot_fset))
            (fimage
              (\ r ->
                Wrapp (ps_reachable_states (TA delta delta_epsilon) (r_root r)
                        []))
              sig));

ps_states_fset_impl ::
  forall a b.
    (Card_UNIV a, Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a,
      Ceq b, Ccompare b, Eq b, Linorder b,
      Set_impl b) => Fset (Ta_rule a b) ->
                       Fset (a, a) -> Maybe (Fset (FSet_Lex_Wrapper a));
ps_states_fset_impl delta delta_epsilon =
  saturate_impl (ps_states_infer0_cont delta delta_epsilon)
    (ps_states_infer1_cont delta delta_epsilon);

ps_rules_cont ::
  forall a b.
    (Card_UNIV a, Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a,
      Ceq b, Ccompare b, Eq b, Linorder b,
      Set_impl b) => Ta a b ->
                       Fset (FSet_Lex_Wrapper a) ->
                         Fset (Ta_rule (FSet_Lex_Wrapper a) b);
ps_rules_cont a q =
  let {
    sig = ta_sig a;
    qss = fimage (\ (f, n) -> (f, (n, fset_concat_n q n))) sig;
    res = fimage
            (\ (f, b) ->
              (case b of {
                (_, ba) ->
                  fimage
                    (\ qs ->
                      TA_rule f qs
                        (Wrapp (ps_reachable_states a f (map exa qs))))
                    ba;
              }))
            qss;
  } in ffilter (\ r -> not (exa (r_rhs r) == bot_fset)) (ffUnion res);

ps_rules ::
  forall a b.
    (Card_UNIV a, Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a,
      Ceq b, Ccompare b, Eq b, Linorder b,
      Set_impl b) => Ta a b ->
                       Fset (FSet_Lex_Wrapper a) ->
                         Fset (Ta_rule (FSet_Lex_Wrapper a) b);
ps_rules a q = ps_rules_cont a q;

ps_reg ::
  forall a b.
    (Card_UNIV a, Cenum a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a,
      Ceq b, Ccompare b, Eq b, Linorder b,
      Set_impl b) => Reg a b -> Reg (FSet_Lex_Wrapper a) b;
ps_reg (Reg q (TA delta delta_epsilon)) =
  let {
    xs = the (ps_states_fset_impl delta delta_epsilon);
  } in Reg (ffilter (\ s -> not (inf_fset q (exa s) == bot_fset)) xs)
         (TA (ps_rules (TA delta delta_epsilon) xs) bot_fset);

complement_reg ::
  forall a b.
    (Card_UNIV a, Cenum a, Ceq a, Cproper_interval a, Compare a, Eq a,
      Linorder a, Set_impl a, Ceq b, Ccompare b, Eq b, Linorder b,
      Set_impl b) => Reg a b ->
                       Fset (b, Nat) -> Reg (FSet_Lex_Wrapper (Sum () a)) b;
complement_reg r f = let {
                       a = ps_reg (reg_union (sig_ta_reg f) r);
                     } in Reg (minus_fset (q (ta a)) (fin a)) (ta a);

filter_ta_sig ::
  forall a b.
    (Ceq a, Ccompare a, Ceq b, Ccompare b) => Fset (a, Nat) -> Ta b a -> Ta b a;
filter_ta_sig f a =
  TA (ffilter (\ r -> fmember (r_root r, size_list (r_lhs_states r)) f)
       (rules a))
    (eps a);

filter_ta_reg ::
  forall a b.
    (Ceq a, Ccompare a, Ceq b,
      Ccompare b) => Fset (a, Nat) -> Reg b a -> Reg b a;
filter_ta_reg f r = Reg (fin r) (filter_ta_sig f (ta r));

difference_reg ::
  forall a b c.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b, Eq b, Linorder b, Set_impl b, Card_UNIV c,
      Cenum c, Ceq c, Cproper_interval c, Compare c, Eq c, Linorder c,
      Set_impl c) => Reg a b ->
                       Reg c b -> Reg (a, FSet_Lex_Wrapper (Sum () c)) b;
difference_reg r l =
  let {
    f = ta_sig (ta r);
  } in reg_intersect r (trim_reg (complement_reg (filter_ta_reg f l) f));

q_infer1_cont ::
  forall a.
    (Ceq a, Ccompare a, Eq a, Linorder a,
      Set_impl a) => Fset (a, a) -> (a, a) -> Fset (a, a) -> [(a, a)];
q_infer1_cont delta_epsilon pq bs =
  sorted_list_of_fset
    (sup_fset
      (sup_fset
        (fimage (\ (_, a) -> (fst pq, a))
          (ffilter (\ (q, _) -> q == snd pq) delta_epsilon))
        (fimage (\ (r, _) -> (r, snd pq))
          (ffilter (\ (_, p) -> p == fst pq) bs)))
      (fimage (\ (_, a) -> (fst pq, a))
        (ffilter (\ (q, _) -> q == snd pq) (finsert pq bs))));

q_infer0_cont ::
  forall a b c.
    (Ceq a, Ccompare a, Eq a, Linorder a, Ceq b, Ccompare b, Ceq c,
      Ccompare c) => Fset (Ta_rule a (Maybe b, Maybe c)) -> [(a, a)];
q_infer0_cont delta =
  concat
    (sorted_list_of_fset
      (fimage (\ (TA_rule _ ps p) -> map (\ x -> (x, p)) ps)
        (ffilter
          (\ (TA_rule f ps _) ->
            is_none (fst f) && not (is_none (snd f)) && not (null ps))
          delta)));

q_impl ::
  forall a b c.
    (Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b, Ccompare b, Ceq c,
      Ccompare c) => Fset (Ta_rule a (Maybe b, Maybe c)) ->
                       Fset (a, a) -> Maybe (Fset (a, a));
q_impl delta delta_epsilon =
  saturate_impl (q_infer0_cont delta) (q_infer1_cont delta_epsilon);

q_infinity_impl ::
  forall a b c.
    (Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b, Ccompare b, Ceq c,
      Ccompare c) => Fset (Ta_rule a (Maybe b, Maybe c)) ->
                       Fset (a, a) -> Fset a;
q_infinity_impl delta delta_epsilon =
  let {
    q = the (q_impl delta delta_epsilon);
  } in fimage snd (frelcomp (ffilter (\ (a, b) -> a == b) q) q);

fQ_inf_e ::
  forall a b c.
    (Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b, Ccompare b, Ceq c,
      Ccompare c) => Ta a (Maybe b, Maybe c) -> Fset a;
fQ_inf_e (TA delta delta_epsilon) = q_infinity_impl delta delta_epsilon;

inf_reg_impl ::
  forall a b.
    (Ceq a, Ccompare a, Compare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b, Eq b,
      Linorder b) => Reg a (Maybe b, Maybe b) ->
                       Reg (Sum a a) (Maybe b, Maybe b);
inf_reg_impl r = inf_reg r (fQ_inf_e (ta r));

semantic_path_rules ::
  forall a b.
    (Ceq a, Ccompare a, Eq a, Linorder a, Ceq b, Ccompare b, Eq b,
      Linorder b) => Fset (a, Nat) -> b -> b -> b -> Fset (Ta_rule b a);
semantic_path_rules f q_c q_i q_f =
  sup_fset
    (ffUnion
      (fimage
        (\ (fa, n) ->
          fset_of_list
            (map (\ i ->
                   TA_rule fa
                     (take i (replicate n q_c) ++
                       q_i : drop (suc i) (replicate n q_c))
                     q_f)
              (upt zero_nat n)))
        f))
    (ffUnion
      (fimage
        (\ (fa, n) ->
          fset_of_list
            (map (\ i ->
                   TA_rule fa
                     (take i (replicate n q_c) ++
                       q_f : drop (suc i) (replicate n q_c))
                     q_f)
              (upt zero_nat n)))
        f));

ta_relfcl_rules ::
  forall a b.
    (Ceq a, Ccompare a, Ceq b,
      Ccompare b) => Fset (a, Nat) -> b -> Fset (Ta_rule b a);
ta_relfcl_rules f q = fimage (\ (fa, n) -> TA_rule fa (replicate n q) q) f;

gen_nhole_mctxt_closure_reg ::
  forall a b.
    (Ceq a, Ccompare a, Eq a, Linorder a, Ceq b, Ccompare b, Eq b, Linorder b,
      Set_impl b) => Fset (a, Nat) -> Reg b a -> b -> b -> b -> Reg b a;
gen_nhole_mctxt_closure_reg f a q_c q_i q_f =
  Reg (finsert q_f bot_fset)
    (TA (sup_fset (sup_fset (rules (ta a)) (ta_relfcl_rules f q_c))
          (semantic_path_rules f q_c q_i q_f))
      (sup_fset (sup_fset (eps (ta a)) (fimage (\ p -> (p, q_i)) (fin a)))
        (finsert (q_i, q_c) bot_fset)));

fmap_states_reg ::
  forall a b c.
    (Ceq a, Ccompare a, Ceq b, Ccompare b, Set_impl b, Ceq c,
      Ccompare c) => (a -> b) -> Reg a c -> Reg b c;
fmap_states_reg f r = Reg (fimage f (fin r)) (fmap_states_ta f (ta r));

refin_fin_reg ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b, Ccompare b) => Reg a b -> Reg a b;
refin_fin_reg r = Reg (inf_fset (fin r) (q (ta r))) (ta r);

fun_sig ::
  forall a b.
    (Ceq a, Ccompare a, Ceq b, Ccompare b, Zero b,
      Ord b) => Fset (a, b) -> Bool;
fun_sig f = fBex f (\ (_, a) -> less zero a);

nhole_mctxt_closure_reg ::
  forall a b.
    (Ceq a, Ccompare a, Eq a, Linorder a, Finite_UNIV b, Cenum b, Ceq b,
      Cproper_interval b, Compare b, Eq b, Linorder b,
      Set_impl b) => Fset (a, Nat) -> Reg b a -> Reg (Sum b Cl_states) a;
nhole_mctxt_closure_reg f a =
  let {
    b = fmap_states_reg Inl (refin_fin_reg a);
  } in (if not (fun_sig f) then Reg bot_fset (TA bot_fset bot_fset)
         else gen_nhole_mctxt_closure_reg f b (Inr Cl_state) (Inr Tr_state)
                (Inr Fin_state));

nhole_mctxt_reflcl_reg ::
  forall a b.
    (Ceq a, Ccompare a, Eq a, Linorder a, Finite_UNIV b, Cenum b, Ceq b,
      Cproper_interval b, Compare b, Eq b, Linorder b,
      Set_impl b) => Fset (a, Nat) ->
                       Reg b a -> Reg (Sum (Sum b Cl_states) Cl_states) a;
nhole_mctxt_reflcl_reg f a =
  reg_union (nhole_mctxt_closure_reg f a)
    (Reg (finsert Fin_clstate bot_fset)
      (TA (ta_relfcl_rules f Fin_clstate) bot_fset));

gen_nhole_ctxt_closure_reg ::
  forall a b.
    (Ceq a, Ccompare a, Eq a, Linorder a, Ceq b, Ccompare b, Eq b, Linorder b,
      Set_impl b) => Fset (a, Nat) -> Reg b a -> b -> b -> b -> Reg b a;
gen_nhole_ctxt_closure_reg f a q_c q_i q_f =
  Reg (finsert q_f bot_fset)
    (TA (sup_fset (sup_fset (rules (ta a)) (ta_relfcl_rules f q_c))
          (semantic_path_rules f q_c q_i q_f))
      (sup_fset (eps (ta a)) (fimage (\ p -> (p, q_i)) (fin a))));

nhole_ctxt_closure_reg ::
  forall a b.
    (Ceq a, Ccompare a, Eq a, Linorder a, Finite_UNIV b, Cenum b, Ceq b,
      Cproper_interval b, Compare b, Eq b, Linorder b,
      Set_impl b) => Fset (a, Nat) -> Reg b a -> Reg (Sum b Cl_states) a;
nhole_ctxt_closure_reg f a =
  let {
    b = fmap_states_reg Inl (refin_fin_reg a);
  } in (if not (fun_sig f) then Reg bot_fset (TA bot_fset bot_fset)
         else gen_nhole_ctxt_closure_reg f b (Inr Cl_state) (Inr Tr_state)
                (Inr Fin_state));

gen_parallel_closure_automaton ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b,
      Ccompare b) => Fset a -> Fset (b, Nat) -> Ta a b -> a -> Ta a b;
gen_parallel_closure_automaton qaa f a qa =
  TA (sup_fset (rules a) (ta_relfcl_rules f qa))
    (sup_fset (eps a) (fimage (\ p -> (p, qa)) (inf_fset qaa (q a))));

parallel_closure_reg ::
  forall a b.
    (Ceq a, Ccompare a, Finite_UNIV b, Cenum b, Ceq b, Cproper_interval b, Eq b,
      Linorder b, Set_impl b) => Fset (a, Nat) -> Reg b a -> Reg (Maybe b) a;
parallel_closure_reg f a =
  let {
    b = fmap_states_reg Just a;
  } in Reg (finsert Nothing bot_fset)
         (gen_parallel_closure_automaton (fin b) f (ta b) Nothing);

gen_mctxt_closure_reg ::
  forall a b.
    (Ceq a, Ccompare a, Eq a, Linorder a, Ceq b, Ccompare b, Eq b, Linorder b,
      Set_impl b) => Fset (a, Nat) -> Reg b a -> b -> b -> Reg b a;
gen_mctxt_closure_reg f a q_c q_f =
  Reg (finsert q_f bot_fset)
    (TA (sup_fset (sup_fset (rules (ta a)) (ta_relfcl_rules f q_c))
          (semantic_path_rules f q_c q_f q_f))
      (sup_fset (sup_fset (eps (ta a)) (fimage (\ p -> (p, q_f)) (fin a)))
        (finsert (q_f, q_c) bot_fset)));

mctxt_closure_reg ::
  forall a b.
    (Ceq a, Ccompare a, Eq a, Linorder a, Finite_UNIV b, Cenum b, Ceq b,
      Cproper_interval b, Compare b, Eq b, Linorder b,
      Set_impl b) => Fset (a, Nat) -> Reg b a -> Reg (Sum b Bool) a;
mctxt_closure_reg f a =
  let {
    b = fmap_states_reg Inl (refin_fin_reg a);
  } in (if not (fun_sig f) then b
         else gen_mctxt_closure_reg f b (Inr False) (Inr True));

gen_ctxt_closure_reg ::
  forall a b.
    (Ceq a, Ccompare a, Eq a, Linorder a, Ceq b, Ccompare b, Eq b, Linorder b,
      Set_impl b) => Fset (a, Nat) -> Reg b a -> b -> b -> Reg b a;
gen_ctxt_closure_reg f a q_c q_f =
  Reg (finsert q_f bot_fset)
    (TA (sup_fset (sup_fset (rules (ta a)) (ta_relfcl_rules f q_c))
          (semantic_path_rules f q_c q_f q_f))
      (sup_fset (eps (ta a)) (fimage (\ p -> (p, q_f)) (fin a))));

ctxt_closure_reg ::
  forall a b.
    (Ceq a, Ccompare a, Eq a, Linorder a, Finite_UNIV b, Cenum b, Ceq b,
      Cproper_interval b, Compare b, Eq b, Linorder b,
      Set_impl b) => Fset (a, Nat) -> Reg b a -> Reg (Sum b Bool) a;
ctxt_closure_reg f a =
  let {
    b = fmap_states_reg Inl (refin_fin_reg a);
  } in (if not (fun_sig f) then b
         else gen_ctxt_closure_reg f b (Inr False) (Inr True));

gen_reflcl_automaton ::
  forall a b.
    (Ceq a, Ccompare a, Ceq b,
      Ccompare b) => Fset (a, Nat) -> Ta b a -> b -> Ta b a;
gen_reflcl_automaton f a q =
  TA (sup_fset (rules a) (ta_relfcl_rules f q)) (eps a);

reflcl_automaton ::
  forall a b.
    (Ceq a, Ccompare a, Ceq b, Ccompare b,
      Set_impl b) => Fset (a, Nat) -> Ta b a -> Ta (Maybe b) a;
reflcl_automaton f a = let {
                         b = fmap_states_ta Just a;
                       } in gen_reflcl_automaton f b Nothing;

reflcl_reg ::
  forall a b.
    (Ceq a, Ccompare a, Ceq b, Ccompare b,
      Set_impl b) => Fset (a, Nat) -> Reg b a -> Reg (Maybe b) a;
reflcl_reg f a =
  Reg (finsert Nothing (fimage Just (fin a))) (reflcl_automaton f (ta a));

rr2_compositon ::
  forall a b c.
    (Ceq a, Ccompare a, Eq a, Linorder a, Card_UNIV b, Cenum b, Ceq b,
      Cproper_interval b, Eq b, Linorder b, Set_impl b, Card_UNIV c, Cenum c,
      Ceq c, Cproper_interval c, Eq c, Linorder c,
      Set_impl c) => Fset (a, Nat) ->
                       Reg b (Maybe a, Maybe a) ->
                         Reg c (Maybe a, Maybe a) ->
                           Reg ((Maybe b, Maybe Nat), (Maybe Nat, Maybe c))
                             (Maybe a, Maybe a);
rr2_compositon f a b =
  let {
    aa = fmap_funs_reg (\ (fa, g) -> [fa, g]) a;
    ba = fmap_funs_reg (\ (fa, g) -> [fa, g]) b;
    fa = true_RRn f one_nat;
    ca = trim_reg
           (fmap_funs_reg
             (pad_with_Nones (nat_of_integer (2 :: Integer)) one_nat)
             (pair_automaton_reg aa fa));
    cb = trim_reg
           (fmap_funs_reg
             (pad_with_Nones one_nat (nat_of_integer (2 :: Integer)))
             (pair_automaton_reg fa ba));
    pi = trim_reg
           (fmap_funs_reg
             (\ xs ->
               map (nth xs) [one_nat, zero_nat, nat_of_integer (2 :: Integer)])
             (reg_intersect ca cb));
  } in fmap_funs_reg (\ fb -> (nth fb zero_nat, nth fb one_nat))
         (collapse_automaton_reg
           (fmap_funs_reg
             (\ fs ->
               (if all is_none (drop one_nat fs) then Nothing
                 else Just (drop one_nat fs)))
             pi));

gTT_to_RR2_root_reg ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Eq a, Linorder a,
      Set_impl a, Ceq b,
      Ccompare b) => (Ta a b, Ta a b) ->
                       Reg (Maybe a, Maybe a) (Maybe b, Maybe b);
gTT_to_RR2_root_reg g =
  Reg (fimage (map_prod Just Just) (fId_on (gtt_states g))) (gTT_to_RR2_root g);

eps_free_reg ::
  forall a b.
    (Card_UNIV a, Ceq a, Ccompare a, Eq a, Linorder a, Set_impl a, Ceq b,
      Ccompare b, Eq b, Linorder b) => Reg a b -> Reg a b;
eps_free_reg r = Reg (fin r) (eps_free (ta r));

rr1_of_rr1_rel ::
  forall a b.
    (Ceq a, Ccompare a, Compare a, Eq a, Linorder a, Set_impl a, Compare b,
      Eq b) => Fset (a, Nat) ->
                 [Fset (Term a b, Term a b)] ->
                   Rr1_rel Ftrs -> Maybe (Reg Nat a);
rr1_of_rr1_rel f rs R1Terms = Just (relabel_reg (term_reg f));
rr1_of_rr1_rel f rs (R1NF is) =
  liftO1 (\ r -> simplify_reg (nf_reg (fimage fst r) f)) (is_to_trs rs is);
rr1_of_rr1_rel f rs (R1Inf r) =
  liftO1 (\ ra -> let {
                    a = trim_reg ra;
                  } in simplify_reg (proj_1_reg (inf_reg_impl a)))
    (rr2_of_rr2_rel f rs r);
rr1_of_rr1_rel f rs (R1Proj i r) =
  (if equal_nat i zero_nat
    then liftO1 (trim_reg . proj_1_reg) (rr2_of_rr2_rel f rs r)
    else liftO1 (trim_reg . proj_2_reg) (rr2_of_rr2_rel f rs r));
rr1_of_rr1_rel f rs (R1Union s1 s2) =
  liftO2 (\ x y -> relabel_reg (reg_union x y)) (rr1_of_rr1_rel f rs s1)
    (rr1_of_rr1_rel f rs s2);
rr1_of_rr1_rel f rs (R1Inter s1 s2) =
  liftO2 (\ x y -> simplify_reg (reg_intersect x y)) (rr1_of_rr1_rel f rs s1)
    (rr1_of_rr1_rel f rs s2);
rr1_of_rr1_rel f rs (R1Diff s1 s2) =
  liftO2 (\ x y -> relabel_reg (trim_reg (difference_reg x y)))
    (rr1_of_rr1_rel f rs s1) (rr1_of_rr1_rel f rs s2);

rr2_of_rr2_rel ::
  forall a b.
    (Ceq a, Ccompare a, Compare a, Eq a, Linorder a, Set_impl a, Compare b,
      Eq b) => Fset (a, Nat) ->
                 [Fset (Term a b, Term a b)] ->
                   Rr2_rel Ftrs -> Maybe (Reg Nat (Maybe a, Maybe a));
rr2_of_rr2_rel f rs (R2GTT_Rel g w x) =
  (case w of {
    PRoot ->
      (case x of {
        ESingle ->
          liftO1 ((simplify_reg . eps_free_reg) . gTT_to_RR2_root_reg)
            (gtt_of_gtt_rel f rs g);
        EParallel ->
          liftO1
            (((simplify_reg . eps_free_reg) .
               reflcl_reg (fimage (\ (fa, a) -> ((Just fa, Just fa), a)) f)) .
              gTT_to_RR2_root_reg)
            (gtt_of_gtt_rel f rs g);
        EStrictParallel ->
          liftO1 ((simplify_reg . eps_free_reg) . gTT_to_RR2_root_reg)
            (gtt_of_gtt_rel f rs g);
      });
    PNonRoot ->
      (case x of {
        ESingle ->
          liftO1
            (((simplify_reg . eps_free_reg) .
               nhole_ctxt_closure_reg
                 (fimage (\ (fa, a) -> ((Just fa, Just fa), a)) f)) .
              gTT_to_RR2_root_reg)
            (gtt_of_gtt_rel f rs g);
        EParallel ->
          liftO1
            (((simplify_reg . eps_free_reg) .
               nhole_mctxt_reflcl_reg
                 (fimage (\ (fa, a) -> ((Just fa, Just fa), a)) f)) .
              gTT_to_RR2_root_reg)
            (gtt_of_gtt_rel f rs g);
        EStrictParallel ->
          liftO1
            (((simplify_reg . eps_free_reg) .
               nhole_mctxt_closure_reg
                 (fimage (\ (fa, a) -> ((Just fa, Just fa), a)) f)) .
              gTT_to_RR2_root_reg)
            (gtt_of_gtt_rel f rs g);
      });
    PAny ->
      (case x of {
        ESingle ->
          liftO1
            (((simplify_reg . eps_free_reg) .
               ctxt_closure_reg
                 (fimage (\ (fa, a) -> ((Just fa, Just fa), a)) f)) .
              gTT_to_RR2_root_reg)
            (gtt_of_gtt_rel f rs g);
        EParallel ->
          liftO1
            (((simplify_reg . eps_free_reg) .
               parallel_closure_reg
                 (fimage (\ (fa, a) -> ((Just fa, Just fa), a)) f)) .
              gTT_to_RR2_root_reg)
            (gtt_of_gtt_rel f rs g);
        EStrictParallel ->
          liftO1
            (((simplify_reg . eps_free_reg) .
               mctxt_closure_reg
                 (fimage (\ (fa, a) -> ((Just fa, Just fa), a)) f)) .
              gTT_to_RR2_root_reg)
            (gtt_of_gtt_rel f rs g);
      });
  });
rr2_of_rr2_rel f rs (R2Diag s) =
  liftO1 (fmap_funs_reg (\ fa -> (Just fa, Just fa))) (rr1_of_rr1_rel f rs s);
rr2_of_rr2_rel f rs (R2Prod s1 s2) =
  liftO2 (\ x y -> simplify_reg (pair_automaton_reg x y))
    (rr1_of_rr1_rel f rs s1) (rr1_of_rr1_rel f rs s2);
rr2_of_rr2_rel f rs (R2Inv r) =
  liftO1 (fmap_funs_reg swap) (rr2_of_rr2_rel f rs r);
rr2_of_rr2_rel f rs (R2Union r1 r2) =
  liftO2 (\ x y -> relabel_reg (reg_union x y)) (rr2_of_rr2_rel f rs r1)
    (rr2_of_rr2_rel f rs r2);
rr2_of_rr2_rel f rs (R2Inter r1 r2) =
  liftO2 (\ x y -> simplify_reg (reg_intersect x y)) (rr2_of_rr2_rel f rs r1)
    (rr2_of_rr2_rel f rs r2);
rr2_of_rr2_rel f rs (R2Diff r1 r2) =
  liftO2 (\ x y -> simplify_reg (difference_reg x y)) (rr2_of_rr2_rel f rs r1)
    (rr2_of_rr2_rel f rs r2);
rr2_of_rr2_rel f rs (R2Comp r1 r2) =
  liftO2 (\ x y -> simplify_reg (rr2_compositon f x y)) (rr2_of_rr2_rel f rs r1)
    (rr2_of_rr2_rel f rs r2);

nnf_to_list_aci :: forall a b. (Eq a, Eq b) => Form a b -> Form_list_aci a b;
nnf_to_list_aci FF = FF_aci;
nnf_to_list_aci TT = TT_aci;
nnf_to_list_aci (Pred b ts) = Pred_aci True b ts;
nnf_to_list_aci (Neg (Pred b ts)) = Pred_aci False b ts;
nnf_to_list_aci (And p q) =
  and_list_aci (nnf_to_list_aci p) (nnf_to_list_aci q);
nnf_to_list_aci (Or p q) = or_list_aci (nnf_to_list_aci p) (nnf_to_list_aci q);
nnf_to_list_aci (Forall p) = Forall_aci (nnf_to_list_aci p);
nnf_to_list_aci (Exists p) = Exists_aci (nnf_to_list_aci p);
nnf_to_list_aci (Impl v va) = error "undefined";
nnf_to_list_aci (Neg FF) = error "undefined";
nnf_to_list_aci (Neg TT) = error "undefined";
nnf_to_list_aci (Neg (And va vb)) = error "undefined";
nnf_to_list_aci (Neg (Or va vb)) = error "undefined";
nnf_to_list_aci (Neg (Impl va vb)) = error "undefined";
nnf_to_list_aci (Neg (Neg va)) = error "undefined";
nnf_to_list_aci (Neg (Forall va)) = error "undefined";
nnf_to_list_aci (Neg (Exists va)) = error "undefined";

map_gtt_rel :: forall a b. (a -> b) -> Gtt_rel a -> Gtt_rel b;
map_gtt_rel f (ARoot x1) = ARoot (map f x1);
map_gtt_rel f (GInv x2) = GInv (map_gtt_rel f x2);
map_gtt_rel f (AUnion x31 x32) = AUnion (map_gtt_rel f x31) (map_gtt_rel f x32);
map_gtt_rel f (ATrancl x4) = ATrancl (map_gtt_rel f x4);
map_gtt_rel f (GTrancl x5) = GTrancl (map_gtt_rel f x5);
map_gtt_rel f (AComp x61 x62) = AComp (map_gtt_rel f x61) (map_gtt_rel f x62);
map_gtt_rel f (GComp x71 x72) = GComp (map_gtt_rel f x71) (map_gtt_rel f x72);

map_rr2_rel :: forall a b. (a -> b) -> Rr2_rel a -> Rr2_rel b;
map_rr2_rel f (R2GTT_Rel x11 x12 x13) = R2GTT_Rel (map_gtt_rel f x11) x12 x13;
map_rr2_rel f (R2Diag x2) = R2Diag (map_rr1_rel f x2);
map_rr2_rel f (R2Prod x31 x32) = R2Prod (map_rr1_rel f x31) (map_rr1_rel f x32);
map_rr2_rel f (R2Inv x4) = R2Inv (map_rr2_rel f x4);
map_rr2_rel f (R2Union x51 x52) =
  R2Union (map_rr2_rel f x51) (map_rr2_rel f x52);
map_rr2_rel f (R2Inter x61 x62) =
  R2Inter (map_rr2_rel f x61) (map_rr2_rel f x62);
map_rr2_rel f (R2Diff x71 x72) = R2Diff (map_rr2_rel f x71) (map_rr2_rel f x72);
map_rr2_rel f (R2Comp x81 x82) = R2Comp (map_rr2_rel f x81) (map_rr2_rel f x82);

map_rr1_rel :: forall a b. (a -> b) -> Rr1_rel a -> Rr1_rel b;
map_rr1_rel f R1Terms = R1Terms;
map_rr1_rel f (R1NF x2) = R1NF (map f x2);
map_rr1_rel f (R1Inf x3) = R1Inf (map_rr2_rel f x3);
map_rr1_rel f (R1Proj x41 x42) = R1Proj x41 (map_rr2_rel f x42);
map_rr1_rel f (R1Union x51 x52) =
  R1Union (map_rr1_rel f x51) (map_rr1_rel f x52);
map_rr1_rel f (R1Inter x61 x62) =
  R1Inter (map_rr1_rel f x61) (map_rr1_rel f x62);
map_rr1_rel f (R1Diff x71 x72) = R1Diff (map_rr1_rel f x71) (map_rr1_rel f x72);

map_formula :: forall a b. (a -> b) -> Formula a -> Formula b;
map_formula f (FRR1 x11 x12) = FRR1 (map_rr1_rel f x11) x12;
map_formula f (FRR2 x21 x22 x23) = FRR2 (map_rr2_rel f x21) x22 x23;
map_formula f (FAnd x3) = FAnd (map (map_formula f) x3);
map_formula f (FOr x4) = FOr (map (map_formula f) x4);
map_formula f (FNot x5) = FNot (map_formula f x5);
map_formula f (FExists x6) = FExists (map_formula f x6);
map_formula f (FForall x7) = FForall (map_formula f x7);

fRestrict :: Formula Ftrs -> [Nat] -> Formula Ftrs;
fRestrict f trss =
  map_formula
    (map_ftrs
      (\ n ->
        (if less_eq_nat (size_list trss) n then zero_nat else nth trss n)))
    f;

r2ParStep :: forall a. [a] -> Rr2_rel a;
r2ParStep trss = R2GTT_Rel (ARoot trss) PAny EParallel;

r2StepsEq :: forall a. [a] -> Rr2_rel a;
r2StepsEq trss = R2GTT_Rel (gSteps trss) PAny EParallel;

r2StepsNF :: forall a. [a] -> Rr2_rel a;
r2StepsNF trss = R2Inter (r2StepsEq trss) (R2Prod R1Terms (R1NF trss));

ord_form_list_aci ::
  forall a b.
    (Eq a, Linorder a, Eq b,
      Linorder b) => Form_list_aci a b -> Form_list_aci a b;
ord_form_list_aci TT_aci = TT_aci;
ord_form_list_aci FF_aci = FF_aci;
ord_form_list_aci (Pred_aci bool b ts) = Pred_aci bool b ts;
ord_form_list_aci (And_aci fm) =
  And_aci (sort_key (\ x -> x) (map ord_form_list_aci fm));
ord_form_list_aci (Or_aci fm) =
  Or_aci (sort_key (\ x -> x) (map ord_form_list_aci fm));
ord_form_list_aci (Forall_aci fm) = Forall_aci (ord_form_list_aci fm);
ord_form_list_aci (Exists_aci fm) = Exists_aci (ord_form_list_aci fm);

form_of_formula :: forall a. Formula a -> Form () (Sum (Rr1_rel a) (Rr2_rel a));
form_of_formula (FRR1 r1 x) = Pred (Inl r1) [Vara x];
form_of_formula (FRR2 r2 x y) = Pred (Inr r2) [Vara x, Vara y];
form_of_formula (FAnd fs) = foldr (And . form_of_formula) fs TT;
form_of_formula (FOr fs) = foldr (Or . form_of_formula) fs FF;
form_of_formula (FNot f) = Neg (form_of_formula f);
form_of_formula (FExists f) =
  Exists (And (Pred (Inl R1Terms) [Vara zero_nat]) (form_of_formula f));
form_of_formula (FForall f) =
  Forall (Impl (Pred (Inl R1Terms) [Vara zero_nat]) (form_of_formula f));

check_inference ::
  forall a b.
    (Ceq a, Ccompare a, Compare a, Eq a, Linorder a, Set_impl a, Compare b,
      Eq b) => Fset (a, Nat) ->
                 [Fset (Term a b, Term a b)] ->
                   [(Formula Ftrs, ([Nat], Reg Nat [Maybe a]))] ->
                     (Nat, (Inference Ftrs, (Formula Ftrs, [Info]))) ->
                       Maybe (Formula Ftrs, ([Nat], Reg Nat [Maybe a]));
check_inference f rs infs (l, (step, (fm, is))) =
  bind (guard (equal_nat l (size_list infs)))
    (\ _ ->
      (case step of {
        IRR1 s x ->
          bind (guard (equal_formula fm (FRR1 s x)))
            (\ _ ->
              liftO1
                (\ ta ->
                  (FRR1 s x, ([x], fmap_funs_reg (\ fa -> [Just fa]) ta)))
                (rr1_of_rr1_rel f rs s));
        IRR2 r x y ->
          bind (guard (equal_formula fm (FRR2 r x y)))
            (\ _ ->
              (case compare_nat x y of {
                Eqa ->
                  liftO1
                    (\ ta ->
                      (FRR2 r x y, ([x], fmap_funs_reg (\ fa -> [Just fa]) ta)))
                    (liftO1 (simplify_reg . proj_1_reg)
                      (liftO2 (\ t1 t2 -> simplify_reg (reg_intersect t1 t2))
                        (rr2_of_rr2_rel f rs r)
                        (rr2_of_rr2_rel f rs (R2Diag R1Terms))));
                Lt -> liftO1
                        (\ ta ->
                          (FRR2 r x y,
                            ([x, y], fmap_funs_reg (\ (fa, g) -> [fa, g]) ta)))
                        (rr2_of_rr2_rel f rs r);
                Gt -> liftO1
                        (\ ta ->
                          (FRR2 r x y,
                            ([y, x], fmap_funs_reg (\ (fa, g) -> [g, fa]) ta)))
                        (rr2_of_rr2_rel f rs r);
              }));
        IAnd ls ->
          bind (guard (all (\ la -> less_nat la l) ls))
            (\ _ ->
              bind (guard
                     (equal_formula fm
                       (FAnd (map (\ la -> fst (nth infs la)) ls))))
                (\ _ ->
                  (case fit_rrns f (map (nth infs) ls) of {
                    (vs, tas) -> Just (fm, (vs, fand_rrn f (size_list vs) tas));
                  })));
        IOr ls ->
          bind (guard (all (\ la -> less_nat la l) ls))
            (\ _ ->
              bind (guard
                     (equal_formula fm
                       (FOr (map (\ la -> fst (nth infs la)) ls))))
                (\ _ -> (case fit_rrns f (map (nth infs) ls) of {
                          (vs, tas) -> Just (fm, (vs, for_rrn tas));
                        })));
        INot la ->
          bind (guard (less_nat la l))
            (\ _ ->
              bind (guard (equal_formula fm (FNot (fst (nth infs la)))))
                (\ _ ->
                  (case snd (nth infs la) of {
                    (vs, tas) ->
                      Just (fm, (vs, simplify_reg
                                       (difference_reg
 (true_RRn f (size_list vs)) tas)));
                  })));
        IExists la ->
          bind (guard (less_nat la l))
            (\ _ ->
              bind (guard (equal_formula fm (FExists (fst (nth infs la)))))
                (\ _ ->
                  (case snd (nth infs la) of {
                    (vs, tas) ->
                      (if equal_nat (size_list vs) zero_nat
                        then Just (fm, ([], tas))
                        else (if reg_empty tas
                               then Just (fm,
   ([], Reg bot_fset (TA bot_fset bot_fset)))
                               else (if not (membera vs zero_nat)
                                      then Just
     (fm, (map (\ x -> minus_nat x one_nat) vs, tas))
                                      else (if equal_nat one_nat (size_list vs)
     then Just (fm, ([], true_RRn f zero_nat))
     else Just (fm, (upd_bruijn vs, rrn_drop_fst tas))))));
                  })));
        IRename la _ -> bind (guard (less_nat la l)) (\ _ -> Nothing);
        INNFPlus la ->
          bind (guard (less_nat la l))
            (\ _ ->
              let {
                fma = fst (nth infs la);
              } in bind (guard
                          (equal_form_list_aci
                            (ord_form_list_aci
                              (nnf_to_list_aci
                                (nnf True (form_of_formula fma))))
                            (ord_form_list_aci
                              (nnf_to_list_aci
                                (nnf True (form_of_formula fm))))))
                     (\ _ -> Just (fm, snd (nth infs la))));
        IRepl _ _ la -> bind (guard (less_nat la l)) (\ _ -> Nothing);
      }));

check_trss ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Compare a, Eq a,
      Set_impl a, Card_UNIV b, Cenum b, Ceq b, Cproper_interval b, Compare b,
      Eq b, Set_impl b) => [Fset (Term a b, Term a b)] -> Fset (a, Nat) -> Bool;
check_trss r f =
  all (\ ra -> lv_trs (fset ra) && less_eq_set (funas_trs (fset ra)) (fset f))
    r;

r2RootStep :: forall a. [a] -> Rr2_rel a;
r2RootStep trss = R2GTT_Rel (ARoot trss) PRoot ESingle;

r2RootSteps :: forall a. [a] -> Rr2_rel a;
r2RootSteps trss = R2GTT_Rel (ATrancl (ARoot trss)) PRoot ESingle;

r2RootStepEq :: forall a. [a] -> Rr2_rel a;
r2RootStepEq trss = r2Reflc (r2RootStep trss);

r2NonRootStep :: forall a. [a] -> Rr2_rel a;
r2NonRootStep trss = R2GTT_Rel (ARoot trss) PNonRoot ESingle;

r2RootStepsEq :: forall a. [a] -> Rr2_rel a;
r2RootStepsEq trss = r2Reflc (r2RootSteps trss);

r2NonRootSteps :: forall a. [a] -> Rr2_rel a;
r2NonRootSteps trss = R2GTT_Rel (gSteps trss) PNonRoot EStrictParallel;

r2NonRootStepEq :: forall a. [a] -> Rr2_rel a;
r2NonRootStepEq trss = r2Reflc (r2NonRootStep trss);

check_sig_nempty ::
  forall a b.
    (Ceq a, Ccompare a, Ceq b, Ccompare b, Zero b,
      Set_impl b) => Fset (a, b) -> Bool;
check_sig_nempty f = fmember zero (fimage snd f);

r2NonRootStepsEq :: forall a. [a] -> Rr2_rel a;
r2NonRootStepsEq trss = R2GTT_Rel (gSteps trss) PNonRoot EParallel;

equal_claim :: Claim -> Claim -> Bool;
equal_claim Emptya Nonempty = False;
equal_claim Nonempty Emptya = False;
equal_claim Nonempty Nonempty = True;
equal_claim Emptya Emptya = True;

check_inference_list ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Compare a, Eq a,
      Linorder a, Set_impl a, Card_UNIV b, Cenum b, Ceq b, Cproper_interval b,
      Compare b, Eq b,
      Set_impl b) => Fset (a, Nat) ->
                       [Fset (Term a b, Term a b)] ->
                         [(Nat, (Inference Ftrs, (Formula Ftrs, [Info])))] ->
                           Maybe [(Formula Ftrs, ([Nat], Reg Nat [Maybe a]))];
check_inference_list f rs infs =
  bind (guard (check_sig_nempty f))
    (\ _ ->
      bind (guard (check_trss rs f))
        (\ _ ->
          foldl (\ tas inf ->
                  bind tas
                    (\ tasa ->
                      bind (check_inference f rs tasa inf)
                        (\ r -> Just (tasa ++ [r]))))
            (Just []) infs));

check_certificate ::
  forall a b.
    (Finite_UNIV a, Cenum a, Ceq a, Cproper_interval a, Compare a, Eq a,
      Linorder a, Set_impl a, Card_UNIV b, Cenum b, Ceq b, Cproper_interval b,
      Compare b, Eq b,
      Set_impl b) => Fset (a, Nat) ->
                       [Fset (Term a b, Term a b)] ->
                         Bool -> Formula Ftrs -> Certificate Ftrs -> Maybe Bool;
check_certificate f rs a fm (Certificate infs claim n) =
  bind (guard (less_nat n (size_list infs)))
    (\ _ ->
      bind (guard (a == equal_claim claim Nonempty))
        (\ _ ->
          bind (guard (equal_formula fm (fst (snd (snd (nth infs n))))))
            (\ _ ->
              bind (check_inference_list f rs (take (suc n) infs))
                (\ fvA -> let {
                            e = reg_empty (snd (snd (last fvA)));
                          } in (case claim of {
                                 Emptya -> Just e;
                                 Nonempty -> Just (not e);
                               })))));

check_certificate_string ::
  Fset ([Integer], Nat) ->
    [Fset (Term [Integer] [Integer], Term [Integer] [Integer])] ->
      Bool -> Formula Ftrs -> Certificate Ftrs -> Maybe Bool;
check_certificate_string = check_certificate;

}
